


{  }
{                                                  }
{   Virtual Pascal Runtime Library.  Version 2.1   }
{   WinShell unit 3.00 - Object-oriented version   }
{     Ole32.dll, OleAut32.dll & Shell32.dll API    }
{       2008.05.15 by Alcatiz - www.lpjjl.net      }
{   --------------------------------------------   }
{        Copyright (C) 1999-2008 vpascal.com       }
{                                                  }
{  }

Unit WinShell;

(* ========================================================================================================================= *)
                                                            Interface
(* ========================================================================================================================= *)

Uses Windows, CommCtrl, ShellAPI;

Const INTERNET_MAX_URL_LENGTH = 2056;

      (* Ole2 constants *)

      MEMCTX_TASK                             = 1;
      MEMCTX_SHARED                           = 2;
      MEMCTX_MACSYSTEM                        = 3;
      MEMCTX_UNKNOWN                          = -1;
      MEMCTX_SAME                             = -2;

      ROTFLAGS_REGISTRATIONKEEPSALIVE         = 1;

      CLSCTX_INPROC_SERVER                    = 1;
      CLSCTX_INPROC_HANDLER                   = 2;
      CLSCTX_LOCAL_SERVER                     = 4;
      CLSCTX_INPROC_SERVER16                  = 8;

      CLSCTX_ALL                              = CLSCTX_INPROC_SERVER or CLSCTX_INPROC_HANDLER or CLSCTX_LOCAL_SERVER;
      CLSCTX_INPROC                           = CLSCTX_INPROC_SERVER or CLSCTX_INPROC_HANDLER;
      CLSCTX_SERVER                           = CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER;

      MSHLFLAGS_NORMAL                        = 0;
      MSHLFLAGS_TABLESTRONG                   = 1;
      MSHLFLAGS_TABLEWEAK                     = 2;

      MSHCTX_LOCAL                            = 0;
      MSHCTX_NOSHAREDMEM                      = 1;
      MSHCTX_DIFFERENTMACHINE                 = 2;
      MSHCTX_INPROC                           = 3;

      DVASPECT_CONTENT                        = 1;
      DVASPECT_THUMBNAIL                      = 2;
      DVASPECT_ICON                           = 4;
      DVASPECT_DOCPRINT                       = 8;

      STGC_DEFAULT                            = 0;
      STGC_OVERWRITE                          = 1;
      STGC_ONLYIFCURRENT                      = 2;
      STGC_DANGEROUSLYCOMMITMERELYTODISKCACHE = 4;

      STGMOVE_MOVE                            = 0;
      STGMOVE_COPY                            = 1;

      STATFLAG_DEFAULT                        = 0;
      STATFLAG_NONAME                         = 1;

      BIND_MAYBOTHERUSER                      = 1;
      BIND_JUSTTESTEXISTENCE                  = 2;

      MKSYS_NONE                              = 0;
      MKSYS_GENERICCOMPOSITE                  = 1;
      MKSYS_FILEMONIKER                       = 2;
      MKSYS_ANTIMONIKER                       = 3;
      MKSYS_ITEMMONIKER                       = 4;
      MKSYS_POINTERMONIKER                    = 5;

      MKRREDUCE_ONE                           = 3 shl 16;
      MKRREDUCE_TOUSER                        = 2 shl 16;
      MKRREDUCE_THROUGHUSER                   = 1 shl 16;
      MKRREDUCE_ALL                           = 0;

      STGTY_STORAGE                           = 1;
      STGTY_STREAM                            = 2;
      STGTY_LOCKBYTES                         = 3;
      STGTY_PROPERTY                          = 4;

      STREAM_SEEK_SET                         = 0;
      STREAM_SEEK_CUR                         = 1;
      STREAM_SEEK_END                         = 2;

      LOCK_WRITE                              = 1;
      LOCK_EXCLUSIVE                          = 2;
      LOCK_ONLYONCE                           = 4;

      ADVF_NODATA                             = 1;
      ADVF_PRIMEFIRST                         = 2;
      ADVF_ONLYONCE                           = 4;
      ADVF_DATAONSTOP                         = 64;
      ADVFCACHE_NOHANDLER                     = 8;
      ADVFCACHE_FORCEBUILTIN                  = 16;
      ADVFCACHE_ONSAVE                        = 32;

      TYMED_HGLOBAL                           = 1;
      TYMED_FILE                              = 2;
      TYMED_ISTREAM                           = 4;
      TYMED_ISTORAGE                          = 8;
      TYMED_GDI                               = 16;
      TYMED_MFPICT                            = 32;
      TYMED_ENHMF                             = 64;
      TYMED_NULL                              = 0;

      DATADIR_GET                             = 1;
      DATADIR_SET                             = 2;

      CALLTYPE_TOPLEVEL                       = 1;
      CALLTYPE_NESTED                         = 2;
      CALLTYPE_ASYNC                          = 3;
      CALLTYPE_TOPLEVEL_CALLPENDING           = 4;
      CALLTYPE_ASYNC_CALLPENDING              = 5;

      SERVERCALL_ISHANDLED                    = 0;
      SERVERCALL_REJECTED                     = 1;
      SERVERCALL_RETRYLATER                   = 2;

      PENDINGTYPE_TOPLEVEL                    = 1;
      PENDINGTYPE_NESTED                      = 2;

      PENDINGMSG_CANCELCALL                   = 0;
      PENDINGMSG_WAITNOPROCESS                = 1;
      PENDINGMSG_WAITDEFPROCESS               = 2;

      REGCLS_SINGLEUSE                        = 0;
      REGCLS_MULTIPLEUSE                      = 1;
      REGCLS_MULTI_SEPARATE                   = 2;

      MARSHALINTERFACE_MIN                    = 500;

      CWCSTORAGENAME                          = 32;

      STGM_DIRECT                             = $00000000;
      STGM_TRANSACTED                         = $00010000;
      STGM_SIMPLE                             = $08000000;
      STGM_READ                               = $00000000;
      STGM_WRITE                              = $00000001;
      STGM_READWRITE                          = $00000002;
      STGM_SHARE_DENY_NONE                    = $00000040;
      STGM_SHARE_DENY_READ                    = $00000030;
      STGM_SHARE_DENY_WRITE                   = $00000020;
      STGM_SHARE_EXCLUSIVE                    = $00000010;
      STGM_PRIORITY                           = $00040000;
      STGM_DELETEONRELEASE                    = $04000000;
      STGM_CREATE                             = $00001000;
      STGM_CONVERT                            = $00020000;
      STGM_FAILIFTHERE                        = $00000000;

      FADF_AUTO                               = $0001;  (* Array is allocated on the stack *)
      FADF_STATIC                             = $0002;  (* Array is staticly allocated *)
      FADF_EMBEDDED                           = $0004;  (* Array is embedded in a structure *)
      FADF_FIXEDSIZE                          = $0010;  (* Array may not be resized or reallocated *)
      FADF_BSTR                               = $0100;  (* an Array of BSTRs *)
      FADF_UNKNOWN                            = $0200;  (* an Array of IUnknown *)
      FADF_DISPATCH                           = $0400;  (* an Array of IDispatch *)
      FADF_VARIANT                            = $0800;  (* an Array of VARIANTs *)
      FADF_Reserved                           = $F0E8;  (* bits Reserved for future use *)

                                                      (* [V] - may appear in a VARIANT
                                                         [T] - may appear in a TYPEDESC
                                                         [P] - may appear in an OLE property set
                                                         [S] - may appear in a Safe Array *)

      VT_EMPTY                              = 0;      (* [V]   [P]  nothing                     *)
      VT_NULL                               = 1;      (* [V]        SQL style Null              *)
      VT_I2                                 = 2;      (* [V][T][P]  2 byte signed int           *)
      VT_I4                                 = 3;      (* [V][T][P]  4 byte signed int           *)
      VT_R4                                 = 4;      (* [V][T][P]  4 byte real                 *)
      VT_R8                                 = 5;      (* [V][T][P]  8 byte real                 *)
      VT_CY                                 = 6;      (* [V][T][P]  currency                    *)
      VT_DATE                               = 7;      (* [V][T][P]  date                        *)
      VT_BSTR                               = 8;      (* [V][T][P]  binary string               *)
      VT_DISPATCH                           = 9;      (* [V][T]     IDispatch FAR*              *)
      VT_ERROR                              = 10;     (* [V][T]     SCODE                       *)
      VT_BOOL                               = 11;     (* [V][T][P]  True=-1, False=0            *)
      VT_VARIANT                            = 12;     (* [V][T][P]  VARIANT FAR*                *)
      VT_UNKNOWN                            = 13;     (* [V][T]     IUnknown FAR*               *)
      VT_I1                                 = 16;     (*    [T]     signed char                 *)
      VT_UI1                                = 17;     (*    [T]     unsigned char               *)
      VT_UI2                                = 18;     (*    [T]     unsigned short              *)
      VT_UI4                                = 19;     (*    [T]     unsigned short              *)
      VT_I8                                 = 20;     (*    [T][P]  signed 64-bit int           *)
      VT_UI8                                = 21;     (*    [T]     unsigned 64-bit int         *)
      VT_INT                                = 22;     (*    [T]     signed machine int          *)
      VT_UINT                               = 23;     (*    [T]     unsigned machine int        *)
      VT_VOID                               = 24;     (*    [T]     C style void                *)
      VT_hResult                            = 25;     (*    [T]                                 *)
      VT_PTR                                = 26;     (*    [T]     pointer type                *)
      VT_SAFEArray                          = 27;     (*    [T]     (use VT_Array in VARIANT)   *)
      VT_CArray                             = 28;     (*    [T]     C style Array               *)
      VT_USERDEFINED                        = 29;     (*    [T]     user defined type          *)
      VT_LPSTR                              = 30;     (*    [T][P]  null terminated string      *)
      VT_LPWSTR                             = 31;     (*    [T][P]  wide null terminated string *)
      VT_FILETIME                           = 64;     (*       [P]  FILETIME                    *)
      VT_BLOB                               = 65;     (*       [P]  Length prefixed bytes       *)
      VT_STREAM                             = 66;     (*       [P]  Name of the stream follows  *)
      VT_STORAGE                            = 67;     (*       [P]  Name of the storage follows *)
      VT_STREAMED_OBJECT                    = 68;     (*       [P]  Stream contains an object   *)
      VT_STORED_OBJECT                      = 69;     (*       [P]  Storage contains an object  *)
      VT_BLOB_OBJECT                        = 70;     (*       [P]  Blob contains an object     *)
      VT_CF                                 = 71;     (*       [P]  Clipboard format            *)
      VT_CLSID                              = 72;     (*       [P]  A Class ID                  *)
      VT_VECTOR                             = $1000;  (*       [P]  simple counted Array        *)
      VT_Array                              = $2000;  (* [V]        SAFEArray*                  *)
      VT_BYREF                              = $4000;  (* [V]                                    *)
      VT_Reserved                           = $8000;

      TKIND_ENUM                            = 0;
      TKIND_Record                          = 1;
      TKIND_MODULE                          = 2;
      TKIND_INTERFACE                       = 3;
      TKIND_DISPATCH                        = 4;
      TKIND_COCLASS                         = 5;
      TKIND_ALIAS                           = 6;
      TKIND_UNION                           = 7;
      TKIND_MAX                             = 8;

      CC_CDECL                              = 1;
      CC_PASCAL                             = 2;
      CC_MACPASCAL                          = 3;
      CC_STDCALL                            = 4;
      CC_Reserved                           = 5;
      CC_SYSCALL                            = 6;
      CC_MPWCDECL                           = 7;
      CC_MPWPASCAL                          = 8;
      CC_MAX                                = 9;

      FUNC_VIRTUAL                          = 0;
      FUNC_PUREVIRTUAL                      = 1;
      FUNC_NONVIRTUAL                       = 2;
      FUNC_STATIC                           = 3;
      FUNC_DISPATCH                         = 4;

      INVOKE_FUNC                           = 1;
      INVOKE_PROPERTYGET                    = 2;
      INVOKE_PROPERTYPUT                    = 4;
      INVOKE_PROPERTYPUTREF                 = 8;

      VAR_PERINSTANCE                       = 0;
      VAR_STATIC                            = 1;
      VAR_CONST                             = 2;
      VAR_DISPATCH                          = 3;

      IMPLTYPEFLAG_FDEFAULT                 = 1;
      IMPLTYPEFLAG_FSOURCE                  = 2;
      IMPLTYPEFLAG_FRESTRICTED              = 4;

      TYPEFLAG_FAPPOBJECT                   = $0001;
      TYPEFLAG_FCANCREATE                   = $0002;
      TYPEFLAG_FLICENSED                    = $0004;
      TYPEFLAG_FPREDECLID                   = $0008;
      TYPEFLAG_FHIDDEN                      = $0010;
      TYPEFLAG_FCONTROL                     = $0020;
      TYPEFLAG_FDUAL                        = $0040;
      TYPEFLAG_FNONEXTENSIBLE               = $0080;
      TYPEFLAG_FOLEAUTOMATION               = $0100;

      FUNCFLAG_FRESTRICTED                  = $0001;
      FUNCFLAG_FSOURCE                      = $0002;
      FUNCFLAG_FBINDABLE                    = $0004;
      FUNCFLAG_FREQUESTEDIT                 = $0008;
      FUNCFLAG_FDISPLAYBIND                 = $0010;
      FUNCFLAG_FDEFAULTBIND                 = $0020;
      FUNCFLAG_FHIDDEN                      = $0040;

      VARFLAG_FREADONLY                     = $0001;
      VARFLAG_FSOURCE                       = $0002;
      VARFLAG_FBINDABLE                     = $0004;
      VARFLAG_FREQUESTEDIT                  = $0008;
      VARFLAG_FDISPLAYBIND                  = $0010;
      VARFLAG_FDEFAULTBIND                  = $0020;
      VARFLAG_FHIDDEN                       = $0040;

      DISPID_VALUE                          = 0;
      DISPID_UNKNOWN                        = -1;
      DISPID_PROPERTYPUT                    = -3;
      DISPID_NEWENUM                        = -4;
      DISPID_EVALUATE                       = -5;
      DISPID_CONSTRUCTOR                    = -6;
      DISPID_DESTRUCTOR                     = -7;
      DISPID_COLLECT                        = -8;

      DESCKIND_NONE                         = 0;
      DESCKIND_FUNCDESC                     = 1;
      DESCKIND_VARDESC                      = 2;
      DESCKIND_TYPECOMP                     = 3;
      DESCKIND_IMPLICITAPPOBJ               = 4;
      DESCKIND_MAX                          = 5;

      SYS_WIN16                             = 0;
      SYS_WIN32                             = 1;
      SYS_MAC                               = 2;

      LIBFLAG_FRESTRICTED                   = 1;
      LIBFLAG_FCONTROL                      = 2;
      LIBFLAG_FHIDDEN                       = 4;

      STDOLE_MAJORVERNUM                    = 1;
      STDOLE_MINORVERNUM                    = 0;
      STDOLE_LCID                           = 0;

      VARIANT_NOVALUEPROP                   = 1;

      VAR_TIMEVALUEONLY                     = 1;
      VAR_DATEVALUEONLY                     = 2;

      MEMBERID_NIL                          = DISPID_UNKNOWN;

      ID_DEFAULTINST                        = -2;

      IDLFLAG_NONE                          = 0;
      IDLFLAG_FIN                           = 1;
      IDLFLAG_FOUT                          = 2;
      IDLFLAG_FLCID                         = 4;
      IDLFLAG_FRETVAL                       = 8;

      DISPATCH_METHOD                       = 1;
      DISPATCH_PROPERTYGET                  = 2;
      DISPATCH_PROPERTYPUT                  = 4;
      DISPATCH_PROPERTYPUTREF               = 8;

      OLEIVERB_PRIMARY                      = 0;
      OLEIVERB_SHOW                         = -1;
      OLEIVERB_OPEN                         = -2;
      OLEIVERB_HIDE                         = -3;
      OLEIVERB_UIACTIVATE                   = -4;
      OLEIVERB_INPLACEACTIVATE              = -5;
      OLEIVERB_DISCARDUNDOSTATE             = -6;

      EMBDHLP_INPROC_HANDLER                = $00000000;
      EMBDHLP_INPROC_SERVER                 = $00000001;
      EMBDHLP_CREATENOW                     = $00000000;
      EMBDHLP_DELAYCREATE                   = $00010000;

      UPDFCACHE_NODATACACHE                 = 1;
      UPDFCACHE_ONSAVECACHE                 = 2;
      UPDFCACHE_ONSTOPCACHE                 = 4;
      UPDFCACHE_NORMALCACHE                 = 8;
      UPDFCACHE_IFBLANK                     = $10;
      UPDFCACHE_ONLYIFBLANK                 = $80000000;
      UPDFCACHE_IFBLANKORONSAVECACHE        = UPDFCACHE_IFBLANK or UPDFCACHE_ONSAVECACHE;
      UPDFCACHE_ALL                         = not UPDFCACHE_ONLYIFBLANK;
      UPDFCACHE_ALLBUTNODATACACHE           = UPDFCACHE_ALL and not UPDFCACHE_NODATACACHE;

      DISCARDCACHE_SAVEIFDIRTY              = 0;
      DISCARDCACHE_NOSAVE                   = 1;

      OLEGETMONIKER_ONLYIFTHERE             = 1;
      OLEGETMONIKER_FORCEASSIGN             = 2;
      OLEGETMONIKER_UNASSIGN                = 3;
      OLEGETMONIKER_TEMPFORUSER             = 4;

      OLEWHICHMK_CONTAINER                  = 1;
      OLEWHICHMK_OBJREL                     = 2;
      OLEWHICHMK_OBJFULL                    = 3;

      USERCLASSTYPE_FULL                    = 1;
      USERCLASSTYPE_SHORT                   = 2;
      USERCLASSTYPE_APPNAME                 = 3;

      OLEMISC_RECOMPOSEONRESIZE             = 1;
      OLEMISC_ONLYICONIC                    = 2;
      OLEMISC_INSERTNOTREPLACE              = 4;
      OLEMISC_STATIC                        = 8;
      OLEMISC_CANTLINKINSIDE                = 16;
      OLEMISC_CANLINKBYOLE1                 = 32;
      OLEMISC_ISLINKOBJECT                  = 64;
      OLEMISC_INSIDEOUT                     = 128;
      OLEMISC_ACTIVATEWHENVISIBLE           = 256;
      OLEMISC_RENDERINGISDEVICEINDEPENDENT  = 512;

      OLECLOSE_SAVEIFDIRTY                  = 0;
      OLECLOSE_NOSAVE                       = 1;
      OLECLOSE_PROMPTSAVE                   = 2;

      OLERENDER_NONE                        = 0;
      OLERENDER_DRAW                        = 1;
      OLERENDER_FORMAT                      = 2;
      OLERENDER_ASIS                        = 3;

      OLEUPDATE_ALWAYS                      = 1;
      OLEUPDATE_ONCALL                      = 3;

      OLELINKBIND_EVENIFCLASSDIFF           = 1;

      BINDSPEED_INDEFINITE                  = 1;
      BINDSPEED_MODERATE                    = 2;
      BINDSPEED_IMMEDIATE                   = 3;

      OLECONTF_EMBEDDINGS                   = 1;
      OLECONTF_LINKS                        = 2;
      OLECONTF_OTHERS                       = 4;
      OLECONTF_ONLYUSER                     = 8;
      OLECONTF_ONLYIFRUNNING                = 16;

      DROPEFFECT_NONE                       = 0;
      DROPEFFECT_COPY                       = 1;
      DROPEFFECT_MOVE                       = 2;
      DROPEFFECT_LINK                       = 4;
      DROPEFFECT_SCROLL                     = $80000000;

      DD_DEFSCROLLINSET                     = 11;
      DD_DEFSCROLLDELAY                     = 50;
      DD_DEFSCROLLINTERVAL                  = 50;
      DD_DEFDRAGDELAY                       = 200;
      DD_DEFDRAGMINDIST                     = 2;

      OLEVERBATTRIB_NEVERDIRTIES            = 1;
      OLEVERBATTRIB_ONCONTAINERMENU         = 2;

      (* QueryContextMenu uFlags *)

      CMF_NORMAL           = $00000000;
      CMF_DEFAULTONLY      = $00000001;
      CMF_VERBSONLY        = $00000002;
      CMF_EXPLORE          = $00000004;
      CMF_NOVERBS          = $00000008;
      CMF_CANRENAME        = $00000010;
      CMF_NODEFAULT        = $00000020;
      CMF_INCLUDESTATIC    = $00000040;
      CMF_RESERVED         = $FFFF0000;

      (* GetCommandString uFlags *)

      GCS_VERBA            = $00000000;
      GCS_HELPTEXTA        = $00000001;
      GCS_VALIDATEA        = $00000002;
      GCS_VERBW            = $00000004;
      GCS_HELPTEXTW        = $00000005;
      GCS_VALIDATEW        = $00000006;
      GCS_UNICODE          = $00000004;
      GCS_VERB             = GCS_VERBA;
      GCS_HELPTEXT         = GCS_HELPTEXTA;
      GCS_VALIDATE         = GCS_VALIDATEA;

      CMDSTR_NEWFOLDERA    = 'NewFolder';
      CMDSTR_VIEWLISTA     = 'ViewList';
      CMDSTR_VIEWDETAILSA  = 'ViewDetails';
      CMDSTR_NEWFOLDERW    = 'NewFolder';
      CMDSTR_VIEWLISTW     = 'ViewList';
      CMDSTR_VIEWDETAILSW  = 'ViewDetails';
      CMDSTR_NEWFOLDER     = CMDSTR_NEWFOLDERA;
      CMDSTR_VIEWLIST      = CMDSTR_VIEWLISTA;
      CMDSTR_VIEWDETAILS   = CMDSTR_VIEWDETAILSA;

      CMIC_MASK_ICON       = $00000010;
      CMIC_MASK_HOTKEY     = $00000020;
      CMIC_MASK_FLAG_NO_UI = $00000400;
      CMIC_MASK_NO_CONSOLE = $00008000;
      CMIC_MASK_UNICODE    = $00010000;
      CMIC_MASK_ASYNCOK    = $00100000;
      CMIC_MASK_PTINVOKE   = $20000000;

      (* GetIconLocation flags *)

      GIL_OPENICON         = $0001;
      GIL_FORSHELL         = $0002;
      GIL_ASYNC            = $0020;
      GIL_SIMULATEDOC      = $0001;
      GIL_PERINSTANCE      = $0002;
      GIL_PERCLASS         = $0004;
      GIL_NOTFILENAME      = $0008;
      GIL_DONTCACHE        = $0010;

      (* IShellIconOverlay constants *)

      ISIOI_ICONFILE          = $00000001;
      ISIOI_ICONINDEX         = $00000002;
      ISIOI_SYSIMAGELISTINDEX = $00000004;

      (* IShellLink flags *)

      SLR_NO_UI               = $0001;
      SLR_ANY_MATCH           = $0002;
      SLR_UPDATE              = $0004;
      SLR_NOUPDATE            = $0008;

      SLGP_SHORTPATH          = $0001;
      SLGP_UNCPRIORITY        = $0002;
      SLGP_RAWPATH            = $0004;

      (* IFileViewer constants *)

      FVSIF_RECT              = $00000001;
      FVSIF_PINNED            = $00000002;
      FVSIF_NEWFAILED         = $08000000;
      FVSIF_NEWFILE           = $80000000;
      FVSIF_CANVIEWIT         = $40000000;

      (* CommandTarget ID's *)

      FCIDM_SHVIEWFIRST           = $0000;
      FCIDM_SHVIEWLAST            = $7FFF;
      FCIDM_BROWSERFIRST          = $A000;
      FCIDM_BROWSERLAST           = $BF00;
      FCIDM_GLOBALFIRST           = $8000;
      FCIDM_GLOBALLAST            = $9FFF;
      FCIDM_MENU_FILE             = FCIDM_GLOBALFIRST + $0000;
      FCIDM_MENU_EDIT             = FCIDM_GLOBALFIRST + $0040;
      FCIDM_MENU_VIEW             = FCIDM_GLOBALFIRST + $0080;
      FCIDM_MENU_VIEW_SEP_OPTIONS = FCIDM_GLOBALFIRST + $0081;
      FCIDM_MENU_TOOLS            = FCIDM_GLOBALFIRST + $00C0;
      FCIDM_MENU_TOOLS_SEP_GOTO   = FCIDM_GLOBALFIRST + $00C1;
      FCIDM_MENU_HELP             = FCIDM_GLOBALFIRST + $0100;
      FCIDM_MENU_FIND             = FCIDM_GLOBALFIRST + $0140;
      FCIDM_MENU_EXPLORE          = FCIDM_GLOBALFIRST + $0150;
      FCIDM_MENU_FAVORITES        = FCIDM_GLOBALFIRST + $0170;
      FCIDM_TOOLBAR               = FCIDM_BROWSERFIRST + 0;
      FCIDM_STATUS                = FCIDM_BROWSERFIRST + 1;

      IDC_OFFLINE_HAND            = 103;

      FWF_AUTOARRANGE             = $0001;
      FWF_ABBREVIATEDNAMES        = $0002;
      FWF_SNAPTOGRID              = $0004;
      FWF_OWNERDATA               = $0008;
      FWF_BESTFITWINDOW           = $0010;
      FWF_DESKTOP                 = $0020;
      FWF_SINGLESEL               = $0040;
      FWF_NOSUBFOLDERS            = $0080;
      FWF_TRANSPARENT             = $0100;
      FWF_NOCLIENTEDGE            = $0200;
      FWF_NOSCROLL                = $0400;
      FWF_ALIGNLEFT               = $0800;
      FWF_NOICONS                 = $1000;
      FWF_SINGLECLICKACTIVATE     = $8000;

      FVM_ICON                    = 1;
      FVM_SMALLICON               = 2;
      FVM_LIST                    = 3;
      FVM_DETAILS                 = 4;

      (* IShellBrowser constants *)

      SBSP_DEFBROWSER             = $0000;
      SBSP_SAMEBROWSER            = $0001;
      SBSP_NEWBROWSER             = $0002;
      SBSP_DEFMODE                = $0000;
      SBSP_OPENMODE               = $0010;
      SBSP_EXPLOREMODE            = $0020;
      SBSP_ABSOLUTE               = $0000;
      SBSP_RELATIVE               = $1000;
      SBSP_PARENT                 = $2000;
      SBSP_NAVIGATEBACK           = $4000;
      SBSP_NAVIGATEFORWARD        = $8000;
      SBSP_ALLOW_AUTONAVIGATE     = $10000;
      SBSP_INITIATEDBYHLINKFRAME  = $80000000;
      SBSP_REDIRECT               = $40000000;
      SBSP_WRITENOHISTORY         = $08000000;
      SBSP_NOAUTOSELECT           = $04000000;

      FCW_STATUS                  = $0001;
      FCW_TOOLBAR                 = $0002;
      FCW_TREE                    = $0003;
      FCW_INTERNETBAR             = $0006;
      FCW_PROGRESS                = $0008;

      FCT_MERGE                   = $0001;
      FCT_CONFIGABLE              = $0002;
      FCT_ADDTOEND                = $0004;

      CDBOSC_SETFOCUS             = $00000000;
      CDBOSC_KILLFOCUS            = $00000001;
      CDBOSC_SELCHANGE            = $00000002;
      CDBOSC_RENAME               = $00000003;

      SVSI_DESELECT               = $0000;
      SVSI_SELECT                 = $0001;
      SVSI_EDIT                   = $0003;
      SVSI_DESELECTOTHERS         = $0004;
      SVSI_ENSUREVISIBLE          = $0008;
      SVSI_FOCUSED                = $0010;
      SVSI_TRANSLATEPT            = $0020;

      SVGIO_BACKGROUND            = $00000000;
      SVGIO_SELECTION             = $00000001;
      SVGIO_ALLVIEW               = $00000002;

      (* IShellView2 constants *)

      SV2GV_CURRENTVIEW           = -1;
      SV2GV_DEFAULTVIEW           = -2;

      (* IShellDetails constants *)

      STRRET_WSTR                 = $0000;
      STRRET_OFFSET               = $0001;
      STRRET_CSTR                 = $0002;

      (* SHGetSpecialFolderLocation constants *)

      REGSTR_PATH_SPECIAL_FOLDERS   = 'Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders';
      CSIDL_DESKTOP                 = $0000;
      CSIDL_INTERNET                = $0001;
      CSIDL_PROGRAMS                = $0002;
      CSIDL_CONTROLS                = $0003;
      CSIDL_PRINTERS                = $0004;
      CSIDL_PERSONAL                = $0005;
      CSIDL_FAVORITES               = $0006;
      CSIDL_STARTUP                 = $0007;
      CSIDL_RECENT                  = $0008;
      CSIDL_SENDTO                  = $0009;
      CSIDL_BITBUCKET               = $000a;
      CSIDL_STARTMENU               = $000b;
      CSIDL_DESKTOPDIRECTORY        = $0010;
      CSIDL_DRIVES                  = $0011;
      CSIDL_NETWORK                 = $0012;
      CSIDL_NETHOOD                 = $0013;
      CSIDL_FONTS                   = $0014;
      CSIDL_TEMPLATES               = $0015;
      CSIDL_COMMON_STARTMENU        = $0016;
      CSIDL_COMMON_PROGRAMS         = $0017;
      CSIDL_COMMON_STARTUP          = $0018;
      CSIDL_COMMON_DESKTOPDIRECTORY = $0019;
      CSIDL_APPDATA                 = $001a;
      CSIDL_PRINTHOOD               = $001b;
      CSIDL_ALTSTARTUP              = $001d;
      CSIDL_COMMON_ALTSTARTUP       = $001e;
      CSIDL_COMMON_FAVORITES        = $001f;
      CSIDL_INTERNET_CACHE          = $0020;
      CSIDL_COOKIES                 = $0021;
      CSIDL_HISTORY                 = $0022;

      (* SHBrowseForFolder API constants *)

      BIF_RETURNONLYFSDIRS          = $0001;
      BIF_DONTGOBELOWDOMAIN         = $0002;
      BIF_STATUSTEXT                = $0004;
      BIF_RETURNFSANCESTORS         = $0008;
      BIF_EDITBOX                   = $0010;
      BIF_VALIDATE                  = $0020;
      BIF_NEWDIALOGSTYLE            = $0040;
      BIF_BROWSEINCLUDEURLS         = $0080;
      BIF_BROWSEFORCOMPUTER         = $1000;
      BIF_BROWSEFORPRINTER          = $2000;
      BIF_BROWSEINCLUDEFILES        = $4000;
      BIF_SHAREABLE                 = $8000;
      BIF_USENEWUI                  = BIF_NEWDIALOGSTYLE or BIF_EDITBOX;

      BFFM_INITIALIZED              = 1;
      BFFM_SELCHANGED               = 2;
      BFFM_VALIDATEFAILEDA          = 3;
      BFFM_VALIDATEFAILEDW          = 4;
      BFFM_SETSTATUSTEXTA           = WM_USER + 100;
      BFFM_ENABLEOK                 = WM_USER + 101;
      BFFM_SETSELECTIONA            = WM_USER + 102;
      BFFM_SETSELECTIONW            = WM_USER + 103;
      BFFM_SETSTATUSTEXTW           = WM_USER + 104;
      BFFM_VALIDATEFAILED           = BFFM_VALIDATEFAILEDA;
      BFFM_SETSTATUSTEXT            = BFFM_SETSTATUSTEXTA;
      BFFM_SETSELECTION             = BFFM_SETSELECTIONA;

      (* IShellFolder interface constants *)

      SHGDN_NORMAL                  = 0;
      SHGDN_INFOLDER                = 1;
      SHGDN_FOREDITING              = $1000;
      SHGDN_INCLUDE_NONFILESYS      = $2000;
      SHGDN_FORADDRESSBAR           = $4000;
      SHGDN_FORPARSING              = $8000;

      SHCONTF_FOLDERS               = 32;
      SHCONTF_NONFOLDERS            = 64;
      SHCONTF_INCLUDEHIDDEN         = 128;

      SFGAO_CANCOPY                 = DROPEFFECT_COPY;
      SFGAO_CANMOVE                 = DROPEFFECT_MOVE;
      SFGAO_CANLINK                 = DROPEFFECT_LINK;
      SFGAO_CANRENAME               = $00000010;
      SFGAO_CANDELETE               = $00000020;
      SFGAO_HASPROPSHEET            = $00000040;
      SFGAO_DROPTARGET              = $00000100;
      SFGAO_CAPABILITYMASK          = $00000177;
      SFGAO_LINK                    = $00010000;
      SFGAO_SHARE                   = $00020000;
      SFGAO_READONLY                = $00040000;
      SFGAO_GHOSTED                 = $00080000;
      SFGAO_HIDDEN                  = $00080000;
      SFGAO_DISPLAYATTRMASK         = $000F0000;
      SFGAO_FILESYSANCESTOR         = $10000000;
      SFGAO_FOLDER                  = $20000000;
      SFGAO_FILESYSTEM              = $40000000;
      SFGAO_HASSUBFOLDER            = $80000000;
      SFGAO_CONTENTSMASK            = $80000000;
      SFGAO_VALIDATE                = $01000000;
      SFGAO_REMOVABLE               = $02000000;
      SFGAO_COMPRESSED              = $04000000;
      SFGAO_BROWSABLE               = $08000000;
      SFGAO_NONENUMERATED           = $00100000;
      SFGAO_NEWCONTENT              = $00200000;

      (* IShellFolder2 interface constants *)

      SHCOLSTATE_TYPE_STR     = $00000001;
      SHCOLSTATE_TYPE_INT     = $00000002;
      SHCOLSTATE_TYPE_DATE    = $00000003;
      SHCOLSTATE_TYPEMASK     = $0000000F;
      SHCOLSTATE_ONBYDEFAULT  = $00000010;
      SHCOLSTATE_SLOW         = $00000020;
      SHCOLSTATE_EXTENDED     = $00000040;
      SHCOLSTATE_SECONDARYUI  = $00000080;
      SHCOLSTATE_HIDDEN       = $00000100;

      (* IDockingWindowFrame constants *)

      DWFRF_NORMAL            = $0000;
      DWFRF_DELETECONFIGDATA  = $0001;
      DWFAF_HIDDEN            = $0001;

      (* IDeskBand constants *)

      DBIM_MINSIZE              = $0001;
      DBIM_MAXSIZE              = $0002;
      DBIM_INTEGRAL             = $0004;
      DBIM_ACTUAL               = $0008;
      DBIM_TITLE                = $0010;
      DBIM_MODEFLAGS            = $0020;
      DBIM_BKCOLOR              = $0040;

      DBIMF_NORMAL              = $0000;
      DBIMF_VARIABLEHEIGHT      = $0008;
      DBIMF_DEBOSSED            = $0020;
      DBIMF_BKCOLOR             = $0040;

      DBIF_VIEWMODE_NORMAL      = $0000;
      DBIF_VIEWMODE_VERTICAL    = $0001;
      DBIF_VIEWMODE_FLOATING    = $0002;
      DBIF_VIEWMODE_TRANSPARENT = $0004;

      DBID_BANDINFOCHANGED      = 0;
      DBID_SHOWONLY             = 1;
      DBID_MAXIMIZEBAND         = 2;

      (* IActiveDesktop constants *)

      COMPONENT_TOP             = $7fffffff;
      COMP_TYPE_HTMLDOC         = 0;
      COMP_TYPE_PICTURE         = 1;
      COMP_TYPE_WEBSITE         = 2;
      COMP_TYPE_CONTROL         = 3;
      COMP_TYPE_CFHTML          = 4;
      COMP_TYPE_MAX             = 4;

      AD_APPLY_SAVE             = $00000001;
      AD_APPLY_HTMLGEN          = $00000002;
      AD_APPLY_REFRESH          = $00000004;
      AD_APPLY_ALL              = AD_APPLY_SAVE or AD_APPLY_HTMLGEN or AD_APPLY_REFRESH;
      AD_APPLY_FORCE            = $00000008;
      AD_APPLY_BUFFERED_REFRESH = $00000010;

      WPSTYLE_CENTER            = 0;
      WPSTYLE_TILE              = 1;
      WPSTYLE_STRETCH           = 2;
      WPSTYLE_MAX               = 3;

      COMP_ELEM_TYPE            = $00000001;
      COMP_ELEM_CHECKED         = $00000002;
      COMP_ELEM_DIRTY           = $00000004;
      COMP_ELEM_NOSCROLL        = $00000008;
      COMP_ELEM_POS_LEFT        = $00000010;
      COMP_ELEM_POS_TOP         = $00000020;
      COMP_ELEM_SIZE_WIDTH      = $00000040;
      COMP_ELEM_SIZE_HEIGHT     = $00000080;
      COMP_ELEM_POS_ZINDEX      = $00000100;
      COMP_ELEM_SOURCE          = $00000200;
      COMP_ELEM_FRIENDLYNAME    = $00000400;
      COMP_ELEM_SUBSCRIBEDURL   = $00000800;
      COMP_ELEM_ALL             = COMP_ELEM_TYPE or COMP_ELEM_CHECKED or
                                  COMP_ELEM_DIRTY or COMP_ELEM_NOSCROLL or
                                  COMP_ELEM_POS_LEFT or COMP_ELEM_SIZE_WIDTH  or
                                  COMP_ELEM_SIZE_HEIGHT or COMP_ELEM_POS_ZINDEX or
                                  COMP_ELEM_SOURCE or COMP_ELEM_FRIENDLYNAME;
      ADDURL_SILENT             = $0001;

      (* IDataObject constants *)

      CFSTR_SHELLIDLIST           = 'Shell IDList Array';
      CFSTR_SHELLIDLISTOFFSET     = 'Shell Object Offsets';
      CFSTR_NETRESOURCES          = 'Net Resource';
      CFSTR_FILEDESCRIPTORA       = 'FileGroupDescriptor';
      CFSTR_FILEDESCRIPTORW       = 'FileGroupDescriptorW';
      CFSTR_FILECONTENTS          = 'FileContents';
      CFSTR_FILENAMEA             = 'FileName';
      CFSTR_FILENAMEW             = 'FileNameW';
      CFSTR_PRINTERGROUP          = 'PrinterFriendlyName';
      CFSTR_FILENAMEMAPA          = 'FileNameMap';
      CFSTR_FILENAMEMAPW          = 'FileNameMapW';
      CFSTR_SHELLURL              = 'UniformResourceLocator';
      CFSTR_PREFERREDDROPEFFECT   = 'Preferred DropEffect';
      CFSTR_PERFORMEDDROPEFFECT   = 'Performed DropEffect';
      CFSTR_PASTESUCCEEDED        = 'Paste Succeeded';
      CFSTR_INDRAGLOOP            = 'InShellDragLoop';
      CFSTR_FILEDESCRIPTOR        = CFSTR_FILEDESCRIPTORA;
      CFSTR_FILENAME              = CFSTR_FILENAMEA;
      CFSTR_FILENAMEMAP           = CFSTR_FILENAMEMAPA;

      DVASPECT_SHORTNAME          = 2;

      (* FileDescriptor flags *)

      FD_CLSID              = $0001;
      FD_SIZEPOINT          = $0002;
      FD_ATTRIBUTES         = $0004;
      FD_CREATETIME         = $0008;
      FD_ACCESSTIME         = $0010;
      FD_WRITESTIME         = $0020;
      FD_FILESIZE           = $0040;
      FD_LINKUI             = $8000;

      (* File System Notification flags *)

      SHCNE_RENAMEITEM             = $00000001;
      SHCNE_CREATE                 = $00000002;
      SHCNE_DELETE                 = $00000004;
      SHCNE_MKDIR                  = $00000008;
      SHCNE_RMDIR                  = $00000010;
      SHCNE_MEDIAINSERTED          = $00000020;
      SHCNE_MEDIAREMOVED           = $00000040;
      SHCNE_DRIVEREMOVED           = $00000080;
      SHCNE_DRIVEADD               = $00000100;
      SHCNE_NETSHARE               = $00000200;
      SHCNE_NETUNSHARE             = $00000400;
      SHCNE_ATTRIBUTES             = $00000800;
      SHCNE_UPDATEDIR              = $00001000;
      SHCNE_UPDATEITEM             = $00002000;
      SHCNE_SERVERDISCONNECT       = $00004000;
      SHCNE_UPDATEIMAGE            = $00008000;
      SHCNE_DRIVEADDGUI            = $00010000;
      SHCNE_RENAMEFOLDER           = $00020000;
      SHCNE_FREESPACE              = $00040000;
      SHCNE_EXTENDED_EVENT         = $04000000;
      SHCNE_EXTENDED_EVENT_PRE_IE4 = $00080000;
      SHCNE_ASSOCCHANGED           = $08000000;
      SHCNE_DISKEVENTS             = $0002381F;
      SHCNE_GLOBALEVENTS           = $0C0581E0;
      SHCNE_ALLEVENTS              = $7FFFFFFF;
      SHCNE_INTERRUPT              = $80000000;
      SHCNEE_THEMECHANGED          = $00000001;
      SHCNEE_ORDERCHANGED          = $00000002;

      SHCNF_IDLIST                 = $0000;
      SHCNF_PATHA                  = $0001;
      SHCNF_PRINTERA               = $0002;
      SHCNF_DWord                  = $0003;
      SHCNF_PATHW                  = $0005;
      SHCNF_PRINTERW               = $0006;
      SHCNF_TYPE                   = $00FF;
      SHCNF_FLUSH                  = $1000;
      SHCNF_FLUSHNOWAIT            = $2000;
      SHCNF_PATH                   = SHCNF_PATHA;
      SHCNF_PRINTER                = SHCNF_PRINTERA;

      (* IQueryInfo constants *)

      QIF_CACHED             = $00000001;
      QIF_DONTEXPANDFOLDER   = $00000002;

      (* SHAddToRecentDocs constants *)

      SHARD_PIDL             = $00000001;
      SHARD_PATHA            = $00000002;
      SHARD_PATHW            = $00000003;
      SHARD_PATH             = SHARD_PATHA;

      (* SHGetDataFromIDList constants *)

      SHGDFIL_FINDDATA            = 1;
      SHGDFIL_NETRESOURCE         = 2;
      SHGDFIL_DESCRIPTIONID       = 3;

      SHDID_ROOT_REGITEM          = 1;
      SHDID_FS_FILE               = 2;
      SHDID_FS_DIRECTORY          = 3;
      SHDID_FS_OTHER              = 4;
      SHDID_COMPUTER_DRIVE35      = 5;
      SHDID_COMPUTER_DRIVE525     = 6;
      SHDID_COMPUTER_REMOVABLE    = 7;
      SHDID_COMPUTER_FIXED        = 8;
      SHDID_COMPUTER_NETDRIVE     = 9;
      SHDID_COMPUTER_CDROM        = 10;
      SHDID_COMPUTER_RAMDISK      = 11;
      SHDID_COMPUTER_OTHER        = 12;
      SHDID_NET_DOMAIN            = 13;
      SHDID_NET_SERVER            = 14;
      SHDID_NET_SHARE             = 15;
      SHDID_NET_RESTOFNET         = 16;
      SHDID_NET_OTHER             = 17;

      (* PROPIDs for Internet Shortcuts *)

      PID_IS_URL           = 2;
      PID_IS_NAME          = 4;
      PID_IS_WORKINGDIR    = 5;
      PID_IS_HOTKEY        = 6;
      PID_IS_SHOWCMD       = 7;
      PID_IS_ICONINDEX     = 8;
      PID_IS_ICONFILE      = 9;
      PID_IS_WHATSNEW      = 10;
      PID_IS_AUTHOR        = 11;
      PID_IS_DESCRIPTION   = 12;
      PID_IS_COMMENT       = 13;

      (* PROPIDs for Internet Sites *)

      PID_INTSITE_WHATSNEW      = 2;
      PID_INTSITE_AUTHOR        = 3;
      PID_INTSITE_LASTVISIT     = 4;
      PID_INTSITE_LASTMOD       = 5;
      PID_INTSITE_VISITCOUNT    = 6;
      PID_INTSITE_DESCRIPTION   = 7;
      PID_INTSITE_COMMENT       = 8;
      PID_INTSITE_FLAGS         = 9;
      PID_INTSITE_CONTENTLEN    = 10;
      PID_INTSITE_CONTENTCODE   = 11;
      PID_INTSITE_RECURSE       = 12;
      PID_INTSITE_WATCH         = 13;
      PID_INTSITE_SUBSCRIPTION  = 14;
      PID_INTSITE_URL           = 15;
      PID_INTSITE_TITLE         = 16;
      PID_INTSITE_CODEPAGE      = 18;
      PID_INTSITE_TRACKING      = 19;

      PIDISF_RECENTLYCHANGED    = $00000001;
      PIDISF_CACHEDSTICKY       = $00000002;
      PIDISF_CACHEIMAGES        = $00000010;
      PIDISF_FOLLOWALLLINKS     = $00000020;

      PIDISM_GLOBAL             = 0;
      PIDISM_WATCH              = 1;
      PIDISM_DONTWATCH          = 2;

      (* SHGetSettings flags *)

      SSF_SHOWALLOBJECTS        = $0001;
      SSF_SHOWEXTENSIONS        = $0002;
      SSF_SHOWCOMPCOLOR         = $0008;
      SSF_SHOWSYSFILES          = $0020;
      SSF_DOUBLECLICKINWEBVIEW  = $0080;
      SSF_SHOWATTRIBCOL         = $0100;
      SSF_DESKTOPHTML           = $0200;
      SSF_WIN95CLASSIC          = $0400;
      SSF_DONTPRETTYPATH        = $0800;
      SSF_SHOWINFOTIP           = $2000;
      SSF_MAPNETDRVBUTTON       = $1000;
      SSF_NOCONFIRMRECYCLE      = $8000;
      SSF_HIDEICONS             = $4000;

      (* IAutoComplete & IAutoComplete2 options *)

      ACO_NONE               = 0;
      ACO_AUTOSUGGEST        = $1;
      ACO_AUTOAPPEND         = $2;
      ACO_SEARCH             = $4;
      ACO_FILTERPREFIXES     = $8;
      ACO_USETAB             = $10;
      ACO_UPDOWNKEYDROPSLIST = $20;
      ACO_RTLREADING         = $40;

      (* String constants for Interface IDs *)

      SID_INewShortcutHookA           = '{000214E1-0000-0000-C000-000000000046}';
      SID_IShellBrowser               = '{000214E2-0000-0000-C000-000000000046}';
      SID_IShellView                  = '{000214E3-0000-0000-C000-000000000046}';
      SID_IContextMenu                = '{000214E4-0000-0000-C000-000000000046}';
      SID_IShellIcon                  = '{000214E5-0000-0000-C000-000000000046}';
      SID_IShellFolder                = '{000214E6-0000-0000-C000-000000000046}';
      SID_IShellExtInit               = '{000214E8-0000-0000-C000-000000000046}';
      SID_IShellPropSheetExt          = '{000214E9-0000-0000-C000-000000000046}';
      SID_IPersistFolder              = '{000214EA-0000-0000-C000-000000000046}';
      SID_IExtractIconA               = '{000214EB-0000-0000-C000-000000000046}';
      SID_IShellLinkA                 = '{000214EE-0000-0000-C000-000000000046}';
      SID_IShellCopyHookA             = '{000214EF-0000-0000-C000-000000000046}';
      SID_IFileViewerA                = '{000214F0-0000-0000-C000-000000000046}';
      SID_ICommDlgBrowser             = '{000214F1-0000-0000-C000-000000000046}';
      SID_IEnumIDList                 = '{000214F2-0000-0000-C000-000000000046}';
      SID_IFileViewerSite             = '{000214F3-0000-0000-C000-000000000046}';
      SID_IContextMenu2               = '{000214F4-0000-0000-C000-000000000046}';
      SID_IShellExecuteHookA          = '{000214F5-0000-0000-C000-000000000046}';
      SID_IPropSheetPage              = '{000214F6-0000-0000-C000-000000000046}';
      SID_INewShortcutHookW           = '{000214F7-0000-0000-C000-000000000046}';
      SID_IFileViewerW                = '{000214F8-0000-0000-C000-000000000046}';
      SID_IShellLinkW                 = '{000214F9-0000-0000-C000-000000000046}';
      SID_IExtractIconW               = '{000214FA-0000-0000-C000-000000000046}';
      SID_IShellExecuteHookW          = '{000214FB-0000-0000-C000-000000000046}';
      SID_IShellCopyHookW             = '{000214FC-0000-0000-C000-000000000046}';
      SID_IShellView2                 = '{88E39E80-3578-11CF-AE69-08002B2E1262}';
      SID_IContextMenu3               = '{BCFCE0A0-EC17-11d0-8D10-00A0C90F2719}';
      SID_IPersistFolder2             = '{1AC3D9F0-175C-11d1-95BE-00609797EA4F}';
      SID_IShellIconOverlayIdentifier = '{0C6C4200-C589-11D0-999A-00C04FD655E1}';
      SID_IShellIconOverlay           = '{7D688A70-C613-11D0-999B-00C04FD655E1}';
      SID_IURLSearchHook              = '{AC60F6A0-0FD9-11D0-99CB-00C04FD64497}';
      SID_IInputObjectSite            = '{f1db8392-7331-11d0-8c99-00a0c92dbfe8}';
      SID_IInputObject                = '{68284faa-6a48-11d0-8c78-00c04fd918b4}';
      SID_IDockingWindowSite          = '{2a342fc2-7b26-11d0-8ca9-00a0c92dbfe8}';
      SID_IDockingWindowFrame         = '{47d2657a-7b27-11d0-8ca9-00a0c92dbfe8}';
      SID_IDockingWindow              = '{012dd920-7b26-11d0-8ca9-00a0c92dbfe8}';
      SID_IDeskBand                   = '{EB0FE172-1A3A-11D0-89B3-00A0C90A90AC}';
      SID_IActiveDesktop              = '{F490EB00-1240-11D1-9888-006097DEACF9}';
      SID_IShellChangeNotify          = '{00000000-0000-0000-0000-000000000000}';  // !!
      SID_IQueryInfo                  = '{00021500-0000-0000-C000-000000000046}';
      SID_IShellDetails               = '{000214EC-0000-0000-C000-000000000046}';
      SID_IShellFolder2               = '{93F2F68C-1D1B-11D3-A30E-00C04F79ABD1}';
      SID_IEnumExtraSearch            = '{0E700BE1-9DB6-11D1-A1CE-00C04FD75D13}';


Type (* Forward class declarations *)

     IUnknown = Class;
     IStream = Class;
     IRunningObjectTable = Class;
     IEnumString = Class;
     IMoniker = Class;
     IAdviseSink = Class;
     IDispatch = Class;
     ITypeInfo = Class;
     ITypeComp = Class;
     ITypeLib = Class;
     IOleInPlaceActiveObject = Class;
     IEnumOleVerb = Class;
     IShellView = Class;
     IShellBrowser = Class;


     SHITEMID = Record
                  cb : USHORT;
                  abID : Array [0..0] of Byte;
                end;
     LPSHITEMID = ^SHITEMID;
     LPCSHITEMID = ^SHITEMID;
     _SHITEMID = SHITEMID;
     TSHITEMID = SHITEMID;
     PSHITEMID = ^SHITEMID;

     ITEMIDLIST = Record
                    mkid : SHITEMID;
                  end;
     LPITEMIDLIST = ^ITEMIDLIST;
     LPCITEMIDLIST = ^ITEMIDLIST;
     _ITEMIDLIST = ITEMIDLIST;
     TITEMIDLIST = ITEMIDLIST;
     PITEMIDLIST = ^ITEMIDLIST;

     (* Variant (not supported by Virtual Pascal) *)

     pVariant = Pointer;
     pOleVariant = Pointer;

     (* OLE character and string types *)

     tOleChar = WideChar;
     pOleStr = pWideChar;

     pOleStrList = ^tOleStrList;
     tOleStrList = Array [0..65535] of pOleStr;

     (* Result list *)

     pResultList = ^tResultList;
     tResultList = Array [0..65535] of hResult;

     (* 64-bit large integer *)

     LargeInt = Comp;

     (* Globally unique ID *)

     pGUID = ^tGUID;
     tGUID = Packed Record
               Data1 : DWord;
               Data2 : SmallWord;
               Data3 : SmallWord;
               Data4 : Array [0..7] of Byte;
             end;
     pIID = pGUID;
     tIID = tGUID;
     pCLSID = pGUID;
     tCLSID = tGUID;

     (* Locale ID *)

     tLCID = DWord;

     (* Automation types *)

     pBStr = ^tBStr;
     tBStr = pOleStr;

     pBStrList = ^tBStrList;
     tBStrList = Array [0..65535] of tBStr;

     pBlob = ^tBlob;
     tagBLOB = Record
                 cbSize : LongInt;
                 pBlobData : Pointer;
               end;
     tBlob = tagBLOB;
     BLOB = tagBLOB;

     pClipData = ^tClipData;
     tagCLIPDATA = Record
                     cbSize : LongInt;
                     ulClipFmt : LongInt;
                     pClipData : Pointer;
                   end;
     tClipData = tagCLIPDATA;
     CLIPDATA = tagCLIPDATA;

     pSafeArrayBound = ^tSafeArrayBound;
     tagSAFEArrayBOUND = Record
                           cElements : LongInt;
                           lLbound : LongInt;
                         end;
     tSafeArrayBound = tagSAFEArrayBOUND;
     SAFEArrayBOUND = tagSAFEArrayBOUND;

     pSafeArray = ^tSafeArray;
     tagSAFEArray = Record
                      cDims : Word;
                      fFeatures : Word;
                      cbElements : LongInt;
                      cLocks : LongInt;
                      pvData : Pointer;
                      rgsabound : Array [0..0] of tSafeArrayBound;
                    end;
     tSafeArray = tagSAFEArray;
     SAFEARRAY = tagSAFEArray;

     tOleDate = Double;

     tCurrency = Comp;

     tOleBool = WordBool;

     tBorderWidths = 0..MaxInt;

     tVarType = Word;

     pVariantArg = ^tVariantArg;
     tagVARIANT = Record
                    vt : tVarType;
                    wReserved1 : Word;
                    wReserved2 : Word;
                    wReserved3 : Word;
                    case Integer of
                      VT_UI1 :                  (bVal : Byte);
                      VT_I2 :                   (iVal : SmallInt);
                      VT_I4 :                   (lVal : LongInt);
                      VT_R4 :                   (fltVal : Single);
                      VT_R8 :                   (dblVal : Double);
                      VT_BOOL :                 (vBool : tOleBool);
                      VT_ERROR :                (sCode : hResult);
                      VT_CY :                   (CyVal : tCurrency);
                      VT_DATE :                 (Date : tOleDate);
                      VT_BSTR :                 (BStrVal : TBStr);
                      VT_UNKNOWN :              (UnkVal : IUnknown);
                      VT_DISPATCH :             (DispVal : IDispatch);
                      VT_ARRAY :                (pArray : pSafeArray);
                      VT_BYREF or VT_UI1 :      (pbVal : ^Byte);
                      VT_BYREF or VT_I2 :       (piVal : ^SmallInt);
                      VT_BYREF or VT_I4 :       (plVal : ^LongInt);
                      VT_BYREF or VT_R4 :       (pfltVal : ^Single);
                      VT_BYREF or VT_R8 :       (pdblVal : ^Double);
                      VT_BYREF or VT_BOOL :     (pBool : ^tOleBool);
                      VT_BYREF or VT_ERROR :    (psCode : ^HResult);
                      VT_BYREF or VT_CY :       (pCyVal : ^tCurrency);
                      VT_BYREF or VT_DATE :     (pDate : ^tOleDate);
                      VT_BYREF or VT_BSTR :     (pBStrVal : pBStr);
                      VT_BYREF or VT_UNKNOWN :  (pUnkVal : ^IUnknown);
                      VT_BYREF or VT_DISPATCH : (pDispVal : ^IDispatch);
                      VT_BYREF or VT_ARRAY :    (ppArray : ^pSafeArray);
                      VT_BYREF or VT_VARIANT :  (pVarVal : pVariant);
                      VT_BYREF :                (ByRef : Pointer);
                  end;
     tVariantArg = tagVARIANT;
     VARIANTARG = tagVARIANT;

     pVariantArgList = ^tVariantArgList;
     tVariantArgList = Array [0..65535] of pVariantArg;

     tDispID = LongInt;

     pDispIDList = ^tDispIDList;
     tDispIDList = Array [0..65535] of tDispID;

     tMemberID = LongInt;

     pMemberIDList = ^tMemberIDList;
     tMemberIDList = Array [0..65535] of tMemberID;

     tPropID = LongInt;

     HRefType = LongInt;

     tTypeKind = LongInt;

     pArrayDesc = ^tArrayDesc;

     pTypeDesc = ^tTypeDesc;
     tagTYPEDESC = Record
                     case Integer of
                       VT_PTR :         (ptdesc : pTypeDesc; vt : tVarType);
                       VT_CArray :      (padesc : pArrayDesc);
                       VT_USERDEFINED : (hreftype : HRefType);
                   end;
     tTypeDesc = tagTYPEDESC;
     TYPEDESC = tagTYPEDESC;

     tagArrayDESC = Record
                      tdescElem : tTypeDesc;
                      cDims : Word;
                      rgbounds : Array [0..0] of tSafeArrayBound;
                    end;
     tArrayDesc = tagArrayDESC;
     ArrayDESC = tagArrayDESC;

     pIDLDesc = ^tIDLDesc;
     tagIDLDESC = Record
                    dwReserved : LongInt;
                    wIDLFlags : Word;
                  end;
     tIDLDesc = tagIDLDESC;
     IDLDESC = tagIDLDESC;

     pElemDesc = ^tElemDesc;
     tagELEMDESC = Record
                     tdesc : tTypeDesc;
                     idldesc : tIDLDesc;
                   end;
     tElemDesc = tagELEMDESC;
     ELEMDESC = tagELEMDESC;

     pElemDescList = ^tElemDescList;
     tElemDescList = Array [0..65535] of tElemDesc;

     pTypeAttr = ^tTypeAttr;
     tagTYPEATTR = Record
                     guid : tGUID;
                     lcid : tLCID;
                     dwReserved : LongInt;
                     memidConstructor : tMemberID;
                     memidDestructor : tMemberID;
                     lpstrSchema : pOleStr;
                     cbSizeInstance : LongInt;
                     TypeKind : tTypeKind;
                     cFuncs : Word;
                     cVars : Word;
                     cImplTypes : Word;
                     cbSizeVft : Word;
                     cbAlignment : Word;
                     wTypeFlags : Word;
                     wMajorVerNum : Word;
                     wMinorVerNum : Word;
                     tDescAlias : tTypeDesc;
                     idldescType : tIDLDesc;
                   end;
     tTypeAttr = tagTYPEATTR;
     TYPEATTR = tagTYPEATTR;

     pExcepInfo = ^tExcepInfo;
{&StdCall+}
     tFNDeferredFillIn = Function (ExInfo : pExcepInfo) : hResult;
{&StdCall-}
     tagEXCEPINFO = Record
                      wCode : Word;
                      wReserved : Word;
                      bstrSource : tBStr;
                      bstrDescription : tBStr;
                      bstrHelpFile : tBStr;
                      dwHelpContext : LongInt;
                      pvReserved : Pointer;
                      pfnDeferredFillIn : tFNDeferredFillIn;
                      scode : hResult;
                    end;
     tExcepInfo = tagEXCEPINFO;
     EXCEPINFO = tagEXCEPINFO;

     tFuncKind = LongInt;
     tInvokeKind = LongInt;
     tCallConv = LongInt;

     pFuncDesc = ^tFuncDesc;
     tagFUNCDESC = Record
                     memid : tMemberID;
                     lprgscode : pResultList;
                     lprgelemdescParam : pElemDescList;
                     FuncKind : tFuncKind;
                     InvKind : tInvokeKind;
                     CallConv : tCallConv;
                     cParams : SmallInt;
                     cParamsOpt : SmallInt;
                     oVft : SmallInt;
                     cScodes : SmallInt;
                     ElemDescFunc : tElemDesc;
                     wFuncFlags : Word;
                   end;
     tFuncDesc = tagFUNCDESC;
     FUNCDESC = tagFUNCDESC;

     tVarKind = LongInt;

     pVarDesc = ^tVarDesc;
     tagVARDESC = Record
                    memid : tMemberID;
                    lpstrSchema : pOleStr;
                    case Integer of
                      VAR_PERINSTANCE : (oInst : LongInt;
                                         elemdescVar : tElemDesc;
                                         wVarFlags : Word;
                                         varkind : tVarKind);
                      VAR_CONST : (lpvarValue : Pointer);
                  end;
     tVarDesc = tagVARDESC;
     VARDESC = tagVARDESC;

     pDispParams = ^tDispParams;
     tagDISPPARAMS = Record
                       rgvarg : pVariantArgList;
                       rgdispidNamedArgs : pDispIDList;
                       cArgs : LongInt;
                       cNamedArgs : LongInt;
                     end;
     tDispParams = tagDISPPARAMS;
     DISPPARAMS = tagDISPPARAMS;

{&StdCall+}
     tDLLGetClassObject = Function (const clsid : TCLSID; const iid : TIID; var pv) : hResult;
     tDLLCanUnloadNow = Function : hResult;
{&StdCall-}

     (* OLE object descriptor *)

     pObjectDescriptor = ^tObjectDescriptor;
     tagOBJECTDESCRIPTOR = Record
                             cbSize : LongInt;
                             clsid : TCLSID;
                             dwDrawAspect : LongInt;
                             Size : tPoint;
                             Point : tPoint;
                             dwStatus : LongInt;
                             dwFullUserTypeName : LongInt;
                             dwSrcOfCopy : LongInt;
                           end;
     tObjectDescriptor = tagOBJECTDESCRIPTOR;
     OBJECTDESCRIPTOR = tagOBJECTDESCRIPTOR;

     pLinkSrcDescriptor = pObjectDescriptor;
     tLinkSrcDescriptor = tObjectDescriptor;

     (* IDispatch implementation support *)

     pParamData = ^tParamData;
     tagPARAMDATA = Record
                      szName : pOleStr;
                      vt : tVarType;
                    end;
     tParamData = tagPARAMDATA;
     PARAMDATA = tagPARAMDATA;

     pParamDataList = ^tParamDataList;
     tParamDataList = Array [0..65535] of tParamData;

     pMethodData = ^tMethodData;
     tagMETHODDATA = Record
                       szName : pOleStr;
                       ppData : pParamDataList;
                       DispId : tDispID;
                       iMeth : Integer;
                       cc : tCallConv;
                       cArgs : Integer;
                       wFlags : Word;
                       vtReturn : tVarType;
                     end;
     tMethodData = tagMETHODDATA;
     METHODDATA = tagMETHODDATA;

     pMethodDataList = ^tMethodDataList;
     tMethodDataList = Array [0..65535] of tMethodData;

     pInterfaceData = ^tInterfaceData;
     tagINTERFACEDATA = Record
                          pMethData : pMethodDataList;
                          cMembers : Integer;
                        end;
     tInterfaceData = tagINTERFACEDATA;
     INTERFACEDATA = tagINTERFACEDATA;

     (* IFileViewer types *)

     pFVShowInfo = ^FVSHOWINFO;
     FVSHOWINFO = Packed record
                    (* Passed into viewer (in) *)
                    cbSize : DWord;                                     (* Size of structure *)
                    HwndOwner : HWnd;                                   (* Owner window *)
                    iShow : Integer;                                    (* The show command *)
                    (* Passed in and updated  (in/Out) *)
                    dwFlags : DWord;                                    (* Flags *)
                    Rect : tRect;                                       (* Where to create the window may have defaults *)
                    pUnkRel : IUnknown;                                 (* Release this interface when window is visible *)
                    (* Returned from viewer (out) *)
                    StrNewFile : Array [0..MAX_PATH - 1] of tOleChar;   (* New File to view *)
                  end;

     tFVShowInfo = FVSHOWINFO;
     LPFVSHOWINFO = pFVShowInfo;

     (* Shell folder types *)

     hOleMenu = hGlobal;

     pFolderSettings = ^FOLDERSETTINGS;
     FOLDERSETTINGS = Packed record
                        ViewMode : UINT;
                        fFlags : UINT;
                      end;

     tFolderSettings = FOLDERSETTINGS;
     LPFOLDERSETTINGS = pFolderSettings;

     pStrRet = ^tStrRet;
     _STRRET = Record
                 uType : UINT;                                     (* One of the STRRET_* values *)
                 case Integer of
                   0 : (pOleStr : LPWSTR);                         (* Must be freed by caller of GetDisplayNameOf *)
                   1 : (pStr : LPSTR);                             (* Not used *)
                   2 : (uOffset : UINT);                           (* Offset into SHITEMID (ANSI) *)
                   3 : (cStr : Array [0..MAX_PATH - 1] of Char);   (* Buffer to fill in *)
               end;
     tStrRet = _STRRET;
     STRRET = _STRRET;

     pShellDetails = ^tShellDetails;
     _SHELLDETAILS = Record
                       Fmt, cxChar : Integer;
                       Str : STRRET;
                     end;
     tShellDetails = _SHELLDETAILS;
     SHELLDETAILS = _SHELLDETAILS;

     (* Shell view types *)

     tSVUIAEnums = (SVUIA_DEACTIVATE,SVUIA_ACTIVATE_NOFOCUS,SVUIA_ACTIVATE_FOCUS,SVUIA_INPLACEACTIVATE);

     SHELLVIEWID = TGUID;
     tShellViewID = SHELLVIEWID;
     pShellViewID = ^tShellViewID;

     pSV2CreateParams = ^tSV2CreateParams;
     _SV2CVW2_PARAMS = Record
                         cbSize : DWord;
                         psvPrev : IShellView;
                         pfs : pFolderSettings;
                         psbOwner : IShellBrowser;
                         prcView : pRect;
                         pvid : pShellViewID;
                         HwndView : HWnd;
                       end;
     tSV2CreateParams = _SV2CVW2_PARAMS;
     SV2CVW2_PARAMS = _SV2CVW2_PARAMS;

     (* SHBrowseForFolder types *)

{&StdCall+}
     BFFCALLBACK = Function (Wnd : HWnd; uMsg : UINT; lParam, lpData : lParam) : Integer;
     tFNBFFCallBack = BFFCALLBACK;
{&StdCall-}

     pBrowseInfoA = ^tBrowseInfoA;
     pBrowseInfoW = ^tBrowseInfoW;
     pBrowseInfo = pBrowseInfoA;
     _BrowseInfoA = Record
                      HwndOwner : HWnd;
                      pIdlRoot : pItemIDList;
                      pszDisplayName : pAnsiChar;
                      lpszTitle : pAnsiChar;
                      ulFlags : UINT;
                      lpfn : tFNBFFCallBack;
                      lParam : lParam;
                      iImage : Integer;
                    end;
     _BrowseInfoW = Record
                      HwndOwner : HWnd;
                      pIdlRoot : pItemIDList;
                      pszDisplayName : pWideChar;
                      lpszTitle : pWideChar;
                      ulFlags : UINT;
                      lpfn : tFNBFFCallBack;
                      lParam : lParam;
                      iImage : Integer;
                    end;
     _BrowseInfo = _BrowseInfoA;
     tBrowseInfoA = _BrowseInfoA;
     tBrowseInfoW = _BrowseInfoW;
     tBrowseInfo = tBrowseInfoA;
     BROWSEINFOA = _browseinfoA;
     BROWSEINFOW = _browseinfoW;
     BROWSEINFO = BROWSEINFOA;

     pExtraSearch = ^tExtraSearch;
     tagExtraSearch = Record
                        guidSearch : TGUID;
                        wszFriendlyName, wszMenuText : Array [0..79] of WideChar;
                        wszHelpText : Array [0..MAX_PATH] of WideChar;
                        wszUrl : Array [0..2047] of WideChar;
                        wszIcon, wszGreyIcon, wszClrIcon : Array [0..MAX_PATH + 10] of WideChar;
                      end;
     tExtraSearch = tagExtraSearch;

     pShColumnID = ^tShColumnID;
     SHCOLUMNID = Record
                    fmtID : TGUID;
                    pID : DWord;
                  end;
     tShColumnID = SHCOLUMNID;

     (* Format of CF_NETRESOURCE *)

     pNResArray = ^tNResArray;
     _NRESARRAY = Record
                    cItems : UINT;
                    Nr : Array [0..0] of tNetResource;
                  end;
     tNResArray = _NRESARRAY;
     NRESARRAY = _NRESARRAY;

     (* Format of CF_IDLIST *)

     PIDA = ^TIDA;
     _IDA = Record
              cidl : UINT;                      (* Number of relative IDList *)
              aOffset : Array [0..0] of UINT;   (* [0] : folder IDList - [1]-[cidl] : item IDList *)
            end;
     TIDA = _IDA;
     CIDA = _IDA;

     (* File descriptor *)

     pFileDescriptorA = ^tFileDescriptorA;
     pFileDescriptorW = ^tFileDescriptorW;
     pFileDescriptor = pFileDescriptorA;
     _FILEDESCRIPTORA = Record
                          dwFlags : DWord;
                          clsid : TCLSID;
                          SizeL : tSize;
                          PointL : tPoint;
                          dwFileAttributes : DWord;
                          ftCreationTime : tFileTime;
                          ftLastAccessTime : tFileTime;
                          ftLastWriteTime : tFileTime;
                          nFileSizeHigh : DWord;
                          nFileSizeLow : DWord;
                          cFileName : Array [0..MAX_PATH - 1] of AnsiChar;
                        end;
     _FILEDESCRIPTORW = Record
                          dwFlags : DWord;
                          clsid : TCLSID;
                          SizeL : tSize;
                          PointL : tPoint;
                          dwFileAttributes : DWord;
                          ftCreationTime : tFileTime;
                          ftLastAccessTime : tFileTime;
                          ftLastWriteTime : tFileTime;
                          nFileSizeHigh : DWord;
                          nFileSizeLow : DWord;
                          cFileName : Array [0..MAX_PATH - 1] of WideChar;
                        end;
     _FILEDESCRIPTOR = _FILEDESCRIPTORA;
     tFileDescriptorA = _FILEDESCRIPTORA;
     tFileDescriptorW = _FILEDESCRIPTORW;
     tFileDescriptor = tFileDescriptorA;
     FILEDESCRIPTORA = _FILEDESCRIPTORA;
     FILEDESCRIPTORW = _FILEDESCRIPTORW;
     FILEDESCRIPTOR = FILEDESCRIPTORA;

     (* Format of CF_FILEGROUPDESCRIPTOR *)

     pFileGroupDescriptorA = ^tFileGroupDescriptorA;
     pFileGroupDescriptorW = ^tFileGroupDescriptorW;
     pFileGroupDescriptor = pFileGroupDescriptorA;
     _FILEGROUPDESCRIPTORA = Record
                               cItems : UINT;
                               fgd : Array [0..0] of tFileDescriptorA;
                             end;
     _FILEGROUPDESCRIPTORW = Record
                               cItems : UINT;
                               fgd : Array [0..0] of tFileDescriptorW;
                             end;
     _FILEGROUPDESCRIPTOR = _FILEGROUPDESCRIPTORA;
     tFileGroupDescriptorA = _FILEGROUPDESCRIPTORA;
     tFileGroupDescriptorW = _FILEGROUPDESCRIPTORW;
     tFileGroupDescriptor = tFileGroupDescriptorA;
     FILEGROUPDESCRIPTORA = _FILEGROUPDESCRIPTORA;
     FILEGROUPDESCRIPTORW = _FILEGROUPDESCRIPTORW;
     FILEGROUPDESCRIPTOR = FILEGROUPDESCRIPTORA;

     (* Format of CF_HDROP and CF_PRINTERS *)

     pDropFiles = ^tDropFiles;
     _DROPFILES = Record
                    pFiles : DWord;   (* Offset of file list *)
                    pt : tPoint;      (* Drop point (client coords) *)
                    fNC : BOOL;       (* Is it on NonClient area *)
                    fWide : BOOL;     (* Wide character switch *)
                  end;
     tDropFiles = _DROPFILES;
     DROPFILES = _DROPFILES;

     (* SHGetDataFromIDList types *)

     pSHDescriptionID = ^tSHDescriptionID;
     _SHDESCRIPTIONID = Record
                          dwDescriptionId : DWord;
                          Id : TCLSID;
                        end;
     tSHDescriptionID = _SHDESCRIPTIONID;
     SHDESCRIPTIONID = _SHDESCRIPTIONID;

     (* Shell flag state *)

     SHELLFLAGSTATE = Packed record
                        Data : SmallWord;
                      end;
     pShellFlagState = ^tShellFlagState;
     tShellFlagState = SHELLFLAGSTATE;

     (* SoftwareUpdateMessageBox structure *)

     pSoftDistInfo = ^tSoftDistInfo;
     _tagSOFTDISTINFO = Packed Record
                          cbSize : ULONG;
                          dwFlags : DWord;
                          dwAdState : DWord;
                          szTitle : LPWSTR;
                          szAbstract : LPWSTR;
                          szHREF : LPWSTR;
                          dwInstalledVersionMS : DWord;
                          dwInstalledVersionLS : DWord;
                          dwUpdateVersionMS : DWord;
                          dwUpdateVersionLS : DWord;
                          dwAdvertisedVersionMS : DWord;
                          dwAdvertisedVersionLS : DWord;
                          dwReserved : DWord;
                        end;
     tSoftDistInfo = _tagSOFTDISTINFO;
     SOFTDISTINFO = _tagSOFTDISTINFO;


     (* IUnknown interface
        ==================

        The IUnknown interface lets clients get pointers to other interfaces on a given object through the QueryInterface method,
        and manage the existence of the object through the IUnknown::AddRef and IUnknown::Release methods.
        All other COM interfaces are inherited, directly or indirectly, from IUnknown.
        Therefore, the three methods in IUnknown are the first entries in the VTable for every interface.

        When to Implement
        -----------------

        You must implement IUnknown as part of every interface.
        If you are using C++ multiple inheritance to implement multiple interfaces, the various interfaces can share one
        implementation of IUnknown. If you are using nested classes to implement multiple interfaces, you must implement
        IUnknown once for each interface you implement.

        When to Use
        -----------

        Use IUnknown methods to switch between interfaces on an object, add references, and release objects.

        IUnknown Methods
        ----------------

        QueryInterface  Returns a pointer to a specified interface on an object to which a client currently holds an interface pointer.
                        This function must call IUnknown::AddRef on the pointer it returns.
        AddRef          Increments the reference count for an interface on an object.
                        It should be called for every new copy of a pointer to an interface on a given object.
        Release         Decrements the reference count for the calling interface on a object.
                        If the reference count on the object falls to 0, the object is freed from memory. *)

     ppIUnknown = ^pIUnknown;
     pIUnknown = ^IUnknown;

     IUnknown = Class
                Public
{&StdCall+}
                  Function QueryInterface (const iid : TIID; var Obj) : hResult;
                     virtual; abstract;
                  Function AddRef : LongInt;
                     virtual; abstract;
                  Function Release : LongInt;
                     virtual; abstract;
{&StdCall-}
                end;


     (* IClassFactory interface
        =======================

        The IClassFactory interface contains two methods intended to deal with an entire class of objects, and so is implemented
        on the class object for a specific class of objects (identified by a CLSID). The first method, CreateInstance, creates an
        uninitialized objd object of a specified CLSID, and the second, LockServer, locks the object's server in memory, allowing
        new objects to be created more quickly.

        When to Implement
        -----------------

        You must implement this interface for every class that you register in the system registry and to which you assign a
        CLSID, so objects of that class can be created.

        When to Use
        -----------

        After calling the CoGetClassObject function to get an IClassFactory interface pointer to the class object, call the
        CreateInstance method of this interface to create a new uninitialized object.
        It is not, however, always necessary to go through this process to create an object. To create a single uninitialized
        object, you can, instead, just call CoCreateInstance. OLE also provides numerous helper functions (with names of the
        form OleCreateXxx) to create compound document objects.

        Call the LockServer method to keep the object server in memory and enhance performance only if you intend to create more
        than one object of the specified class.

        IClassFactory Methods
        ---------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        CreateInstance  Creates an uninitialized object.
        LockServer      Called by the client of a class object to keep a server open in memory, allowing instances to be created
                        more quickly. *)

     ppIClassFactory = ^pIClassFactory;
     pIClassFactory = ^IClassFactory;

     IClassFactory = Class (IUnknown)
                     Public
{&StdCall+}
                       Function CreateInstance (unkOuter : IUnknown; const iid : TIID; var obj) : hResult;
                          virtual; abstract;
                       Function LockServer (fLock : BOOL) : hResult;
                          virtual; abstract;
{&StdCall-}
                     end;


     (* IMarshal interface
        ==================

        The IMarshal interface enables an COM object to define and manage the marshaling of its interface pointers.
        The alternative is to use COM's default implementation, the preferred choice in all but a few special cases (see "When
        to Implement").

        "Marshaling" is the process of packaging data into packets for transmission to a different process or machine.
        "Unmarshaling" is the process of recovering that data at the receiving end.
        In any given call, method arguments are marshaled and unmarshaled in one direction, while return values are marshaled
        and unmarshaled in the other.
        Although marshaling applies to all data types, interface pointers require special handling.
        The fundamental problem is how client code running in one address space can correctly dereference a pointer to an
        interface on an object residing in a different address space. COM's solution is for a client application to communicate
        with the original object through a surrogate object, or proxy, which lives in the client's process.
        The proxy holds a reference to an interface on the original object and hands the client a pointer to an interface on
        itself. When the client calls an interface method on the original object, its call is actually going to the proxy.
        Therefore, from the client's point of view, all calls are in-process.

        On receiving a call, the proxy marshals the method arguments and, through some means of interprocess communication, such
        as RPC, passes them along to code in the server process, which unmarshals the arguments and passes them to the original
        object. This same code marshals return values for transmission back to the proxy, which unmarshals the values and passes
        them to the client application.
        IMarshal provides methods for creating, initializing, and managing a proxy in a client process; it does not dictate how
        the proxy should communicate with the original object. COM's default implementation of IMarshal uses RPC. When you
        implement this interface yourself, you are free to choose any method of interprocess communication you deem to be
        appropriate for your application  shared memory, named pipe, window handle, RPC  in short, whatever works.

        When to Implement
        -----------------

        Implement IMarshal only when you believe that you can realize significant optimizations to COM's default implementation.
        In practice, this will rarely be the case. However, there are occasions where implementing IMarshal may be preferred:

         The objects you are writing keep their state in shared memory.
          In this case, both the original process and the client process uses proxies that refer to the shared memory.
          This type of custom marshaling is possible only if the client proceess is on the same machine as the original process.
          OLE-provided implementations of IStorage and IStream are examples of this type of custom marshaling.
         The objects you are writing are immutable, that is, their state does not change after creation. Instead of forwarding
          method calls to the original objects, you simply create copies of those objects in the client process. This technique
          avoids the cost of switching from one process to another.
          Some monikers are examples of immutable objects; if you are implementing your own moniker class, you should evaluate
          the costs and benefits of implementing IMarshal on your moniker objects.
         Objects that themselves are proxy objects can use custom marshaling to avoid creating proxies to proxies.
          Instead, the existing proxy can refer new proxies back to the original object. This capability is important for the
          sake of both efficiency and robustness.
         Your server application wants to manage how calls are made across the network without affecting the interface exposed
          to clients. For example, if an end user were making changes to a database record, the server might want to cache the
          changes until the user has committed them all, at which time the entire transaction would be forwarded in a single
          packet. Using a custom proxy would enable the caching and batching of changes in this way.

        When you choose to implement IMarshal, you must do so for both your original object and the proxy you create for it.
        When implementing the interface on either object or proxy, you simply return E_NOTIMPL for the methods that are not
        implemented.

        COM uses your implementation of IMarshal in the following manner: When it's necessary to create a remote interface
        pointer to your object (that is, when a pointer to your object is passed as an argument in a remote function call), COM
        queries your object for the IMarshal interface. If your object implements it, COM uses your IMarshal implementation to
        create the proxy object. If your object does not implement IMarshal, COM uses its default implementation.

        How you choose to structure the proxy is entirely up to you. You can write the proxy to use whatever mechanisms you deem
        appropriate for communicating with the original object. You can also create the proxy as either a stand-alone object or
        as part of a larger aggregation such as a handler. However you choose to structure the proxy, it must implement IMarshal
        to work at all. You must also generate a CLSID for the proxy to be returned by your implementation of
        IMarshal::GetUnmarshalClass on the original object.

        When to Use
        -----------

        COM calls this interface as part of system-provided marshaling support. COM's calls are wrapped in calls to
        CoMarshalInterface and CoUnmarshalInterface. Your code typically will not need to call this interface.
        Special circumstances where you might choose to do so are discussed in the "Notes to Callers" section for each method.

        IMarshal Methods
        ----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetUnmarshalClass       Returns the CLSID that COM uses to locate the DLL containing the code for the corresponding proxy.
                                COM loads this DLL to create an uninitialized instance of the proxy.
        GetMarshalSizeMax       Returns an upper bound on the number of bytes needed to marshal the specified interface pointer on
                                the specified object.
        MarshalInterface        Writes into a stream the data required to initialize a proxy object in some client process.
        UnmarshalInterface      Initializes a newly created proxy and returns an interface pointer to that proxy.
        ReleaseMarshalData      Destroys a marshaled data packet.
        DisconnectObject        Forcibly releases all external connections to an object.
                                The object's server calls the object's implementation of this method prior to shutting down. *)

     ppIMarshal = ^pIMarshal;
     pIMarshal = ^IMarshal;

     IMarshal = Class (IUnknown)
                Public
{&StdCall+}
                  Function GetUnmarshalClass (const iid : TIID; pv : Pointer; dwDestContext : LongInt; pvDestContext : Pointer;
                                              mshlFlags : LongInt; var cid : TCLSID) : hResult;
                     virtual; abstract;
                  Function GetMarshalSizeMax (const iid : TIID; pv : Pointer; dwDestContext : Longint; pvDestContext : Pointer;
                                              mshlFlags: LongInt; var Size : LongInt) : hResult;
                     virtual; abstract;
                  Function MarshalInterface (stm : IStream; const iid : TIID; pv : Pointer; dwDestContext : LongInt;
                                             pvDestContext : Pointer; mshlFlags : LongInt) : hResult;
                     virtual; abstract;
                  Function UnmarshalInterface (stm : IStream; const iid : TIID; var pv) : hResult;
                     virtual; abstract;
                  Function ReleaseMarshalData (stm : IStream) : hResult;
                     virtual; abstract;
                  Function DisconnectObject (dwReserved : LongInt) : hResult;
                     virtual; abstract;
{&StdCall-}
                end;


     (* IMalloc interface
        =================

        Allocates, frees, and manages memory.

        When to Implement
        -----------------

        In general, you should not implement IMalloc, instead using the OLE implementation, which is guaranteed to be
        thread-safe in managing task memory.
        You get a pointer to the OLE task allocator object's IMalloc through a call to the CoGetMalloc function.

        When to Use
        -----------

        Call the methods of IMalloc to allocate and manage memory.
        The OLE libraries and object handlers also call the IMalloc methods to manage memory.
        Object handlers should call CoGetMalloc to get a pointer to the IMalloc implementation on the task allocator object,
        and use the implementation of those methods to manage task memory.
        The IMalloc methods Alloc, Free, and Realloc are similar to the C library functions malloc, free, and realloc.
        For debugging, refer to the functions CoRegisterMallocSpy and CoRevokeMallocSpy.

        IMalloc Methods
        ---------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Alloc           Allocates a block of memory.
        Realloc         Changes the size of a previously allocated block of memory.
        Free            Frees a previously allocated block of memory.
        GetSize         Returns the size in bytes of a previously allocated block of memory.
        DidAlloc        Determines if this instance of IMalloc was used to allocate the specified block of memory.
        HeapMinimize    Minimizes the heap as much as possible by releasing unused memory to the operating system, coalescing
                        adjacent free blocks and committing free pages. *)

     ppIMalloc = ^pIMalloc;
     pIMalloc = ^IMalloc;

     IMalloc = Class (IUnknown)
               Public
{&StdCall+}
                 Function Alloc (cb : LongInt) : Pointer;
                    virtual; abstract;
                 Function Realloc (pv : Pointer; cb : LongInt): Pointer;
                    virtual; abstract;
                 Procedure Free (pv : Pointer);
                    virtual; abstract;
                 Function GetSize (pv : Pointer) : LongInt;
                    virtual; abstract;
                 Function DidAlloc (pv : Pointer) : Integer;
                    virtual; abstract;
                 Procedure HeapMinimize;
                    virtual; abstract;
{&StdCall-}
               end;


     (* IMallocSpy interface
        ====================

        The IMallocSpy interface is a debugging interface that allows application developers to monitor (spy on) memory allocation,
        detect memory leaks and simulate memory failure in calls to IMalloc methods.


        Caution
        -------

        The IMallocSpy interface is intended to be used only to debug application code under development.
        Do not ship this interface to retail customers of your application, because it causes severe performance degradation and
        could conflict with user-installed software to produce unpredictable results.


        When to Implement
        -----------------

        Implement this interface to debug memory allocation during application development.


        When to Use
        -----------

        When an implementation of IMallocSpy is registered with CoRegisterMallocSpy, OLE calls the pair of IMallocSpy methods
        around the corresponding IMalloc method. You would not make direct calls to IMallocSpy methods.
        The OLE SDK contains a sample implementation of IMallocSpy. The call to the pre-method through the return from the
        corresponding post-method is guaranteed to be thread-safe in multi-threaded operations.

        IMallocSpy Methods
        ------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        PreAlloc            Called before invoking IMalloc::Alloc, and may extend or modify the allocation to store debug
                            information.
        PostAlloc           Called after invoking IMalloc::Alloc, taking as input a pointer to the IMalloc::Alloc caller's
                            allocation, and returning a pointer to the actual allocation.
        PreFree             Called before invoking IMalloc::Free to ensure that the pointer passed to IMalloc::Free points to
                            the beginning of the actual allocation.
        PostFree            Called after invoking IMalloc::Free.
        PreRealloc          Called before invoking IMalloc::Realloc.
        PostRealloc         Called after invoking IMalloc::Realloc.
        PreGetSize          Called by OLE just prior to any call to IMalloc::GetSize.
        PostGetSize         Called after invoking IMalloc::GetSize.
        PreDidAlloc         Called by OLE just prior to invoking IMalloc::DidAlloc.
        PostDidAlloc        Called after invoking IMalloc::DidAlloc.
        PreHeapMinimize     Called before invoking IMalloc::DidAlloc.
        PostHeapMinimize    Called after invoking IMalloc::HeapMinimize. *)

     ppIMallocSpy = ^pIMallocSpy;
     pIMallocSpy = ^IMallocSpy;

     IMallocSpy = Class (IUnknown)
                  Public
{&StdCall+}
                    Function PreAlloc (cbRequest : LongInt) : LongInt;
                       virtual; abstract;
                    Function PostAlloc (pActual : Pointer) : Pointer;
                       virtual; abstract;
                    Function PreFree (pRequest : Pointer; fSpyed : BOOL) : Pointer;
                       virtual; abstract;
                    Procedure PostFree (fSpyed : BOOL);
                       virtual; abstract;
                    Function PreRealloc (pRequest : Pointer; cbRequest : LongInt; var ppNewRequest : Pointer; fSpyed : BOOL) : LongInt;
                       virtual; abstract;
                    Function PostRealloc (pActual : Pointer; fSpyed : BOOL) : Pointer;
                       virtual; abstract;
                    Function PreGetSize (pRequest : Pointer; fSpyed : BOOL) : Pointer;
                       virtual; abstract;
                    Function PostGetSize (pActual : Pointer; fSpyed : BOOL) : LongInt;
                       virtual; abstract;
                    Function PostDidAlloc (pRequest : Pointer; fSpyed : BOOL; fActual : Integer) : Integer;
                       virtual; abstract;
                    Procedure PreHeapMinimize;
                       virtual; abstract;
                    Procedure PostHeapMinimize;
                       virtual; abstract;
{&StdCall-}
                  end;


     (* IStdMarshalInfo interface
        =========================

        The IStdMarshalInfo interface returns the CLSID identifying the handler to be used in the destination process during
        standard marshaling.

        An object that uses OLE's default implementation of IMarshal does not provide its own proxy but, by implementing
        IStdMarshalInfo, can nevertheless specify a handler to be loaded in the client process. Such a handler would typically
        handle certain requests in-process and use OLE's default marshaling to delegate others back to the original object.
        To create an instance of an object in some client process, COM must first determine whether the object uses default
        marshaling or its own implementation. If the object uses default marshaling, COM then queries the object to determine
        whether it uses a special handler or, simply, OLE's default proxy. To get the CLSID of the handler to be loaded, COM queries
        the object for the IStdMarshalInfo interface and then the IPersist interface. If neither interface is supported, a standard
        handler is used.

        When to Implement
        -----------------

        If you are writing a server application that supports class emulation (that is, if your server can manipulate objects of
        another type in response to the Activate As option in the Convert dialog box), you must implement the IStdMarshalInfo
        interface in order to return the CLSID of the handler to be used for the object.
        Note that your handler must aggregate the default handler.

        When to Use
        -----------

        You typically don't call this interface yourself. COM queries for this interface when performing standard marshaling.

        IStdMarshalInfo Methods
        -----------------------

        Methods Description
        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetClassForHandler      Retrieves the CLSID of the object handler to be used in the destination process during standard
                                marshaling. *)

     ppIStdMarshalInfo = ^pIStdMarshalInfo;
     pIStdMarshalInfo = ^IStdMarshalInfo;

     IStdMarshalInfo = Class (IUnknown)
                       Public
{&StdCall+}
                          Function GetClassForHandler (dwDestContext : LongInt; pvDestContext : Pointer; var clsid : TCLSID) : hResult;
                             virtual; abstract;
{&StdCall-}
                       end;


     (* IExternalConnection interface
        =============================

        The IExternalConnection interface enables an embedded object to keep track of external locks on it, thereby enabling the
        safe and orderly shutdown of the object following silent updates. An object that supports links either to itself or to
        some portion of itself (a range of cells in a spreadsheet, for example) should implement this interface to prevent
        possible loss of data during shutdown.

        Such data loss can occur when an object happens to have unsaved changes at a time when its stub manager's count of strong
        external references has reached zero. This situation would arise, for example, at the end of a silent update, when the
        final link client breaks its connection to the object. With the severing of this connection, the stub manager's count of
        strong external references would reach zero, causing it to release its pointers to an interface on the object and
        initiate shutdown of the object. When the object calls IOleClientSite::SaveObject, its container's return call to
        IPersistStorage::Save would fail because the stub manager would no longer have a pointer to any interface on the object.
        Any unsaved changes to the object would be lost.

        If the object manages its own count of external locks, rather than relying on the stub manager to do so, it can save its
        data before the stub manager has a chance to release its pointers. An object can obtain a count of external connections by
        implementing the IExternalConnection interface. The stub manager calls this interface whenever a new strong external
        reference is added or deleted. The object combines this count with its own tally of strong internal references to maintain
        an accurate total of all locks.

        When to Implement
        -----------------

        All embeddable compound-document objects that support links to themselves or portions of themselves should implement
        IExternalConnection to prevent possible data loss during shutdown. In addition, an in-place container should call
        OleLockRunning to hold a strong lock on its embedded objects.

        When to Use
        -----------

        An object's stub manager should call IExternalConnection whenever an external connection is added or released.

        IExternalConnection Methods
        ---------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        AddConnection       Increments an object's count of its strong external connections (links).
        ReleaseConnection   Decrements an object's count of its strong external connections (references). *)

     ppIExternalConnection = ^pIExternalConnection;
     pIExternalConnection = ^IExternalConnection;

     IExternalConnection = Class (IUnknown)
                           Public
{&StdCall+}
                             Function AddConnection (ExtConn : LongInt; Reserved : LongInt) : LongInt;
                                virtual; abstract;
                             Function ReleaseConnection (ExtConn : LongInt; Reserved : LongInt; fLastReleaseCloses : BOOL) : LongInt;
                                virtual; abstract;
{&StdCall-}
                           end;


     (* IWeakRef interface
        ==================

        IWeakRef Methods
        ----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        ChangeWeakCount
        ReleaseKeepAlive. *)

     ppIWeakRef = ^pIWeakRef;
     pIWeakRef = ^IWeakRef;

     IWeakRef = Class (IUnknown)
                Public
{&StdCall+}
                  Function ChangeWeakCount (Delta : LongInt) : LongInt;
                     virtual; abstract;
                  Function ReleaseKeepAlive (unkReleased : IUnknown; Reserved : LongInt) : LongInt;
                     virtual; abstract;
{&StdCall-}
                end;


     (* IEnumUnknown interface
        ======================

        This enumerator enumerates objects with the IUnknown interface. It can be used to enumerate through the objects in a
        component containing multiple objects. IEnumUnknown has the same methods as all enumerator interfaces: Next, Skip, Reset,
        and Clone. For general information on these methods, refer to IEnumXXXX.

        When to Implement
        -----------------

        You can implement this whenever you want a caller to be able to enumerate the objects contained in another object.
        You get a pointer to IEnumUnknown through a call to IOleContainer::EnumObjects.

        When to Use
        -----------

        Call the methods of IEnumUnknown to enumerate the objects in a compound document, when you get a pointer to the interface
        on the enumerator through a call to IOleContainer::EnumObjects.

        IEnumUnknown Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Next    Retrieves the next celt items in the enumeration sequence. If there are fewer than the requested number of elements
                left in the sequence, it retrieves the remaining elements. The number of elements actually retrieved is returned through
                pceltFetched (unless the caller passed in NULL for that parameter).
        Skip    Skips over the next specified number of elements in the enumeration sequence.
        Reset   Resets the enumeration sequence to the beginning.
        Clone   Creates another enumerator that contains the same enumeration state as the current one.
                Using this function, a client can record a particular point in the enumeration sequence, and then return to that
                point at a later time. The new enumerator supports the same interface as the original one. *)

     ppIEnumUnknown = ^pIEnumUnknown;
     pIEnumUnknown = ^IEnumUnknown;

     IEnumUnknown = Class (IUnknown)
                    Public
{&StdCall+}
                      Function Next (celt : LongInt; var elt; pceltFetched : pLongInt) : hResult;
                         virtual; abstract;
                      Function Skip (celt : LongInt) : hResult;
                         virtual; abstract;
                      Function Reset : hResult;
                         virtual; abstract;
                      Function Clone (var enm : IEnumUnknown) : hResult;
                         virtual; abstract;
{&StdCall-}
                    end;


     (* IBindCtx interface
        ==================

        The IBindCtx interface provides access to a bind context, which is an object that stores information about a particular
        moniker binding operation. You pass a bind context as a parameter when calling many methods of IMoniker and in certain
        functions related to monikers.

        A bind context includes the following information:

         A BIND_OPTS structure containing a set of parameters that do not change during the binding operation. When a composite
          moniker is bound, each component uses the same bind context, so it acts as a mechanism for passing the same parameters to
          each component of a composite moniker.
         A set of pointers to objects that the binding operation has activated. The bind context holds pointers to these bound
          objects, keeping them loaded and thus eliminating redundant activations if the objects are needed again during subsequent
          binding operations.
         A pointer to the Running Object Table on the machine of the process that started the bind operation. Moniker
          implementations that need to access the Running Object Table should use the IBindCtx::GetRunningObjectTable method rather
          than using the GetRunningObjectTable function. This allows future enhancements to the system's IBindCtx implementation to
          modify binding behavior.
         A table of interface pointers, each associated with a string key. This capability enables moniker implementations to
          store interface pointers under a well-known string so that they can later be retrieved from the bind context. For example,
          OLE defines several string keys (e.g., "ExceededDeadline", "ConnectManually") that can be used to store a pointer to the
          object that caused an error during a binding operation.

        When to Implement
        -----------------

        You do not need to implement this interface. The system provides an IBindCtx implementation, accessible though a call to
        the CreateBindCtx function, that is suitable for all situations.

        When to Use
        -----------

        Anyone writing a new moniker class by implementing the IMoniker interface must call IBindCtx methods in the implementation
        of several IMoniker methods. Moniker providers (servers that hand out monikers to identify their objects) may also need to
        call IBindCtx methods from their implementations of the IOleItemContainer or IParseDisplayName interfaces.
        Moniker clients (objects that use monikers to acquire interface pointers to other objects) typically don't call many
        IBindCtx methods. Instead, they simply pass a bind context as a parameter in a call to an IMoniker method. To acquire an
        interface pointer and activate the indicated object (called binding to an object), moniker clients typically do the
        following :

        1. Call the CreateBindCtx function to create a bind context and get a pointer to the IBindCtx interface on the bind
           context object.
        2. If desired (although this is rarely necessary), the moniker client can call IBindCtx::SetBindOptions to specify the
           bind options.
        3. Pass the bind context as a parameter to the desired IMoniker method (usually IMoniker::BindToObject).
        4. Call IUnknown::Release on the bind context to release it.

        Although applications that act as link containers (container applications that allow their documents to contain linked
        objects) are moniker clients, they rarely call IMoniker methods directly. Generally, they manipulate linked objects through
        the system implementation (in the default handler) of the IOleLink interface. This implementation calls the appropriate
        IMoniker methods as needed, and, in doing so, passes pointers to IBindCtx interfaces on the proper bind context objects.

        IBind Ctx Methods
        -----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        RegisterObjectBound     Calls IUnknown::AddRef on the specified object to ensure that the object remains active until the
                                bind context is released. The method stores a pointer to the object in the bind context's internal
                                list of pointers.
        RevokeObjectBound       Releases the IUnknown pointer to the specified object and removes that pointer from the bind
                                context's internal list of pointers.
                                This undoes a previous call to IBindCtx::RegisterObjectBound for the same object.
        ReleaseBoundObjects     Releases all pointers to all objects that were previously registered by calls to
                                IBindCtx::RegisterObjectBound.
        SetBindOptions          Specifies new values for the binding parameters stored in the bind context.
                                Subsequent binding operations can call IBindCtx::GetBindOptions to retrieve the parameters.
        GetBindOptions          Returns the binding options stored in this bind context.
        GetRunningObjectTable   Provides an interface pointer to the Running Object Table (ROT) for the machine on which this
                                bind context is running.
        RegisterObjectParam     Stores an IUnknown pointer on the specified object under the specified key in the bind context's
                                string-keyed table of pointers.
                                The method must call IUnknown::AddRef on the stored pointer.
        GetObjectParam          Retrieves the pointer associated with the specified key in the bind context's string-keyed table
                                of pointers.
        EnumObjectParam         Supplies a pointer to an IEnumString interface on an enumerator that can return the keys of the
                                bind context's string-keyed table of pointers.
        RevokeObjectParam       Removes the specified key and its associated pointer from the bind context's string-keyed table of
                                objects.
                                The key must have previously been inserted into the table with a call to IBindCtx::RegisterObjectParam. *)

     pBindOpts = ^tBindOpts;
     tagBIND_OPTS = Record
                      cbStruct : LongInt;
                      grfFlags : LongInt;
                      grfMode : LongInt;
                      dwTickCountDeadline : LongInt;
                    end;
     tBindOpts = tagBIND_OPTS;
     BIND_OPTS = tagBIND_OPTS;

     ppIBindCtx = ^pIBindCtx;
     pIBindCtx = ^IBindCtx;

     IBindCtx = Class (IUnknown)
                Public
{&StdCall+}
                  Function RegisterObjectBound (unk : IUnknown) : hResult;
                     virtual; abstract;
                  Function RevokeObjectBound (unk : IUnknown) : hResult;
                     virtual; abstract;
                  Function ReleaseBoundObjects : hResult;
                     virtual; abstract;
                  Function SetBindOptions (var BindOpts : tBindOpts) : hResult;
                     virtual; abstract;
                  Function GetBindOptions (var BindOpts : tBindOpts) : hResult;
                     virtual; abstract;
                  Function GetRunningObjectTable (var ROT : IRunningObjectTable) : hResult;
                     virtual; abstract;
                  Function RegisterObjectParam (pszKey : pOleStr; unk : IUnknown) : hResult;
                     virtual; abstract;
                  Function GetObjectParam (pszKey : pOleStr; var unk : IUnknown) : hResult;
                     virtual; abstract;
                  Function EnumObjectParam (var Enum : IEnumString) : hResult;
                     virtual; abstract;
                  Function RevokeObjectParam (pszKey : pOleStr) : hResult;
                     virtual; abstract;
{&StdCall-}
                end;


     (* IEnumMoniker interface
        ======================

        The IEnumMoniker interface is used to enumerate the components of a moniker or to enumerate the monikers in a table of
        monikers. IEnumMoniker has the same methods as all enumerator interfaces: Next, Skip, Reset, and Clone. For general
        information on these methods, refer to IEnumXXXX.

        When to Implement
        -----------------

        You need to implement IEnumMoniker if you are writing a new type of moniker and your monikers have an internal structure
        that can be enumerated. Your implementation of IMoniker::Enum must return an enumerator that implements IEnumMoniker and
        can enumerate your moniker's components. If your moniker has no structure that can be enumerated, your
        IMoniker::Enum method can simply return a NULL pointer.

        When to Use
        -----------

        Call the methods of the IEnumMoniker interface if you need to enumerate the components of a composite moniker, or to
        enumerate the monikers in a table.
        OLE defines two interfaces that supply an IEnumMoniker interface pointer:

         The IMoniker::Enum method gets a pointer to an IEnumMoniker implementation that can enumerate forwards or backwards
          through the components of the moniker. For a description of how two of the system-supplied types of monikers enumerate
          their components, see IMoniker - File Moniker Implementation and IMoniker - Generic Composite Moniker Implementation.
         The IRunningObjectTable::EnumRunning method returns a pointer to an IEnumMoniker implementation that can enumerate the
          monikers registered in a Running Object Table.

        IEnumMoniker Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Next    Retrieves the next celt items in the enumeration sequence. If there are fewer than the requested number of elements
                left in the sequence, it retrieves the remaining elements. The number of elements actually retrieved is returned through
                pceltFetched (unless the caller passed in NULL for that parameter).
        Skip    Skips over the next specified number of elements in the enumeration sequence.
        Reset   Resets the enumeration sequence to the beginning.
        Clone   Creates another enumerator that contains the same enumeration state as the current one.
                Using this function, a client can record a particular point in the enumeration sequence, and then return to that
                point at a later time. The new enumerator supports the same interface as the original one. *)

     ppIEnumMoniker = ^pIEnumMoniker;
     pIEnumMoniker = ^IEnumMoniker;

     IEnumMoniker = Class (IUnknown)
                    Public
{&StdCall+}
                      Function Next (celt : LongInt; var elt; pceltFetched : pLongInt) : hResult;
                         virtual; abstract;
                      Function Skip (celt : LongInt) : hResult;
                         virtual; abstract;
                      Function Reset : hResult;
                         virtual; abstract;
                      Function Clone (var enm : IEnumMoniker) : hResult;
                         virtual; abstract;
{&StdCall-}
                    end;


     (* IRunnableObject interface
        =========================

        The IRunnableObject interface enables a container to control the running of its embedded objects. In the case of an
        object implemented with a local server, calling IRunnableObject::Run launches the server's .EXE file. In the case of an
        object implemented with an in-process server, calling the Run method causes the object .DLL file to transition into the
        running state.

        When to Implement
        -----------------

        Object handlers should implement IRunnableObject to provide their containers with a way to run them and manage their
        running state. DLL object applications should implement IRunnableObject to support silent updates of their objects.

        When to Use
        -----------

        Containers call IRunnableObject to determine if an embedded object is running, to force an object to run, to lock an object
        into the running state, or to inform an object handler whether its object is being run as either a simple embedding or as a
        link source.

        IRunnableObject Methods
        -----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetRunningClass      Returns CLSID of a running object.
        Run                  Forces an object to run.
        IsRunning            Determines if an object is running.
        LockRunning          Locks an object into running state.
        SetContainedObject   Indicates that an object is embedded. *)

     ppIRunnableObject = ^pIRunnableObject;
     pIRunnableObject = ^IRunnableObject;

     IRunnableObject = Class (IUnknown)
                       Public
{&StdCall+}
                         Function GetRunningClass (var clsid : TCLSID) : hResult;
                            virtual; abstract;
                         Function Run (bc : IBindCtx) : hResult;
                            virtual; abstract;
                         Function IsRunning : BOOL;
                            virtual; abstract;
                         Function LockRunning (fLock : BOOL; fLastUnlockCloses : BOOL) : hResult;
                            virtual; abstract;
                         Function SetContainedObject (fContained : BOOL) : hResult;
                            virtual; abstract;
{&StdCall-}
                       end;


     (* IRunningObjectTable interface
        =============================

        The IRunningObjectTable interface manages access to the Running Object Table (ROT), a globally accessible look-up table
        on each workstation. A workstation's ROT keeps track of those objects that can be identified by a moniker and that are
        currently running on the workstation. When a client tries to bind a moniker to an object, the moniker checks the ROT to
        see if the object is already running; this allows the moniker to bind to the current instance instead of loading a new one.

        The ROT contains entries of the form : (pmkObjectName, pUnkObject)

        The pmkObjectName element is a pointer to the moniker that identifies the running object. The pUnkObject element is a
        pointer to the running object itself. During the binding process, monikers consult the pmkObjectName entries in the
        Running Object Table to see if an object is already running.
        Objects that can be named by monikers must be registered with the ROT when they are loaded and their registration must be
        revoked when they are no longer running.

        When to Implement
        -----------------

        You do not need to implement this interface. The system provides an implementation of the Running Object Table that is
        suitable for all situations.

        When to Use
        -----------

        You typically use the ROT if you're a moniker provider (that is, you hand out monikers identifying your objects to make
        them accessible to others) or if you're writing your own moniker class (that is, implementing the IMoniker interface).
        If you are a moniker provider, you register your objects with the ROT when they begin running and revoke their registrations
        when they are no longer running. This enables the monikers that you hand out to be bound to running objects. You should also
        use the ROT to record the object's last modification time. You can get an IRunningObjectTable interface pointer to the local
        ROT by calling the GetRunningObjectTable function.

        The most common type of moniker provider is a compound-document link source. This includes server applications that support
        linking to their documents (or portions of a document) and container applications that support linking to embeddings within
        their documents. Server applications that do not support linking can also use the ROT to cooperate with container
        applications that support linking to embeddings.
        If you are writing your own moniker class, you use the ROT to determine whether a object is running and to retrieve the
        object's last modification time. You can get an IRunningObjectTable interface pointer to the local ROT by calling the
        IBindCtx::GetRunningObjectTable method on the bind context for the current binding operation. Moniker implementations should
        always use the bind context to acquire a pointer to the ROT; this allows future implementations of IBindCtx to modify
        binding behavior. Note that you must also implement the IROTData interface on your moniker class in order to allow your
        monikers to be registered with the ROT.

        IRunningObjectTable Methods
        ---------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Register              Registers an object with the ROT.
        Revoke                Revokes an object's registration with the ROT.
        IsRunning             Checks whether an object is running.
        GetObject             Returns a pointer to an object given its moniker.
        NoteChangeTime        Notifies the ROT that an object has changed.
        GetTimeOfLastChange   Returns the time an object was last changed.
        EnumRunning           Returns an enumerator for the ROT. *)

     ppIRunningObjectTable = ^pIRunningObjectTable;
     pIRunningObjectTable = ^IRunningObjectTable;

     IRunningObjectTable = Class (IUnknown)
                           Public
{&StdCall+}
                             Function Register (grfFlags : LongInt; var unkObject : IUnknown; mkObjectName : IMoniker;
                                                var dwRegister: LongInt) : HResult;
                                virtual; abstract;
                             Function Revoke (dwRegister : LongInt) : hResult;
                                virtual; abstract;
                             Function IsRunning (mkObjectName : IMoniker) : hResult;
                                virtual; abstract;
                             Function GetObject (mkObjectName : IMoniker; var unkObject : IUnknown) : hResult;
                                virtual; abstract;
                             Function NoteChangeTime (dwRegister : LongInt; var FileTime : tFileTime) : hResult;
                                virtual; abstract;
                             Function GetTimeOfLastChange (mkObjectName : IMoniker; var FileTime : tFileTime) : hResult;
                                virtual; abstract;
                             Function EnumRunning (var EnumMoniker : IEnumMoniker) : hResult;
                                virtual; abstract;
{&StdCall-}
                           end;


     (* IPersist interface
        ==================

        The IPersist interface defines the single method GetClassID, which is designed to supply the CLSID of an object that can
        be stored persistently in the system.
        A call to this method can allow the object to specify which object handler to use in the process, as it is used in the
        OLE default implementation of marshaling.

        IPersist is the base interface for three other interfaces: IPersistStorage, IPersistStream, and IPersistFile.
        Each of these interfaces, therefore, includes the GetClassID method, and the appropriate one of these three interfaces
        is implemented on objects that can be serialized to a storage, a stream, or a file.
        The methods of these interfaces allow the state of these objects to be saved for later instantiations, and load the
        object using the saved state. Typically, the persistence interfaces are implemented by an embedded or linked object,
        and are called by the container application or the default object handler.

        When to Implement
        -----------------

        You must implement the single method of IPersist in implementing any one of the other persistence interfaces: IPersistStorage,
        IPersistStream, or IPersistFile. Typically, for example, you would implement IPersistStorage on an embedded object,
        IPersistFile on a linked object, and IPersistStream on a new moniker class, although their uses are not limited to these
        objects. You could implement IPersist in a situation where all that is required is to obtain the CLSID of a persistent
        object, as it is used in marshaling.

        When to Use
        -----------

        The single method of IPersist is rarely called directly in application code.
        It is called by the default object handler to get the CLSID of an embedded object, or an object to be marshaled.
        A container application, for example, would probably not call the GetClassID method directly unless it provided object
        handlers for specific classes of objects.

        IPersist Methods
        ----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetClassID      Retrieves the class identifier (CLSID) of an object.
                        The CLSID is a unique value that identifies the code that can manipulate the persistent data. *)

     ppIPersist = ^pIPersist;
     pIPersist = ^IPersist;

     IPersist = Class (IUnknown)
                Public
{&StdCall+}
                  Function GetClassID (var ClassID : TCLSID) : hResult;
                     virtual; abstract;
{&StdCall-}
                end;


     (* IPersistStream interface
        ========================

        The IPersistStream interface provides methods for saving and loading objects that use a simple serial stream for their
        storage needs. The IPersistStream interface inherits its definition from the IPersist interface, and so the includes the
        GetClassID method of IPersist.

        One way in which it is used is to support OLE moniker implementations. Each of the OLE-provided moniker interfaces
        provides an IPersistStream implementation through which the moniker saves or loads itself. An instance of the OLE generic
        composite moniker class calls the IPersistStream methods of its component monikers to load or save the components in the
        proper sequence in a single stream.
        OLE containers with embedded and linked component objects do not use this interface; they use the IPersistStorage
        interface instead.

        When to Implement
        -----------------

        Implement the IPersistStream interface on objects that are to be saved to a simple stream. Some objects of this type are
        monikers and some OLE controls, although generally, controls use the IPersistStreamInit interface, which has the same
        methods as IPersistStream, with one added method, IPersistStreamInit::InitNew. The IMoniker interface is derived from the
        IPersistStream interface, so you must implement the IPersistStream interface if you are implementing a new moniker class.

        When to Use
        -----------

        Call methods of IPersistStream from a container application to save or load objects that are contained in a simple stream.
        When used to save or load monikers, typical applications do not call the methods directly, but allow the default link
        handler to make the calls to save and load the monikers that identify the link source. These monikers are stored in a
        stream in the storage for the linked object. If you are writing a custom link handler for your class of objects, you would
        call the methods of IPersistStream to implement the link handler.

        IPersistStream Methods
        ----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IPersist.GetClassID
        IsDirty      Checks the object for changes since it was last saved.
        Load         Initializes an object from the stream where it was previously saved.
        Save         Saves an object into the specified stream and indicates whether the object should reset its dirty flag.
        GetSizeMax   Return the size in bytes of the stream needed to save the object. *)

     ppIPersistStream = ^pIPersistStream;
     pIPersistStream = ^IPersistStream;

     IPersistStream = Class (IPersist)
                      Public
{&StdCall+}
                        Function IsDirty : hResult;
                           virtual; abstract;
                        Function Load (stm : IStream) : hResult;
                           virtual; abstract;
                        Function Save (stm : IStream; fClearDirty : BOOL) : hResult;
                           virtual; abstract;
                        Function GetSizeMax (var cbSize : LargeInt) : hResult;
                           virtual; abstract;
{&StdCall-}
                      end;

     (* IMoniker interface
        ==================

        The IMoniker interface contains methods that allow you to use a moniker object, which contains information that uniquely
        identifies a COM object. An object that has a pointer to the moniker object's IMoniker interface can locate, activate,
        and get access to the identified object without having any other specific information on where the object is actually
        located in a distributed system.

        Like a path to a file in a file system, a moniker contains information that allows a COM object to be located and
        activated. Monikers can identify any type of COM object, from a document object stored in a file to a selection within an
        embedded object. OLE provides a set of moniker classes that allow you to create moniker objects identifying the objects
        most commonly found in the system. For example, there might be an object representing a range of cells in a spreadsheet
        which is itself embedded in a text document stored in a file. In a distributed system, this object's moniker would
        identify the location of the object's system, the file's physical location on that system, the storage of the embedded
        object within that file, and, finally, the location of the range of cells within the embedded object.

        A moniker object supports the IMoniker interface, which is derived from the IPersistStream interface, and uniquely
        identifies a single object in the system. Once an object providing a moniker has created the moniker object, this
        information cannot be changed within that object. If the moniker provider changes the information, it can only do so by
        creating a new moniker object, which would then uniquely identify the object in question.
        Monikers have two important capabilites:

         Monikers can be saved to a persistent storage. When a moniker is loaded back into memory, it still identifies the same
          object.
         Monikers support an operation called "binding," which is the process of locating the object named by the moniker,
          activating it (loading it into memory) if it is not already active, and returning a pointer to a requested interface on
          that object.

        Monikers are used as the basis for linking in OLE. A linked object contains a moniker that identifies its source. When the
        user activates the linked object to edit it, the moniker is bound; this loads the link source into memory.

        When to Implement
        -----------------

        Implement IMoniker only if you are writing a new moniker class. This is necessary only if you need to identify objects that
        cannot be identified using one of the OLE-supplied moniker classes described below.

        The OLE-supplied moniker classes are sufficient for most situations. Before considering writing your own moniker class, you
        should make sure that your requirements cannot be satisified by these classes.
        If you decide you need to write your own implementation of IMoniker, you must also implement the IROTData interface on your
        moniker class. This interface allows your monikers to be registered with the Running Object Table (ROT).

        When to Use
        -----------

        Two kinds of objects call the methods of IMoniker:

         A component that contains one or more objects to be identified with a moniker and must provide the moniker to other objects.
         A client object that must bind to the object identified by the moniker.

        The component providing a moniker makes it accessible to other objects. It is important to understand the differences
        between the various system-supplied moniker classes to know which are appropriate for a given object. OLE also provides
        functions for creating monikers using the OLE-supplied moniker classes.

         File monikers - based on a path in the file system. File monikers can be used to identify objects that are saved as
          files. The associated creation function is CreateFileMoniker.
         Item monikers - based on a string that identifies an object in a container. Item monikers can be used to identify
          objects smaller than a file, such as embedded objects in a compound document and pseudo-objects (like a range of cells in
          a spreadsheet). The associated creation function is CreateItemMoniker.
         Generic composite monikers - consists of two or more monikers of arbitrary type that have been composed together.
          Generic composite monikers allow monikers of different classes to be used in combination. The associated creation function
          is CreateGenericComposite.
         Anti-monikers - the inverse of file, item, or pointer monikers. Anti-monikers are used primarily for constructing
          relative monikers, which are analogous to relative path (such as "..\backup\report.old"), and which specify a location of
          an object relative to the location of another object). The associated creation function is CreateAntiMoniker.
           Pointer monikers - a non-persistent moniker that wraps an interface pointer to an object loaded in memory.
            Whereas most monikers identify objects that can be saved to persistent storage, pointer monikers identify objects that
            cannot. The associated creation function is CreatePointerMoniker.
            A moniker provider must also implement other interfaces to allow the monikers it hands out to be bound. OLE objects that
            commonly provide monikers are link sources. These include server applications that support linking and container
            applications that support linking to their embedded objects.
            Binding to an object means that a client uses a moniker to locate the object, activate it when necessary, and get a
            pointer to one of the active object's interfaces. The client of the moniker does not need to be aware of the class of the
            moniker  it must just get a pointer to the correct moniker's IMoniker interface. Monikers are used most often in this
            way by container applications that allow their documents to contain linked objects. However, link containers rarely call
            IMoniker methods directly. Instead, they generally manipulate linked objects through the default handler's implementation
            of the IOleLink interface, which calls the appropriate IMoniker methods as needed.
           Class monikers  these represent an object class. Class monikers bind to the class object of the class for which they are
            created. The associated creation function is CreateClassComposite.

          IMoniker Methods
          ----------------

          IUnknown.QueryInterface
          IUnknown.AddRef
          IUnknown.Release
          IPersist.GetClassID
          IPersistStream.IsDirty
          IPersistStream.Load
          IPersistStream.Save
          IPersistStream.GetSizeMax
          BindToObject          Binds to the object named by the moniker.
          BindToStorage         Binds to the object's storage.
          Reduce                Reduces the moniker to simplest form.
          ComposeWith           Composes with another moniker.
          Enum                  Enumerates component monikers.
          IsEqual               Compares with another moniker.
          Hash                  Returns a hash value.
          IsRunning             Checks whether object is running.
          GetTimeOfLastChange   Returns time the object was last changed.
          Inverse               Returns the inverse of the moniker.
          CommonPrefixWith      Finds the prefix that the moniker has in common with another moniker.
          RelativePathTo        Constructs a relative moniker between the moniker and another.
          GetDisplayName        Returns the display name.
          ParseDisplayName      Converts a display name into a moniker.
          IsSystemMoniker       Checks whether moniker is one of the system-supplied types. *)

     ppIMoniker = ^pIMoniker;
     pIMoniker = ^IMoniker;

     IMoniker = Class (IPersistStream)
                Public
{&StdCall+}
                  Function BindToObject (bc : IBindCtx; mkToLeft : IMoniker; const iidResult : TIID; var vResult) : hResult;
                     virtual; abstract;
                  Function BindToStorage (bc : IBindCtx; mkToLeft : IMoniker; const iid : TIID; var vObj) : hResult;
                     virtual; abstract;
                  Function Reduce (bc : IBindCtx; dwReduceHowFar : LongInt; var mkToLeft : IMoniker; var mkReduced : IMoniker) : hResult;
                     virtual; abstract;
                  Function ComposeWith (mkRight : IMoniker; fOnlyIfNotGeneric : BOOL; var mkComposite : IMoniker) : hResult;
                     virtual; abstract;
                  Function Enum (fForward : BOOL; var enumMoniker : IEnumMoniker) : hResult;
                     virtual; abstract;
                  Function IsEqual (mkOtherMoniker : IMoniker) : hResult;
                     virtual; abstract;
                  Function Hash (var dwHash : LongInt) : hResult;
                     virtual; abstract;
                  Function IsRunning (bc : IBindCtx; mkToLeft : IMoniker; mkNewlyRunning : IMoniker) : hResult;
                     virtual; abstract;
                  Function GetTimeOfLastChange (bc : IBindCtx; mkToLeft : IMoniker; var filetime : tFileTime) : hResult;
                     virtual; abstract;
                  Function Inverse (var mk : IMoniker) : hResult;
                     virtual; abstract;
                  Function CommonPrefixWith (mkOther : IMoniker; var mkPrefix : IMoniker) : hResult;
                     virtual; abstract;
                  Function RelativePathTo (mkOther : IMoniker; var mkRelPath : IMoniker) : hResult;
                     virtual; abstract;
                  Function GetDisplayName (bc : IBindCtx; mkToLeft : IMoniker; var pszDisplayName : pOleStr) : hResult;
                     virtual; abstract;
                  Function ParseDisplayName (bc : IBindCtx; mkToLeft : IMoniker; pszDisplayName : pOleStr; var chEaten : LongInt;
                                             var mkOut : IMoniker) : hResult;
                     virtual; abstract;
                  Function IsSystemMoniker (var dwMksys : LongInt) : hResult;
                     virtual; abstract;
{&StdCall-}
                end;


     (* IEnumString interface
        =====================

        IEnumString is defined to enumerate strings. LPWSTR is the type that indicates a pointer to a zero-terminated string of
        wide, i.e., Unicode, characters. IEnumString has the same methods as all enumerator interfaces: Next, Skip, Reset, and
        Clone. For general information on these methods, refer to IEnumXXXX.

        When to Implement
        -----------------

        It is usually not necessary to implement this interface unless you have use for a custom string enumerator. A system
        implementation in the bind context object on which is the IBindCtx interface also contains an implementation of
        IEnumString. IBindCtx::EnumObjectParam returns a pointer to this IEnumString interface on an enumerator that can return
        the keys of the bind context's string-keyed table of pointers.

        When to Use
        -----------

        Call the methods of IEnumString to enumerate through a set of strings.

        IEnumString Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Next    Retrieves the next celt items in the enumeration sequence. If there are fewer than the requested number of elements
                left in the sequence, it retrieves the remaining elements. The number of elements actually retrieved is returned through
                pceltFetched (unless the caller passed in NULL for that parameter).
        Skip    Skips over the next specified number of elements in the enumeration sequence.
        Reset   Resets the enumeration sequence to the beginning.
        Clone   Creates another enumerator that contains the same enumeration state as the current one.
                Using this function, a client can record a particular point in the enumeration sequence, and then return to that
                point at a later time. The new enumerator supports the same interface as the original one. *)

     ppIEnumString = ^pIEnumString;
     pIEnumString = ^IEnumString;

     IEnumString = Class (IUnknown)
                   Public
{&StdCall+}
                     Function Next (celt : LongInt; var elt; pceltFetched : pLongInt) : hResult;
                        virtual; abstract;
                     Function Skip (celt : LongInt) : hResult;
                        virtual; abstract;
                     Function Reset : hResult;
                        virtual; abstract;
                     Function Clone (var enm : IEnumString) : hResult;
                        virtual; abstract;
{&StdCall-}
                   end;


     (* IStream interface
        =================

        The IStream interface supports reading and writing data to stream objects. Stream objects contain the data in a structured
        storage object, where storages provide the structure. Simple data can be written directly to a stream, but most frequently,
        streams are elements nested within a storage object. They are similar to standard files.

        The IStream interface defines methods similar to the MS-DOS FAT file functions. For example, each stream object has its own
        access rights and a seek pointer. The main difference between a stream object and a DOS file is that streams are not opened
        using a file handle, but through an IStream interface pointer.
        The methods in this interface present your object's data as a contiguous sequence of bytes that you can read or write.
        There are also methods for committing and reverting changes on streams open in transacted mode and methods for restricting
        access to a range of bytes in the stream.

        Streams can remain open for long periods of time without consuming file system resources. The IStream::Release method is
        similar to a close function on a file. Once released, the stream object is no longer valid and cannot be used.

        When to Implement
        -----------------

        Implement IStream on a container or object application when you require functionality not provided by the OLE compound file
        implementation. The specification of IStream defines more functionality that the OLE implementation supports. In addition,
        if you are creating a stream object that is larger than the heap in your machine's memory and you are using a global memory
        handle, the compound file implementation calls GlobalRealloc internally whenever it needs more memory, which can be
        extremely inefficient. In this case, the preferred solution is to implement an IStream that uses memory allocated by
        VirtualAlloc instead of GlobalAlloc. This can reserve a large chunk of virtual address space and then commit memory within
        that address space as required. No data copying occurs and memory is committed only as it is needed. For more information,
        refer to IStream - Compound File Implementation.

        When to Use
        -----------

        Call the methods of the IStream interface from a container or application to read and write the data for an object. Since
        stream objects can be marshaled to other processes, applications can share the data in storage objects without having to use
        global memory.

        IStream Methods
        ---------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Read            Reads a specified number of bytes from the stream object into memory starting at the current seek pointer.
        Write           Writes a specified number from bytes into the stream object starting at the current seek pointer.
        Seek            Changes the seek pointer to a new location relative to the beginning of the stream, the end of the stream,
                        or the current seek pointer.
        SetSize         Changes the size of the stream object.
        CopyTo          Copies a specified number of bytes from the current seek pointer in the stream to the current seek pointer in
                        another stream.
        Commit          Ensures that any changes made to a stream object open in transacted mode are reflected in the parent storage.
                        If the stream object is open in direct mode, IStream::Commit has no effect other than flushing all memory
                        buffers to the next level storage object. The OLE compound file implementation of streams does not support
                        opening streams in transacted mode.
        Revert          Discards all changes that have been made to a transacted stream since the last IStream::Commit call.
                        On streams open in direct mode and streams using the OLE compound file implementation of IStream::Revert,
                        this method has no effect.
        LockRegion      Restricts access to a specified range of bytes in the stream. Supporting this functionality is optional
                        since some file systems do not provide it.
        UnlockRegion    Removes the access restriction on a range of bytes previously restricted with IStream::LockRegion.
        Stat            Retrieves the STATSTG structure for this stream.
        Clone           Creates a new stream object that references the same bytes as the original stream but provides a separate
                        seek pointer to those bytes. *)

     pStatStg = ^tStatStg;
     TagSTATSTG = Record
                    pwcsName : pOleStr;
                    dwType : Longint;
                    cbSize : LargeInt;
                    mTime : tFileTime;
                    cTime : tFileTime;
                    aTime: tFileTime;
                    grfMode : Longint;
                    grfLocksSupported : LongInt;
                    clsid : TCLSID;
                    grfStateBits : LongInt;
                    Reserved : Longint;
                  end;
     tStatStg = TagSTATSTG;
     STATSTG = TagSTATSTG;

     ppIStream = ^pIStream;
     pIStream = ^IStream;

     IStream = Class (IUnknown)
               Public
{&StdCall+}
                 Function Read (pv : Pointer; cb : LongInt; pcbRead : pLongInt) : hResult;
                    virtual; abstract;
                 Function Write (pv : Pointer; cb : LongInt; pcbWritten : pLongInt) : hResult;
                    virtual; abstract;
                 Function Seek (dlibMove : LargeInt; dwOrigin : LongInt; var libNewPosition : LargeInt) : hResult;
                    virtual; abstract;
                 Function SetSize (LibNewSize : LargeInt) : hResult;
                    virtual; abstract;
                 Function CopyTo (stm : IStream; cb : LargeInt; var cbRead : LargeInt; var cbWritten : LargeInt) : hResult;
                    virtual; abstract;
                 Function Commit (grfCommitFlags : LongInt) : hResult;
                    virtual; abstract;
                 Function Revert : hResult;
                    virtual; abstract;
                 Function LockRegion (LibOffset : LargeInt; cb : LargeInt; dwLockType : LongInt) : hResult;
                    virtual; abstract;
                 Function UnlockRegion (LibOffset : LargeInt; cb : LargeInt; dwLockType : LongInt) : hResult;
                    virtual; abstract;
                 Function Stat (var StatStg : tStatStg; grfStatFlag : LongInt) : hResult;
                    virtual; abstract;
                 Function Clone (var stm : IStream) : hResult;
                    virtual; abstract;
{&StdCall-}
               end;


     (* IEnumStatStg interface
        ======================

        The IEnumSTATSTG interface is used to enumerate through an array of STATSTG structures, which contain statistical
        information about an open storage, stream, or byte array object. IEnumSTATSTG has the same methods as all enumerator
        interfaces: Next, Skip, Reset, and Clone. For general information on these methods, refer to IEnumXXXX.

        When to Implement
        -----------------

        IEnumSTATSTG is implemented to enumerate the elements of a storage object. If you are using the compound file
        implementation of the storage object, a pointer to which is available through a call to StgCreateDocfile, IEnumSTATSTG is
        implemented on that object, and a pointer is returned through a call to IStorage::EnumElements. If you are doing a custom
        implementation of a storage object, you need to implement IEnumSTATSTG to fill in a caller-allocated array of STATSTG
        structures, each of which contains information about the nested elements in the storage object.

        When to Use
        -----------

        Containers call methods that return a pointer to IEnumSTATSTG so the container can manage its storage object and the
        elements within it. Calls to the IStorage::EnumElements method supplies a pointer to IEnumSTATDATA. The caller allocates
        an array of STATSTG structures and the IEnumSTATSTG methods fill in each structure with the statistics about one of the
        nested elements in the storage object. If present, the lpszName member of the STATSTG structure requires additional memory
        allocations through the IMalloc interface, and the caller is responsible for freeing this memory, if it is allocated, by
        calling the IMalloc::Free method. If the lpszName member is NULL, no memory is allocated, and, therefore, no memory needs to be freed.

        IEnumStatStg Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Next    Retrieves the next celt items in the enumeration sequence. If there are fewer than the requested number of elements
                left in the sequence, it retrieves the remaining elements. The number of elements actually retrieved is returned through
                pceltFetched (unless the caller passed in NULL for that parameter).
        Skip    Skips over the next specified number of elements in the enumeration sequence.
        Reset   Resets the enumeration sequence to the beginning.
        Clone   Creates another enumerator that contains the same enumeration state as the current one.
                Using this function, a client can record a particular point in the enumeration sequence, and then return to that
                point at a later time. The new enumerator supports the same interface as the original one. *)

     ppIEnumStatStg = ^pIEnumStatStg;
     pIEnumStatStg = ^IEnumStatStg;

     IEnumStatStg = Class (IUnknown)
                    Public
{&StdCall+}
                      Function Next (celt : LongInt; var elt; pceltFetched : pLongInt) : hResult;
                         virtual; abstract;
                      Function Skip (celt : LongInt): hResult;
                         virtual; abstract;
                      Function Reset : hResult;
                         virtual; abstract;
                      Function Clone (var enm : IEnumStatStg) : hResult;
                         virtual; abstract;
{&StdCall-}
                    end;


     (* IStorage interface
        ==================

        The IStorage interface supports the creation and management of structured storage objects. Structured storage allows
        hierarchical storage of information within a single file, and is often referred to as "a file system within a file".
        Elements of a structured storage object are storages and streams. Storages are analogous to directories, and streams are
        analogous to files. Within a structured storage there will be a primary storage object that may contain substorages,
        possibly nested, and streams. Storages provide the structure of the object, and streams contain the data, which is
        manipulated through the IStream interface.

        The IStorage interface provides methods for creating and managing the root storage object, child storage objects, and
        stream objects. These methods can create, open, enumerate, move, copy, rename, or delete the elements in the storage
        object.
        An application must release its IStorage pointers when it is done with the storage object to deallocate memory used.
        There are also methods for changing the date and time of an element.
        There are a number of different modes in which a storage object and its elements can be opened, determined by setting
        values from the STGM enumeration. One aspect of this is how changes are committed. You can set direct mode, in which in
        which changes to an object are immediately written to it, or transacted mode, in which changes are written to a buffer
        until explicitly committed. The IStorage interface provides methods for committing changes and reverting to the
        last-committed version. Other storage modes set, for example, a stream can be opened in read only mode or read/write mode.
        For more information, refer to the STGM enumeration.

        Other methods provide a means to gain access to information about a storage object and its elements through the STATSTG
        structure.

        When to Implement
        -----------------

        Generally, you would not implement this interface unless you were defining a new storage scheme for your system. OLE
        provides a compound file implementation of the IStorage interface that supports transacted access. OLE provides a set of
        helper APIs to facilitate using the compound file implementation of storage objects. Refer to IStorage - Compound File
        Implementation.

        When to Use
        -----------

        Call the methods of IStorage to manage substorages or streams within the current storage. This management includes creating,
        opening, or destroying sub-storages or streams, as well as managing aspects such as time stamps, names, etc. You can also
        commit changes or revert to previous version for storages opened in transacted mode. The methods of IStorage do not include
        means to read and write datathis is reserved for IStream, which manages the actual data. While the IStorage and IStream
        interfaces are used to manipulate the storage object and its elements, the IPersistStorage interface contains methods that
        are called to serialize the storage object and its elements to a disk file.

        IStorage Methods
        ----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        CreateStream      Creates and opens a stream object with the specified name contained in this storage object.
        OpenStream        Opens an existing stream object within this storage object using the specified access permissions in
                          grfMode.
        CreateStorage     Creates and opens a new storage object within this storage object.
        OpenStorage       Opens an existing storage object with the specified name according to the specified access mode.
        CopyTo            Copies the entire contents of this open storage object into another storage object. The layout of the
                          destination storage object may differ.
        MoveElementTo     Copies or moves a substorage or stream from this storage object to another storage object.
        Commit            Reflects changes for a transacted storage object to the parent level.
        Revert            Discards all changes that have been made to to the storage object since the last commit operation.
        EnumElements      Returns an enumerator object that can be used to enumerate the storage and stream objects contained
                          within this storage object.
        DestroyElement    Removes the specified storage or stream from this storage object.
        RenameElement     Renames the specified storage or stream in this storage object.
        SetElementTimes   Sets the modification, access, and creation times of the indicated storage element, if supported by the
                          underlying file system.
        SetClass          Assigns the specified CLSID to this storage object.
        SetStateBits      Stores up to 32 bits of state information in this storage object.
        Stat              Returns the STATSTG structure for this open storage object. *)

     TSNB = ^pOleStr;

     ppIStorage = ^pIStorage;
     pIStorage = ^IStorage;

     IStorage = Class (IUnknown)
                Public
{&StdCall+}
                  Function CreateStream (pwcsName : pOleStr; grfMode : LongInt; Reserved1 : LongInt; Reserved2 : LongInt;
                                         var stm : IStream) : hResult;
                     virtual; abstract;
                  Function OpenStream (pwcsName : pOleStr; Reserved1 : Pointer; grfMode : LongInt; Reserved2 : LongInt;
                                       var stm : IStream) : hResult;
                     virtual; abstract;
                  Function CreateStorage (pwcsName : pOleStr; grfMode : LongInt; dwStgFmt : LongInt; Reserved2 : LongInt;
                                          var stg : IStorage) : hResult;
                     virtual; abstract;
                  Function OpenStorage (pwcsName : pOleStr; stgPriority : IStorage; grfMode : LongInt; snbExclude : TSNB;
                                        Reserved : LongInt; var stg : IStorage) : hResult;
                     virtual; abstract;
                  Function CopyTo (ciidExclude : LongInt; rgiidExclude : PIID; snbExclude : TSNB; stgDest : IStorage) : hResult;
                     virtual; abstract;
                  Function MoveElementTo (pwcsName : pOleStr; stgDest : IStorage; pwcsNewName : pOleStr; grfFlags : LongInt) : hResult;
                     virtual; abstract;
                  Function Commit (grfCommitFlags : LongInt) : hResult;
                     virtual; abstract;
                  Function Revert : hResult;
                     virtual; abstract;
                  Function EnumElements (Reserved1 : LongInt; Reserved2 : Pointer; Reserved3 : LongInt;
                                         var enm : IEnumStatStg) : hResult;
                     virtual; abstract;
                  Function DestroyElement (pwcsName : pOleStr) : hResult;
                     virtual; abstract;
                  Function RenameElement (pwcsOldName : pOleStr; pwcsNewName : pOleStr) : hResult;
                     virtual; abstract;
                  Function SetElementTimes (pwcsName : pOleStr; const ctime : tFileTime; const atime : tFileTime;
                                            const mtime : tFileTime) : hResult;
                     virtual; abstract;
                  Function SetClass (const clsid : TCLSID) : hResult;
                     virtual; abstract;
                  Function SetStateBits (grfStateBits : LongInt; grfMask : LongInt) : hResult;
                     virtual; abstract;
                  Function Stat (var statstg : tStatStg; grfStatFlag : LongInt) : hResult;
                     virtual; abstract;
{&StdCall-}
                end;


     (* IPersistFile interface
        ======================

        The IPersistFile interface provides methods that permit an object to be loaded from or saved to a disk file, rather than
        a storage object or stream. Because the information needed to open a file varies greatly from one application to another,
        the implementation of IPersistFile::Load on the object must also open its disk file.

        The IPersistFile interface inherits its definition from IPersist, so all implementations must also include the
        GetClassID method of IPersist.

        When to Implement
        -----------------

        Implement IPersistFile when you want to read or write information from a separate file, which could be of any file format.
        This interface should be implemented on any objects that support linking through a file moniker, including the following:
         Any object that supports links to its files or to pseudo-objects within its files
         A container application that supports links to objects within its compound file.

        Typically, you implement the IPersistFile interface as part of an aggregate object that includes other interfaces that are
        appropriate for the type of moniker binding that is supported.
        For example, in either of the cases mentioned above, the moniker for the linked object can be a composite moniker.
        In the first case, a composite moniker identifies the pseudo-object contained within the file.
        In the second case, a composite moniker indentifies the embedded object contained within the compound file.
        In either case of composite monikers, you must implement the IPersistFile interface as part of the same object on which
        the IOleItemContainer interface is implemented. Then, when the application for the linked object is run, OLE queries for
        the IOleItemContainer interface to locate the embedded object or the pseudo-object contained in the file.

        As another example, if the moniker is a simple file moniker (i.e., the link is to the entire file), OLE queries for the
        interface that the initiator of the bind operation requested.
        Typically, this is one of the compound document interfaces, such as IOleObject, IDataObject, or IPersistStorage.

        When to Use
        -----------

        Call methods in the IPersistFile interface to load or save a linked object in a specified file.
        When IPersistFile is implemented on an object that supports linking through a file moniker and the application for the
        linked object is run, OLE calls IPersistFile::Load. Once the file is loaded, OLE calls IPersistFile::QueryInterface to
        get another interface pointer to the loaded object. The IPersistFile interface is typically part of an aggregate object
        that offers other interfaces.

        In this case, the only IPersistFile method that OLE calls is the Load method to load a file linked to a container,
        running the application associated with the file. It would also be unusual for applications to call other methods in
        this case, which support saving an object to a file. Generally, it is left to the end user and the application for the
        linked object to decide when to save the object. This differs from the situation for an embedded object, in which the
        container application uses the IPersistStorage interface to provide the storage and to tell the object when to save itself.

        IPersistFile Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IPersist.GetClassID
        IsDirty         Checks an object for changes since it was last saved to its current file.
        Load            Opens the specified file and initializes an object from the file contents.
        Save            Saves the object into the specified file.
        SaveCompleted   Notifies the object that it can write to its file. It does this by notifying the object that it can
                        revert from NoScribble mode (in which it must not write to its file), to Normal mode (in which it can).
                        The component enters NoScribble mode when it receives an IPersistFile::Save call.
        GetCurFile      Retrieves either the absolute path to the object's current working file or, if there is no current
                        working file, the object's default filename prompt. *)

     ppIPersistFile = ^pIPersistFile;
     pIPersistFile = ^IPersistFile;

     IPersistFile = Class (IPersist)
                    Public
{&StdCall+}
                      Function IsDirty : hResult;
                         virtual; abstract;
                      Function Load (pszFileName : pOleStr; dwMode : LongInt) : hResult;
                         virtual; abstract;
                      Function Save (pszFileName : pOleStr; fRemember : BOOL) : hResult;
                         virtual; abstract;
                      Function SaveCompleted (pszFileName : pOleStr) : hResult;
                         virtual; abstract;
                      Function GetCurFile (var pszFileName : pOleStr) : hResult;
                         virtual; abstract;
{&StdCall-}
                    end;


     (* IPersistStorage interface
        =========================

        The IPersistStorage interface defines methods that enable a container application to pass a storage object to one of its
        contained objects and to load and save the storage object. This interface supports the structured storage model, in which
        each contained object has its own storage that is nested within the container's storage.

        The IPersistStorage contract inherits its definition from IPersist, so all implementations must also include the
        GetClassID method of IPersist.

        When to Implement
        -----------------

        Any object that can be embedded in a container must implement the IPersistStorage interface. This interface is one of the
        primary interfaces for a compound document object. Embeddable objects must also implement the IOleObject and IDataObject
        interfaces.
        The OLE default handler for embedded objects provides an implementation of the IPersistStorage interface that is used when
        the object is in the loaded state. Similarly, the OLE default link handler provides an IPersistStorage implementation that
        manages storage for a linked object. These default handlers both interact with the OLE default cache implementation, which
        has its own IPersistStorage implementation.

        If you are providing a custom embedding or link handler for your objects, the handler must include an implementation of
        IPersistStorage. You can delegate calls to the default handler so you can take advantage of the default cache
        implementation.

        When to Use
        -----------

        When an OLE container creates a new object, loads an existing object from storage, or inserts a new object in a clipboard or
        a drag-and-drop operation, the container uses the IPersistStorage interface to initialize the object and put it in the loaded
        or running state. When an object is loaded or running, an OLE container calls other IPersistStorage methods to instruct the
        object to perform various save operations or to release its storage.
        Typically, applications use helper functions such as OleLoad or OleCreate, rather than calling the IPersistStorage::Load or
        IPersistStorage::InitNew methods directly. Similarly, applications typically call the OleSave helper function rather than
        calling IPersistStorage::Save directly.

        IPersistStorage Methods
        -----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IPersist.GetClassID
        IsDirty           Indicates whether the object has changed since it was last saved to its current storage.
        InitNew           Initializes a new storage object.
        Load              Initializes an object from its existing storage.
        Save              Saves an object, and any nested objects that it contains, into the specified storage object.
                          The object enters NoScribble mode.
        SaveCompleted     Notifies the object that it can revert from NoScribble or HandsOff mode, in which in must not write to
                          its storage object, to Normal mode in which it can.
        HandsOffStorage   Instructs the object to release all storage objects that have been passed to it by its container and to
                          enter HandsOffAfterSave or HandsOffFromNormal mode. *)

     ppIPersistStorage = ^pIPersistStorage;
     pIPersistStorage = ^IPersistStorage;

     IPersistStorage = Class (IPersist)
                       Public
{&StdCall+}
                         Function IsDirty : hResult;
                            virtual; abstract;
                         Function InitNew (stg : IStorage) : hResult;
                            virtual; abstract;
                         Function Load (stg : IStorage) : hResult;
                            virtual; abstract;
                         Function Save (stgSave : IStorage; fSameAsLoad : BOOL) : hResult;
                            virtual; abstract;
                         Function SaveCompleted (stgNew : IStorage) : hResult;
                            virtual; abstract;
                         Function HandsOffStorage : hResult;
                            virtual; abstract;
{&StdCall-}
                       end;


     (* ILockBytes interface
        ====================

        The ILockBytes interface is implemented on a byte array object that is backed by some physical storage, such as a disk
        file, global memory, or a database. It is used by an OLE compound file storage object to give its root storage access to
        the physical device, while isolating the root storage from the details of accessing the physical storage.

        When to Implement
        -----------------

        Most applications will not implement the ILockBytes interface because OLE provides implementations for the two most common
        situations:
        File-based implementation  If you call StgCreateDocfile function to create a compound file storage object, it contains an
        implementation of ILockBytes that is associated with a byte array stored in a physical disk file. The compound file
        storage object calls the ILockBytes methodsyou do not call them directly in this implementation.

        Memory-based implementation  OLE also provides a byte array object based on global memory that supports an implementation
        of ILockBytes. You can get a pointer through a call to the CreateILockBytesOnHGlobal function). Then, to create a compound
        file storage object on top of that byte array object, call the StgCreateDocfileOnILockBytes function. The compound file
        storage object calls the ILockBytes methods  you do not call them directly in this implementation.

        There are situations in which it would be useful for an application to provide its own ILockBytes implementation. For
        example, a database application could implement ILockBytes to create a byte array object backed by the storage of its
        relational tables. However, it is strongly recommended that you use the OLE-provided implementations. For a discussion of
        the advantages of using the OLE implementations rather than creating your own, see the StgCreateDocfileOnILockBytes API
        function, which creates a compound file storage object on top of a caller-provided byte array object.

        If you choose to implement your own ILockBytes interface, you should consider providing custom marshaling by implementing
        the IMarshal interface as part of your byte array object. The reason for this is that when the OLE-provided
        implementations of IStorage and IStream are marshaled to another process, their ILockBytes interface pointers are also
        marshaled to the other process. The default marshaling mechanism creates a proxy byte array object (on which is the
        ILockBytes interface) that transmits method calls back to the original byte array object. Custom marshaling can improve
        efficiency by creating a remote byte array object that can access the byte array directly.

        When to Use
        -----------

        The ILockBytes methods are called by the OLE implementations of IStorage and IStream on the compound file object. Unless
        you are implementing IStorage and IStream, you would not need to call ILockBytes methods directly. If you write your own
        ILockBytes implementation, you can use the StgCreateDocfileOnILockBytes function to create a compound file storage object
        backed by your implementation of ILockBytes.

        ILockBytes Methods
        ------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        ReadAt         Reads a specified number of bytes starting at a specified offset from the beginning of the byte array.
        WriteAt        Writes a specified number of bytes to a specified location in the byte array.
        Flush          Ensures that any internal buffers maintained by the byte array object are written out to the backing storage.
        SetSize        Changes the size of the byte array.
        LockRegion     Restricts access to a specified range of bytes in the byte array.
        UnlockRegion   Removes the access restriction on a range of bytes previously restricted with ILockBytes::LockRegion.
        Stat           Retrieves a STATSTG structure for this byte array object. *)

     ppILockBytes = ^pILockBytes;
     pILockBytes = ^ILockBytes;

     ILockBytes = Class (IUnknown)
                  Public
{&StdCall+}
                    Function ReadAt (ulOffset : LargeInt; pv : Pointer; cb : LongInt; pcbRead : pLongint) : hResult;
                       virtual; abstract;
                    Function WriteAt (ulOffset : LargeInt; pv : Pointer; cb : LongInt; pcbWritten : pLongint) : hResult;
                       virtual; abstract;
                    Function Flush : hResult;
                       virtual; abstract;
                    Function SetSize (cb : LargeInt) : hResult;
                       virtual; abstract;
                    Function LockRegion (LibOffset : LargeInt; cb : LargeInt; dwLockType : LongInt): hResult;
                       virtual; abstract;
                    Function UnlockRegion (LibOffset : LargeInt; cb : LargeInt; dwLockType : LongInt) : hResult;
                       virtual; abstract;
                    Function Stat(var statstg: TStatStg; grfStatFlag: Longint): HResult;
                       virtual; abstract;
{&StdCall-}
                  end;


     (* IEnumFormatEtc interface
        ========================

        The IEnumFORMATETC interface is used to enumerate an array of FormatEtc structures. IEnumFORMATETC has the same methods
        as all enumerator interfaces: Next, Skip, Reset, and Clone. For general information on these methods, refer to IEnumXXXX.

        When to Implement
        -----------------

        IEnumFORMATETC must be implemented by all data objects to support calls to IDataObject::EnumFormatEtc, which supplies a
        pointer to the enumerator's IEnumFORMATETC interface. If the data object supports a different set of FormatEtc
        information depending on the direction of the data (whether a call is intended for the SetData or GetData method of
        IDataObject), the implementation of IEnumFORMATETC must be able to operate on both.

        The order of formats enumerated through the IEnumFORMATETC object should be the same as the order that the formats would
        be in when placed on the clipboard. Typically, this order starts with private data formats and ends with presentation
        formats such as CF_METAFILEPICT.

        When to Use
        -----------

        Call the methods of IEnumFORMATETC when you need to enumerate the FormatEtc structures defining the formats and media
        supported by a given data object. This is necessary in most data transfer operations, such as clipboard and drag-and-drop,
        so the object on the other end of the data transfer can determine whether the appropriate format and media for the data is
        supported.

        IEnumFormatEtc Methods
        ----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Next    Retrieves the next celt items in the enumeration sequence. If there are fewer than the requested number of elements
                left in the sequence, it retrieves the remaining elements. The number of elements actually retrieved is returned through
                pceltFetched (unless the caller passed in NULL for that parameter).
        Skip    Skips over the next specified number of elements in the enumeration sequence.
        Reset   Resets the enumeration sequence to the beginning.
        Clone   Creates another enumerator that contains the same enumeration state as the current one.
                Using this function, a client can record a particular point in the enumeration sequence, and then return to that
                point at a later time. The new enumerator supports the same interface as the original one. *)


     pDVTargetDevice = ^tDVTargetDevice;
     tagDVTARGETDEVICE = Record
                           tdSize : LongInt;
                           tdDriverNameOffset : Word;
                           tdDeviceNameOffset : Word;
                           tdPortNameOffset : Word;
                           tdExtDevmodeOffset : Word;
                           tdData : Record
                                    end;
                         end;
     tDVTargetDevice = tagDVTARGETDEVICE;
     DVTARGETDEVICE = tagDVTARGETDEVICE;

     pClipFormat = ^tClipFormat;
     tClipFormat = Word;

     pFormatEtc = ^tFormatEtc;
     tagFORMATETC = Record
                      cfFormat : tClipFormat;
                      ptd : pDVTargetDevice;
                      dwAspect : LongInt;
                      lIndex : LongInt;
                      tymed : LongInt;
                    end;
     tFormatEtc = tagFORMATETC;
     FormatEtc = tagFORMATETC;

     ppIEnumFormatEtc = ^pIEnumFormatEtc;
     pIEnumFormatEtc = ^IEnumFormatEtc;

     IEnumFormatEtc = Class (IUnknown)
                      Public
{&StdCall+}
                        Function Next (celt : LongInt; var elt; pceltFetched : pLongInt) : hResult;
                           virtual; abstract;
                        Function Skip (celt : LongInt): hResult;
                           virtual; abstract;
                        Function Reset : hResult;
                           virtual; abstract;
                        Function Clone (var Enum : IEnumFormatEtc) : hResult;
                           virtual; abstract;
{&StdCall-}
                      end;


     (* IEnumStatData interface
        =======================

        The IEnumSTATDATA interface is used to enumerate through an array of STATDATA structures, which contain advisory
        connection information for a data object. IEnumSTATDATA has the same methods as all enumerator interfaces: Next, Skip,
        Reset, and Clone. For general information on these methods, refer to IEnumXXXX.

        When to Implement
        -----------------

        IEnumSTATDATA is implemented to enumerate advisory connections. Most applications will not implement this directly, but
        will use the OLE-provided implementation. Pointers to this implementation are available in two ways:

         In a data object, call CreateDataAdviseHolder to get a pointer to the OLE data advise holder object, and then, to
          implement IDataObject::EnumDAdvise, call IDataAdviseHolder::EnumAdvise, which creates the enumeration object and supplies
          a pointer to the implementation of IEnumSTATDATA.
         In a compound document object, call CreateOLEAdviseHolder to get a pointer to the OLE advise holder object, and then,
          to implement IOleObject::EnumAdvise, call IOleAdviseHolder::EnumAdvise, which creates the enumeration object and supplies
          a pointer to the implementation of IEnumSTATDATA.

        When to Use
        -----------

        Containers usually call methods that return a pointer to IEnumSTATDATA so the container can use its methods to enumerate
        the existing advisory connections, and use this information to instruct an object to release each of its advisory
        connections prior to closing down. IDataObject::EnumDAdvise, IDataAdviseHolder::EnumAdvise, IOleAdviseHolder::EnumAdvise,
        and IOleCache::EnumCache methods all supply a pointer to IEnumSTATDATA.

        IEnumStatData Methods
        ---------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Next    Retrieves the next celt items in the enumeration sequence. If there are fewer than the requested number of elements
                left in the sequence, it retrieves the remaining elements. The number of elements actually retrieved is returned through
                pceltFetched (unless the caller passed in NULL for that parameter).
        Skip    Skips over the next specified number of elements in the enumeration sequence.
        Reset   Resets the enumeration sequence to the beginning.
        Clone   Creates another enumerator that contains the same enumeration state as the current one.
                Using this function, a client can record a particular point in the enumeration sequence, and then return to that
                point at a later time. The new enumerator supports the same interface as the original one. *)

     pStatData = ^tStatData;
     tagSTATDATA = Record
                     FormatEtc : tFormatEtc;
                     advf : LongInt;
                     advSink : IAdviseSink;
                     dwConnection : Longint;
                   end;
     tStatData = tagSTATDATA;
     STATDATA = tagSTATDATA;

     ppIEnumStatData = ^pIEnumStatData;
     pIEnumStatData = ^IEnumStatData;

     IEnumStatData = Class (IUnknown)
                     Public
{&StdCall+}
                       Function Next (celt : LongInt; var elt; pceltFetched : pLongInt) : hResult;
                          virtual; abstract;
                       Function Skip (celt : LongInt): hResult;
                          virtual; abstract;
                       Function Reset : hResult;
                          virtual; abstract;
                       Function Clone (var Enum : IEnumStatData) : hResult;
                          virtual; abstract;
{&StdCall-}
                     end;


     (* IRootStorage interface
        ======================

        The IRootStorage interface contains a single method that switches a storage object to a different underlying file and
        saves the storage object to that file. The save operation occurs even with low memory conditions and uncommitted changes
        to the storage object. A subsequent call to IStorage::Commit is guaranteed to not consume any additional memory.

        When to Implement
        -----------------

        Storage objects that are based on a file should implement IRootStorage in addition to the IStorage interface. For storage
        objects that are not file-based, this interface is not necessary.
        OLE provides an implementation of a storage object, including the IRootStorage interface, as part of its compound file
        implementation.

        When to Use
        -----------

        The primary use for the IRootStorage interface is to save a storage object to a file during low memory conditions.
        Typically, the container application calls the IRootStorage interface to switch to a new file.
        If you have an IStorage pointer to a compound file object, you can call IStorage::QueryInterface with IID_IRootStorage to
        obtain a pointer to the IRootStorage interface.

        IRootStorage Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        SwitchToFile    Copy the file underlying this root storage object, then associate this storage with the copied file. *)

     ppIRootStorage = ^pIRootStorage;
     pIRootStorage = ^IRootStorage;

     IRootStorage = Class (IUnknown)
                    Public
{&StdCall+}
                      Function SwitchToFile (pszFile : pOleStr) : hResult;
                         virtual; abstract;
{&StdCall-}
                    end;


     (* IAdviseSink interface
        =====================

        The IAdviseSink interface enables containers and other objects to receive notifications of data changes, view changes,
        and compound-document changes occurring in objects of interest. Container applications, for example, require such
        notifications to keep cached presentations of their linked and embedded objects up-to-date. Calls to IAdviseSink methods
        are asynchronous, so the call is sent and then the next instruction is executed without waiting for the call's return.

        For an advisory connection to exist, the object that is to receive notifications must implement IAdviseSink, and the
        objects in which it is interested must implement IOleObject::Advise and IDataObject::DAdvise. In-process objects and
        handlers may also implement IViewObject::SetAdvise. Objects implementing IOleObject must support all reasonable advisory
        methods. To simplify advisory notifications, OLE supplies implementations of the IDataAdviseHolder and IOleAdviseHolder,
        which keep track of advisory connections and send notifications to the proper sinks through pointers to their IAdviseSink
        interfaces. IViewObject (and its advisory methods) is implemented in the default handler.

        As shown in the following table, an object that has implemented an advise sink registers its interest in receiving certain
        types of notifications by calling the appropriate method:

        Call This Method         To Register for These Notifications
        IOleObject::Advise       When a document is saved, closed, or renamed.
        IDataObject::DAdvise     When a document's data changes.
        IViewObject::SetAdvise   When a document's presentation changes.


        When an event occurs that applies to a registered notification type, the object application calls the appropriate
        IAdviseSink method. For example, when an embedded object closes, it calls the IAdviseSink::OnClose method to notify its
        container. These notifications are asynchronous, occurring after the events that trigger them.

        When to Implement
        -----------------

        Objects, such as container applications and compound documents, implement IAdviseSink to receive notification of changes in
        data, presentation, name, or state of their linked and embedded objects. Implementers register for one or more types of
        notification, depending on their needs.
        Notifications of changes to an embedded object originate in the server and flow to the container by way of the object
        handler. If the object is a linked object, the OLE link object intercepts the notifications from the object handler and
        notifies the container directly. All containers, the object handler, and the OLE link object register for OLE notifications.
        The typical container also registers for view notifications. Data notifications are usually sent to the OLE link object and object handler.

        When to Use
        -----------

        Servers call the methods of IAdviseSink to notify objects with which they have an advisory connection of changes in an
        object's data, view, name, or state.

        Note : OLE does not permit synchronous calls in the implementation of asynchronous methods, so you cannot make synchronous
               calls within any of the the IAdviseSink interface's methods. For example, an implementation of
               IAdviseSink::OnDataChange cannot contain a call to IDataObject::GetData.

        IAdviseSink Methods
        -------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        OnDataChange   Advises that data has changed.
        OnViewChange   Advises that view of object has changed.
        OnRename       Advises that name of object has changed.
        OnSave         Advises that object has been saved to disk.
        OnClose        Advises that object has been closed. *)

     pRemStgMedium = ^tRemStgMedium;
     tagRemSTGMEDIUM = Record
                         tymed : LongInt;
                         dwHandleType : LongInt;
                         pData : LongInt;
                         pUnkForRelease : LongInt;
                         cbData : Longint;
                         Data : Record
                                end;
                       end;
     tRemStgMedium = tagRemSTGMEDIUM;
     RemSTGMEDIUM = tagRemSTGMEDIUM;

     pStgMedium = ^tStgMedium;
     tagSTGMEDIUM = Record
                      tymed : LongInt;
                      case Integer of
                        0 : (hBitmap : HBitmap; unkForRelease : IUnknown);
                        1 : (hMetaFilePict : THandle);
                        2 : (hEnhMetaFile : THandle);
                        3 : (hGlobal : HGlobal);
                        4 : (lpszFileName : pOleStr);
                        5 : (stm : IStream);
                        6 : (stg : IStorage);
                    end;
     tStgMedium = tagSTGMEDIUM;
     STGMEDIUM = tagSTGMEDIUM;

     ppIAdviseSink = ^pIAdviseSink;
     pIAdviseSink = ^IAdviseSink;

     IAdviseSink = Class (IUnknown)
                   Public
{&StdCall+}
                     Procedure OnDataChange (var FormatEtc : tFormatEtc; var StgMed : tStgMedium);
                        virtual; abstract;
                     Procedure OnViewChange (dwAspect : LongInt; lIndex : LongInt);
                        virtual; abstract;
                     Procedure OnRename (mk : IMoniker);
                        virtual; abstract;
                     Procedure OnSave;
                        virtual; abstract;
                     Procedure OnClose;
                        virtual; abstract;
{&StdCall-}
                   end;

     (* IAdviseSink2 interface
        ======================

        The IAdviseSink2 interface is an extension of IAdviseSink, adding the method OnLinkSrcChange to the contract to handle a
        change in the moniker of a linked object. This avoids overloading the implementation IAdviseSink::OnRename to handle the
        renaming of both embedded objects and linked objects. In applications where different blocks of code might execute
        depending on which of these two similar events has occurred, using the same method for both events complicates testing
        and debugging.

        When to Implement
        -----------------

        If your application supports links, you should definitely implement IAdviseSink2. Even if your application does not support
        links, it may do so in future releases. In general, your code would implement just IAdviseSink2, which, because of contract
        inheritance, must include implementations of all of the IAdviseSink methods, along with the single additional method of
        IAdviseSink2.

        When to Use
        -----------

        When a link source is renamed, the link object should notify its container by calling IAdviseSink::OnLinkSrcChange. If you
        are using the default handler, containing the OLE link object, you can still have both embedded and linked objects call
        IAdviseSink::OnRename, but for linked objects, the OLE link object maps the notification to IAdviseSink2::OnLinkSrcChange.

        IAdviseSink2 Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IAdviseSink.OnDataChange
        IAdviseSink.OnViewChange
        IAdviseSink.OnRename
        IAdviseSink.OnSave
        IAdviseSink.OnClose
        OnLinkSrcChange   Advises that link source has changed. *)

     ppIAdviseSink2 = ^pIAdviseSink2;
     pIAdviseSink2 = ^IAdviseSink2;

     IAdviseSink2 = Class (IAdviseSink)
                    Public
{&StdCall+}
                      Procedure OnLinkSrcChange (mk : IMoniker);
                         virtual; abstract;
{&StdCall-}
                    end;


   (* IDataObject interface
      =====================

      The IDataObject interface specifies methods that enable data transfer and notification of changes in data. Data transfer
      methods specify the format of the transferred data along with the medium through which the data is to be transferred.
      Optionally, the data can be rendered for a specific target device. In addition to methods for retrieving and storing data,
      the IDataObject interface specifies methods for enumerating available formats and managing connections to advisory sinks
      for handling change notifications.

      The term "data object" is used to mean any object that supports an implementation of the IDataObject interface.
      Implementations vary, depending on what the data object is required to do; in some data objects, the implementation of
      certain methods not supported by the object could simply be the return of E_NOTIMPL. For example, some data objects do not
      allow callers to send them data. Other data objects do not support advisory connections and change notifications. However,
      for those data objects that do support change notifications, OLE provides an object called a data advise holder. An
      interface pointer to this holder is available through a call to the helper function CreateDataAdviseHolder. A data object
      can have multiple connections, each with its own set of attributes. The OLE data advise holder simplifies the task of
      managing these connections and sending the appropriate notifications.

      When to Implement
      -----------------

      Implement the IDataObject interface if you are developing a container or server application that is capable of
      transferring data. For example, if your application allows its data to be pasted or dropped into another application, you
      must implement the IDataObject interface. OLE compound document object servers that support objects that can be embedded or
      linked must implement IDataObject.
      OLE provides implementations in its default object handler and its cache.

      When to Use
      -----------

      Any object that can receive data calls the methods in the IDataObject interface.
      When you call the data transfer methods in the IDataObject interface, you specify a format, a medium, and, optionally, a
      target device for which the data should be rendered. Objects, such as containers, that want to be notified through their
      advise sinks when the data in the data object changes call the IDataObject advisory methods to set up an advisory connection
      through which notifications can be sent.

      IDataObject Methods
      -------------------

      IUnknown.QueryInterface
      IUnknown.AddRef
      IUnknown.Release
      GetData                 Renders the data described in a FormatEtc structure and transfers it through the STGMEDIUM
                              structure.
      GetDataHere             Renders the data described in a FormatEtc structure and transfers it through the STGMEDIUM
                              structure allocated by the caller.
      QueryGetData            Determines whether the data object is capable of rendering the data described in the FormatEtc
                              structure.
      GetCanonicalFormatEtc   Provides a potentially different but logically equivalent FormatEtc structure.
      SetData                 Provides the source data object with data described by a FormatEtc structure and an STGMEDIUM
                              structure.
      EnumFormatEtc           Creates and returns a pointer to an object to enumerate the FormatEtc supported by the data object.
      DAdvise                 Creates a connection between a data object and an advise sink so the advise sink can receive
                              notifications of changes in the data object.
      DUnadvise               Destroys a notification previously set up with the DAdvise method.
      EnumDAdvise             Creates and returns a pointer to an object to enumerate the current advisory connections. *)

     ppIDataObject = ^pIDataObject;
     pIDataObject = ^IDataObject;

     IDataObject = Class (IUnknown)
                   Public
{&StdCall+}
                     Function GetData (var TormatEtcIn : tFormatEtc; var Medium : tStgMedium) : hResult;
                        virtual; abstract;
                     Function GetDataHere (var FormatEtc : tFormatEtc; var Medium : tStgMedium) : hResult;
                        virtual; abstract;
                     Function QueryGetData (var FormatEtc : tFormatEtc) : hResult;
                        virtual; abstract;
                     Function GetCanonicalFormatEtc (var FormatEtc : tFormatEtc; var FormatEtcOut : tFormatEtc) : hResult;
                        virtual; abstract;
                     Function SetData (var FormatEtc : tFormatEtc; var Medium : tStgMedium; fRelease : BOOL) : hResult;
                        virtual; abstract;
                     Function EnumFormatEtc (dwDirection : LongInt; var EnumFormatEtc : IEnumFormatEtc) : hResult;
                        virtual; abstract;
                     Function DAdvise (var FormatEtc : tFormatEtc; advf : LongInt; AdvSink : IAdviseSink;
                                       var dwConnection : LongInt) : hResult;
                        virtual; abstract;
                     Function DUnadvise (dwConnection : LongInt) : hResult;
                        virtual; abstract;
                     Function EnumDAdvise (var EnumAdvise : IEnumStatData) : hResult;
                        virtual; abstract;
{&StdCall-}
                   end;


     (* IDataAdviseHolder interface
        ===========================

        The IDataAdviseHolder interface contains methods that create and manage advisory connections between a data object and
        one or more advise sinks. Its methods are intended to be used to implement the advisory methods of IDataObject.
        IDataAdviseHolder is implemented on an advise holder object. Its methods establish and delete data advisory connections
        and send notification of change in data from a data object to an object that requires this notification, such as an OLE
        container, which must contain an advise sink.

        Advise sinks are objects that require notification of change in the data the object contains and implement the IAdviseSink
        interface. Advise sinks are also usually associated with OLE compound document containers.

        When to implement
        -----------------

        Typically, you use the OLE-provided implementation of IDataAdviseHolder to simplify your implementation of the DAdvise,
        DUnadvise, and EnumDAdvise methods in the IDataObject interface, and to send notification of data change as appropriate.
        It would be necessary to implement IDataAdviseHolder only in the case where there may be a need for a custom data advise
        holder object, whose methods are to be used to implement the IDataObject methods in a set of servers.

        When to use
        -----------

        Your implementation of the advisory methods of IDataObject can call the methods in IDataAdviseHolder. The first time you
        receive a call to IDataObject::DAdvise, call the function CreateDataAdviseHolder to create an instance of the OLE-provided
        advise holder and get a pointer to its IDataAdviseHolder interface. Then, in implementing the IDataObject interface on the
        data object, you delegate implementations of the DAdvise, DUnadvise, and EnumDAdvise methods to the corresponding methods
        in IDataAdviseHolder.

        When the data of interest to an advise sink actually changes, you call IDataAdviseHolder::SendOnDataChange from the data
        object to carry out the necessary notifications.

        IDataAdviseHolder Methods
        -------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Advise             Creates a connection between an advise sink and a data object so the advise sink can receive
                           notification of change in the data object.
        Unadvise           Destroys a notification connection previously set up with the Advise method.
        EnumAdvise         Returns an object that can be used to enumerate the current advisory connections.
        SendOnDataChange   Sends a change notification back to each advise sink that is currently being managed. *)

     ppIDataAdviseHolder = ^pIDataAdviseHolder;
     pIDataAdviseHolder = ^IDataAdviseHolder;

     IDataAdviseHolder = Class (IUnknown)
                         Public
{&StdCall+}
                           Function Advise (DataObject : IDataObject; var fetc : tFormatEtc; advf : LongInt;
                                            Advise : IAdviseSink; var pdwConnection : LongInt) : hResult;
                              virtual; abstract;
                           Function Unadvise (dwConnection : LongInt) : hResult;
                              virtual; abstract;
                           Function EnumAdvise (var EnumAdvise : IEnumStatData) : hResult;
                              virtual; abstract;
                           Function SendOnDataChange (DataObject : IDataObject; dwReserved : LongInt; advf : LongInt) : hResult;
                              virtual; abstract;
{&StdCall-}
                         end;


     (* IMessageFilter interface
        ========================

        The IMessageFilter interface provides OLE servers and applications with the ability to selectively handle incoming and
        outgoing OLE messages while waiting for responses from synchronous calls. Filtering messages helps to ensure that calls
        are handled in a manner that improves performance and avoids deadlocks. OLE messages can be synchronous, asynchronous, or
        input-synchronized; the majority of interface calls are synchronous.

        Synchronous calls require the caller to wait for a reply before continuing. OLE enters a modal loop while waiting for the
        reply. During this time, the caller is still able to receive and dispatch incoming messages.
        Asynchronous calls allow the caller to proceed without waiting for a response from the called object. Today, in OLE, the
        only asynchronous calls are to an object's IAdviseSink interface. While the object is processing an asynchronous call, it
        is prohibited from making any synchronous calls back to the calling object.

        Input-synchronized calls require the called object to complete the call before relinquishing control, ensuring that
        behaviors such as focus management and type-ahead function correctly.

        When to Implement
        -----------------

        You will probably want to implement your own message filter. The default implementation provided by COM offers only minimal
        message filtering capability. Although message filtering is no longer as significant as it was with 16-bit applications,
        since the size of the message queue is now virtually unlimited, you still should implement IMessageFilter as a way of
        resolving deadlocks.
        COM will call your implementation of IMessageFilter to find out if an application is blocking, so that you can task-switch
        to that application and give the user an opportunity to deal with the situation. For example, if you have Microsoft Word
        talking to Microsoft Excel, with Excel running in the background in formula mode, in which formulas are being applied to
        data on the worksheet to compute different or "what if" results, Excel won't check all calls, thereby blocking further
        action. IMessageFilter would put up a dialog box indicating which task was blocking and provide the user with an
        opportunity to deal with the deadlock.

        Although it is probably obvious from the method descriptions, it may still be useful to point out that HandleIncomingCall is
        an object-based method and RetryRejectedCall and MessagePending are client-based methods. Clearly, the object must have some
        way of handling incoming calls from external clients. HandleIncomingCall provides that functionality by allowing the object
        to handle or defer some incoming calls and reject others. The client also needs to know how an object is going to handle its
        call. so that it can respond appropriately. The client needs to know if a call has been rejected, or just deferred
        temporarily, so that it can retry rejected calls after some specified time. The client also needs to be able to respond to
        Windows messages, while at the same time waiting for replies to pending messages.

        You will use CoRegisterMessageFilter to register your message filter. Once registered, COM then calls your message filter
        instead of the default implementation.

        When to Use
        -----------

        You don't call this interface directly. It's provided by the OLE server or application and called by the COM.

        Application Shutdown with WM_QUERYENDSESSION and WM_ENDSESSION
        --------------------------------------------------------------

        When a user exits Windows, each open application receives a WM_QUERYENDSESSION message followed by a WM_ENDSESSION message,
        provided the exit is not canceled. These messages are invoked with SendMessage, which unfortunately restricts the
        initiation of all outgoing LRPC calls. This is a problem for container applications that have open embedded objects when
        they receive the shutdown request because LRPC is needed to close those objects.
        Container and container/server applications with open documents typically display a message box on receipt of the
        WM_QUERYENDSESSION message that asks if the user wants to save changes before exiting. A positive response is usually the
        default. The recommendation for dealing with the situation described above is for the application to display an alternate
        message box asking if the user wants to discard changes; a negative response should be the default. If the user chooses to
        discard the changes, TRUE should be returned for WM_QUERYENDSESSION, which .signals to Windows that it can terminate.
        If the user does not want to discard the changes, FALSE should be returned. No attempt should be made to close or release
        running embeddings.

        Server applications should return TRUE for WM_QUERYENDSESSION without prompting the user.On receipt of a WM_ENDSESSION
        message, all OLE applications should execute the normal close sequence for each application's documents and/or objects.
        At the same time, you should ignore any errors resulting from any cross-process calls or calls to IUnknown::Release. All
        storage pointers (IStorage and IStream interface pointers) must be released to properly flush any temporary files
        maintained by the compound file implementation of structured storage.

        IMessageFilter Methods
        ----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        HandleIncomingCall   Provides a single entry point for incoming calls.
        RetryRejectedCall    Provides application with opportunity to display a dialog box offering retry or cancel or task
                             switching options.
        MessagePending       Indicates a Windows message has arrived while OLE is waiting to respond to a remote call. *)

     pInterfaceInfo = ^tInterfaceInfo;
     tagINTERFACEINFO = Record
                          Unk : IUnknown;
                          iid : TIID;
                          wMethod : Word;
                        end;
     tInterfaceInfo = tagINTERFACEINFO;
     INTERFACEINFO = tagINTERFACEINFO;

     ppIMessageFilter = ^pIMessageFilter;
     pIMessageFilter = ^IMessageFilter;

     IMessageFilter = Class (IUnknown)
                      Public
{&StdCall+}
                        Function HandleInComingCall (dwCallType : LongInt; hTaskCaller : hTask; dwTickCount : LongInt;
                                                     lpInterfaceInfo : pInterfaceInfo) : LongInt;
                           virtual; abstract;
                        Function RetryRejectedCall (hTaskCallee : hTask; dwTickCount : LongInt; dwRejectType : LongInt) : LongInt;
                           virtual; abstract;
                        Function MessagePending (hTaskCallee : hTask; dwTickCount : LongInt; dwPendingType : LongInt) : LongInt;
                           virtual; abstract;
{&StdCall-}
                      end;


     (* IRpcChannelBuffer interface
        ===========================

        IRpcChannelBuffer Methods
        -------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetBuffer
        SendReceive
        FreeBuffer
        GetDestCtx
        IsConnected *)

     tRpcOleDataRep = LongInt;

     pRpcOleMessage = ^tRpcOleMessage;
     tagRPCOLEMESSAGE = Record
                          Reserved1: Pointer;
                          DataRepresentation : tRpcOleDataRep;
                          Buffer : Pointer;
                          cbBuffer : LongInt;
                          iMethod : LongInt;
                          Reserved2 : Array [0..4] of Pointer;
                          rpcFlags: LongInt;
                        end;
     tRpcOleMessage = tagRPCOLEMESSAGE;
     RPCOLEMESSAGE = tagRPCOLEMESSAGE;

     ppIRpcChannelBuffer = ^pIRpcChannelBuffer;
     pIRpcChannelBuffer = ^IRpcChannelBuffer;

     IRpcChannelBuffer = Class (IUnknown)
                         Public
{&StdCall+}
                           Function GetBuffer (var Message : tRpcOleMessage; iid : TIID) : hResult;
                              virtual; abstract;
                           Function SendReceive (var Message : tRpcOleMessage; var Status : LongInt) : hResult;
                              virtual; abstract;
                           Function FreeBuffer (var Message : tRpcOleMessage) : hResult;
                              virtual; abstract;
                           Function GetDestCtx (var dwDestContext : LongInt; var pvDestContext) : hResult;
                              virtual; abstract;
                           Function IsConnected : hResult;
                              virtual; abstract;
{&StdCall-}
                         end;


     (* IRpcProxyBuffer interface
        =========================

        IRpcProxyBuffer Methods
        -----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Connect
        Disconnect *)

     ppIRpcProxyBuffer = ^pIRpcProxyBuffer;
     pIRpcProxyBuffer = ^IRpcProxyBuffer;

     IRpcProxyBuffer = Class (IUnknown)
                       Public
{&StdCall+}
                         Function Connect (RpcChannelBuffer : IRpcChannelBuffer) : hResult;
                            virtual; abstract;
                         Procedure Disconnect;
                            virtual; abstract;
{&StdCall-}
                       end;


     (* IRpcStubBuffer interface
        ========================

        IRpcStubBuffer Methods
        ----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Connect
        Invoke
        IsIIDSupported
        CountRefs
        DebugServerQueryInterface
        DebugServerRelease *)

     ppIRpcStubBuffer = ^pIRpcStubBuffer;
     pIRpcStubBuffer = ^IRpcStubBuffer;

     IRpcStubBuffer = Class (IUnknown)
                      Public
{&StdCall+}
                        Function Connect (UnkServer : IUnknown) : hResult;
                           virtual; abstract;
                        Procedure Disconnect;
                           virtual; abstract;
                        Function Invoke (var RpcMsg : tRpcOleMessage; rpcChannelBuffer : IRpcChannelBuffer) : hResult;
                           virtual; abstract;
                        Function IsIIDSupported (const iid : TIID) : IRpcStubBuffer;
                           virtual; abstract;
                        Function CountRefs : LongInt;
                           virtual; abstract;
                        Function DebugServerQueryInterface (var pv) : hResult;
                           virtual; abstract;
                        Procedure DebugServerRelease (pv : Pointer);
                           virtual; abstract;
{&StdCall-}
                      end;


     (* IPSFactoryBuffer interface
        ==========================

        IPSFactoryBuffer Methods
        ------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        CreateProxy
        CreateStub *)

     ppIPSFactoryBuffer = ^pIPSFactoryBuffer;
     pIPSFactoryBuffer = ^IPSFactoryBuffer;

     IPSFactoryBuffer = Class (IUnknown)
                        Public
{&StdCall+}
                          Function CreateProxy (UnkOuter : IUnknown; const iid : TIID; var Proxy : IRpcProxyBuffer; var pv) : hResult;
                             virtual; abstract;
                          Function CreateStub (const iid : TIID; UnkServer : IUnknown; var Stub : IRpcStubBuffer) : hResult;
                             virtual; abstract;
{&StdCall-}
                        end;


     (* ICreateTypeInfo interface
        =========================

        ICreateTypeInfo Methods
        -----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        SetGuid
        SetTypeFlags
        SetDocString
        SetHelpContext
        SetVersion
        AddRefTypeInfo
        AddFuncDesc
        AddImplType
        SetImplTypeFlags
        SetAlignment
        SetSchema
        AddVarDesc
        SetFuncAndParamNames
        SetVarName
        SetTypeDescAlias
        DefineFuncAsDllEntry
        SetFuncDocString
        SetVarDocString
        SetFuncHelpContext
        SetVarHelpContext
        SetMops
        SetTypeIdlDesc
        LayOut *)

     ppICreateTypeInfo = ^pICreateTypeInfo;
     pICreateTypeInfo = ^ICreateTypeInfo;

     ICreateTypeInfo = Class (IUnknown)
                       Public
{&StdCall+}
                         Function SetGuid (const guid : TGUID) : hResult;
                            virtual; abstract;
                         Function SetTypeFlags (uTypeFlags : Integer) : hResult;
                            virtual; abstract;
                         Function SetDocString (pstrDoc : pOleStr) : hResult;
                            virtual; abstract;
                         Function SetHelpContext (dwHelpContext : LongInt) : hResult;
                            virtual; abstract;
                         Function SetVersion (wMajorVerNum, wMinorVerNum : Word) : hResult;
                            virtual; abstract;
                         Function AddRefTypeInfo (tInfo : ITypeInfo; var RefType : hRefType) : hResult;
                            virtual; abstract;
                         Function AddFuncDesc (Index : Integer; var FuncDesc : tFuncDesc) : hResult;
                            virtual; abstract;
                         Function AddImplType (Index : Integer; RefType : hRefType) : hResult;
                            virtual; abstract;
                         Function SetImplTypeFlags (Index : Integer; ImplTypeFlags : Integer) : hResult;
                            virtual; abstract;
                         Function SetAlignment (cbAlignment : Word) : hResult;
                            virtual; abstract;
                         Function SetSchema (lpstrSchema : pOleStr) : hResult;
                            virtual; abstract;
                         Function AddVarDesc (Index : Integer; var VarDesc : tVarDesc) : hResult;
                            virtual; abstract;
                         Function SetFuncAndParamNames (Index : Integer; rgszNames : pOleStrList; cNames : Integer) : hResult;
                            virtual; abstract;
                         Function SetVarName (Index : Integer; szName : pOleStr) : hResult;
                            virtual; abstract;
                         Function SetTypeDescAlias (var DescAlias : tTypeDesc) : hResult;
                            virtual; abstract;
                         Function DefineFuncAsDllEntry (Index : Integer; szDllName, szProcName : pOleStr) : hResult;
                            virtual; abstract;
                         Function SetFuncDocString (Index : Integer; szDocString : pOleStr) : hResult;
                            virtual; abstract;
                         Function SetVarDocString (Index : Integer; szDocString : pOleStr) : hResult;
                            virtual; abstract;
                         Function SetFuncHelpContext (Index : Integer; dwHelpContext : LongInt) : hResult;
                            virtual; abstract;
                         Function SetVarHelpContext (Index : Integer; dwHelpContext : LongInt) : hResult;
                            virtual; abstract;
                         Function SetMops (Index : Integer; bstrMops : tBStr) : hResult;
                            virtual; abstract;
                         Function SetTypeIdlDesc (var IdlDesc : tIDLDesc) : hResult;
                            virtual; abstract;
                         Function LayOut : hResult;
                            virtual; abstract;
{&StdCall-}
                       end;


     (* ICreateTypeLib interface
        ========================

        ICreateTypeLib Methods
        ----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        CreateTypeInfo
        SetName
        SetVersion
        SetGuid
        SetDocString
        SetHelpFileName
        SetHelpContext
        SetLcid
        SetLibFlags
        SaveAllChanges *)

     ppICreateTypeLib = ^pICreateTypeLib;
     pICreateTypeLib = ^ICreateTypeLib;

     ICreateTypeLib = Class (IUnknown)
                      Public
{&StdCall+}
                        Function CreateTypeInfo (szName : pOleStr; tKind : tTypeKind; var IctInfo : ICreateTypeInfo) : hResult;
                           virtual; abstract;
                        Function SetName (szName : pOleStr) : hResult;
                           virtual; abstract;
                        Function SetVersion (wMajorVerNum, wMinorVerNum : Word) : hResult;
                           virtual; abstract;
                        Function SetGuid (const guid : TGUID) : hResult;
                           virtual; abstract;
                        Function SetDocString (szDoc : pOleStr) : hResult;
                           virtual; abstract;
                        Function SetHelpFileName (szHelpFileName : pOleStr) : hResult;
                           virtual; abstract;
                        Function SetHelpContext (dwHelpContext : LongInt) : hResult;
                           virtual; abstract;
                        Function SetLcid (lcid : TLCID) : hResult;
                           virtual; abstract;
                        Function SetLibFlags (uLibFlags : Integer) : hResult;
                           virtual; abstract;
                        Function SaveAllChanges : hResult;
                           virtual; abstract;
{&StdCall-}
                      end;


     (* IDispatch interface
        ===================

        IDispatch Methods
        -----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetTypeInfoCount
        GetTypeInfo
        GetIDsOfNames
        Invoke *)

     ppIDispatch = ^pIDispatch;
     pIDispatch = ^IDispatch;

     IDispatch = Class (IUnknown)
                 Public
{&StdCall+}
                   Function GetTypeInfoCount (var ctInfo : Integer) : hResult;
                      virtual; abstract;
                   Function GetTypeInfo (itInfo : Integer; lcid : TLCID; var tInfo : ITypeInfo) : hResult;
                      virtual; abstract;
                   Function GetIDsOfNames (const iid : TIID; rgszNames : pOleStrList; cNames : Integer; lcid : TLCID;
                                           rgdispid : pDispIDList) : hResult;
                      virtual; abstract;
                   Function Invoke (DispIDMember : tDispID; const iid : TIID; lcid : TLCID; Flags : Word;
                                    var DispParams : tDispParams; VarResult : pVariant; ExcepInfo : pExcepInfo;
                                    argErr : pInteger) : hResult;
                      virtual; abstract;
{&StdCall-}
                 end;


     (* IEnumVariant interface
        ======================

        IEnumVariant Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Next    Retrieves the next celt items in the enumeration sequence. If there are fewer than the requested number of elements
                left in the sequence, it retrieves the remaining elements. The number of elements actually retrieved is returned through
                pceltFetched (unless the caller passed in NULL for that parameter).
        Skip    Skips over the next specified number of elements in the enumeration sequence.
        Reset   Resets the enumeration sequence to the beginning.
        Clone   Creates another enumerator that contains the same enumeration state as the current one.
                Using this function, a client can record a particular point in the enumeration sequence, and then return to that
                point at a later time. The new enumerator supports the same interface as the original one. *)

     ppIEnumVariant = ^pIEnumVariant;
     pIEnumVariant = ^IEnumVariant;

     IEnumVariant = Class (IUnknown)
                    Public
{&StdCall+}
                      Function Next (celt : LongInt; var elt; var pceltFetched : LongInt) : hResult;
                         virtual; abstract;
                      Function Skip (celt : LongInt) : hResult;
                         virtual; abstract;
                      Function Reset : hResult;
                         virtual; abstract;
                      Function Clone (var Enum : IEnumVariant) : hResult;
                         virtual; abstract;
{&StdCall-}
                    end;


     (* ITypeComp interface
        ===================

        ITypeComp Methods
        -----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Bind
        BindType *)

     tDescKind = LongInt;

     pBindPtr = ^tBindPtr;
     tagBINDPTR = Record
                    case Integer of
                      0 : (lpFuncDesc : pFuncDesc);
                      1 : (lpVarDesc : pVarDesc);
                      2 : (lptComp : ITypeComp);
                  end;
     tBindPtr = tagBINDPTR;
     BINDPTR = tagBINDPTR;

     ppITypeComp = ^pITypeComp;
     pITypeComp = ^ITypeComp;

     ITypeComp = Class (IUnknown)
                 Public
{&StdCall+}
                   Function Bind (szName : pOleStr; lHashVal : LongInt; wflags : Word; var tInfo : ITypeInfo;
                                  var DescKind : tDescKind; var BindPtr : tBindPtr) : hResult;
                      virtual; abstract;
                   Function BindType (szName : pOleStr; lHashVal : LongInt; var tInfo : ITypeInfo; var tComp : ITypeComp) : hResult;
                      virtual; abstract;
{&StdCall-}
                 end;


     (* ITypeInfo interface
        ===================

        ITypeInfo Methods
        -----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetTypeAttr
        GetTypeComp
        GetFuncDesc
        GetVarDesc
        GetNames
        GetRefTypeOfImplType
        GetImplTypeFlags
        GetIDsOfNames
        Invoke
        GetDocumentation
        GetDllEntry
        GetRefTypeInfo
        AddressOfMember
        CreateInstance
        GetMops
        GetContainingTypeLib
        ReleaseTypeAttr
        ReleaseFuncDesc
        ReleaseVarDesc *)

     ppITypeInfo = ^pITypeInfo;
     pITypeInfo = ^ITypeInfo;

     ITypeInfo = Class (IUnknown)
                 Public
{&StdCall+}
                   Function GetTypeAttr (var pTypeAttr : pTypeAttr) : hResult;
                      virtual; abstract;
                   Function GetTypeComp (var tComp : ITypeComp) : hResult;
                      virtual; abstract;
                   Function GetFuncDesc (Index : Integer; var pFuncDesc : pFuncDesc) : hResult;
                      virtual; abstract;
                   Function GetVarDesc (Index : Integer; var pVarDesc : pVarDesc) : hResult;
                      virtual; abstract;
                   Function GetNames (MemId : tMemberID; rgBStrNames : PBStrList; cMaxNames : Integer; var cNames : Integer) : hResult;
                      virtual; abstract;
                   Function GetRefTypeOfImplType (Index : Integer; var RefType : hRefType) : hResult;
                      virtual; abstract;
                   Function GetImplTypeFlags (Index : Integer; var ImplTypeFlags : Integer) : hResult;
                      virtual; abstract;
                   Function GetIDsOfNames (rgpszNames : pOleStrList; cNames : Integer; rgMemId : pMemberIDList) : hResult;
                      virtual; abstract;
                   Function Invoke (pvInstance : Pointer; MemId : tMemberID; Flags : Word; var DispParams : tDispParams;
                                    VarResult : pVariant; ExcepInfo : pExcepInfo; ArgErr : pInteger) : hResult;
                      virtual; abstract;
                   Function GetDocumentation (MemId : tMemberID; pBStrName, pBStrDocString : pBStr; pdwHelpContext : pLongint;
                                              pBStrHelpFile : pBStr) : hResult;
                      virtual; abstract;
                   Function GetDllEntry (MemId : tMemberID; InvKind : tInvokeKind; var BStrDllName, BStrName : tBStr;
                                         var wOrdinal : Word) : hResult;
                      virtual; abstract;
                   Function GetRefTypeInfo (RefType : hRefType; var tInfo : ITypeInfo) : hResult;
                      virtual; abstract;
                   Function AddressOfMember (MemId : tMemberID; InvKind : tInvokeKind; var ppv : Pointer) : hResult;
                      virtual; abstract;
                   Function CreateInstance (UnkOuter : IUnknown; const iid : TIID; var vObj) : hResult;
                      virtual; abstract;
                   Function GetMops (MemId : tMemberID; var BStrMops : tBStr) : hResult;
                      virtual; abstract;
                   Function GetContainingTypeLib (var tlib : ITypeLib; var pIndex : Integer) : hResult;
                      virtual; abstract;
                   Procedure ReleaseTypeAttr (pTypeAttr : pTypeAttr);
                      virtual; abstract;
                   Procedure ReleaseFuncDesc (pFuncDesc : pFuncDesc);
                      virtual; abstract;
                   Procedure ReleaseVarDesc (pVarDesc : pVarDesc);
                      virtual; abstract;
{&StdCall-}
                 end;


     (* ITypeLib interface
        ==================

        ITypeLib Methods
        ----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetTypeInfoCount
        GetTypeInfo
        GetTypeInfoType
        GetTypeInfoOfGuid
        GetLibAttr
        GetTypeComp
        GetDocumentation
        IsName
        FindName
        ReleaseTLibAttr *)

     tSysKind = LongInt;

     pTLibAttr = ^tTLibAttr;
     tagTLIBATTR = Record
                     guid : TGUID;
                     lcid : TLCID;
                     SysKind : tSysKind;
                     wMajorVerNum : Word;
                     wMinorVerNum : Word;
                     wLibFlags : Word;
                   end;
     tTLibAttr = tagTLIBATTR;
     TLIBATTR = tagTLIBATTR;

     pTypeInfoList = ^tTypeInfoList;
     tTypeInfoList = Array [0..65535] of ITypeInfo;

     ppITypeLib = ^pITypeLib;
     pITypeLib = ^ITypeLib;

     ITypeLib = Class (IUnknown)
                Public
{&StdCall+}
                  Function GetTypeInfoCount : Integer;
                     virtual; abstract;
                  Function GetTypeInfo (Index : Integer; var tInfo : ITypeInfo) : hResult;
                     virtual; abstract;
                  Function GetTypeInfoType (Index : Integer; var tKind : tTypeKind) : hResult;
                     virtual; abstract;
                  Function GetTypeInfoOfGuid (const guid : TGUID; var tInfo : ITypeInfo) : hResult;
                     virtual; abstract;
                  Function GetLibAttr (var pTLibAttr : pTLibAttr) : hResult;
                     virtual; abstract;
                  Function GetTypeComp (var tComp : ITypeComp) : hResult;
                     virtual; abstract;
                  Function GetDocumentation (Index : Integer; pbstrName, pbstrDocString : pBStr; pdwHelpContext : pLongint;
                                             pBStrHelpFile : pBStr) : hResult;
                     virtual; abstract;
                  Function IsName (szNameBuf : pOleStr; lHashVal : LongInt; var fName : BOOL) : hResult;
                     virtual; abstract;
                  Function FindName (szNameBuf : pOleStr; lHashVal : LongInt; rgPtInfo : pTypeInfoList; rgMemId : pMemberIDList;
                                     var pcFound : Word) : hResult;
                     virtual; abstract;
                  Procedure ReleaseTLibAttr (pTLibAttr : pTLibAttr);
                     virtual; abstract;
{&StdCall-}
                end;


     (* IErrorInfo interface
        ====================

        IErrorInfo Methods
        ------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetGUID
        GetSource
        GetDescription
        GetHelpFile
        GetHelpContext *)

     ppIErrorInfo = ^pIErrorInfo;
     pIErrorInfo = ^IErrorInfo;

     IErrorInfo = Class (IUnknown)
                  Public
{&StdCall+}
                    Function GetGUID (var guid : TGUID) : hResult;
                       virtual; abstract;
                    Function GetSource (var BStrSource : tBStr) : hResult;
                       virtual; abstract;
                    Function GetDescription (var BStrDescription : tBStr) : hResult;
                       virtual; abstract;
                    Function GetHelpFile (var BStrHelpFile : tBStr) : hResult;
                       virtual; abstract;
                    Function GetHelpContext (var dwHelpContext : LongInt) : hResult;
                       virtual; abstract;
{&StdCall-}
                  end;


     (* ICreateErrorInfo interface
        ==========================

        ICreateErrorInfo Methods
        ------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        SetGUID
        SetSource
        SetDescription
        SetHelpFile
        SetHelpContext *)

     ppICreateErrorInfo = ^pICreateErrorInfo;
     pICreateErrorInfo = ^ICreateErrorInfo;

     ICreateErrorInfo = Class (IUnknown)
                        Public
{&StdCall+}
                          Function SetGUID (const guid : TGUID) : hResult;
                             virtual; abstract;
                          Function SetSource (szSource : pOleStr) : hResult;
                             virtual; abstract;
                          Function SetDescription (szDescription : pOleStr) : hResult;
                             virtual; abstract;
                          Function SetHelpFile (szHelpFile : pOleStr) : hResult;
                             virtual; abstract;
                          Function SetHelpContext (dwHelpContext : LongInt) : hResult;
                             virtual; abstract;
{&StdCall-}
                        end;


     (* ISupportErrorInfo interface
        ===========================

        ISupportErrorInfo Methods
        -------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        InterfaceSupportsErrorInfo *)

     ppISupportErrorInfo = ^pISupportErrorInfo;
     pISupportErrorInfo = ^ISupportErrorInfo;

     ISupportErrorInfo = Class (IUnknown)
                         Public
{&StdCall+}
                           Function InterfaceSupportsErrorInfo (const iid : TIID) : hResult;
                              virtual; abstract;
{&StdCall-}
                         end;


     (* IOleAdviseHolder interface
        ==========================

        The IOleAdviseHolder interface contains methods that manage advisory connections and compound document notifications in
        an object server. Its methods are intended to be used to implement the advisory methods of IOleObject. IOleAdviseHolder
        is implemented on an advise holder object. Its methods establish and delete advisory connections from the object managed
        by the server to the object's container, which must contain an advise sink (support the IAdviseSink interface).
        The advise holder object must also keep track of which advise sinks are interested in which notifications and pass along
        the notifications as appropriate.

        When to Implement
        -----------------

        It is unlikely that you would choose to implement this interface. OLE provides an implementation of the OLE advise holder
        as a convenience to programmers.Few applications will require notification capabilities beyond those which the default
        advise holder provides. In general, a single server application that requires different notification capabilities would
        simply implement the advisory functionality in its IOleObject advisory methods. It would be necessary to implement
        IOleAdviseHolder only in the case where there may be a need for a custom advise holder object, whose methods are to be
        used to implement the IOleObject methods in a set of servers.

        When to Use
        -----------

        Call the methods of IOleAdviseHolder to implement the advisory methods of IOleObject. Applications instantiate an OLE
        advise holder by calling the OLE function CreateOleAdviseHolder. (OLE also provides a data advise holder to manage data
        notifications. Applications create a data advise holder by calling the OLE function CreateDataAdviseHolder.)
        Containers and other objects that need to receive compound document notifications must implement the IAdviseSink interface
        to receive those notifications, and call the IOleAdviseHolder interface methods to establish an advisory connection and
        inform the object of what specific notifications it wishes to receive.

        IOleAdviseHolder Methods
        ------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Advise         Establishes advisory connection with sink.
        Unadvise       Deletes advisory connection with sink.
        EnumAdvise     Supplies an IEnumSTATDATA pointer to an enumeration object that can be used to determine current advisory
                       connections.
        SendOnRename   Advises sink that name of object has changed.
        SendOnSave     Advises sink that object has been saved.
        SendOnClose    Advises sink that object has been closed. *)

     ppIOleAdviseHolder = ^pIOleAdviseHolder;
     pIOleAdviseHolder = ^IOleAdviseHolder;

     IOleAdviseHolder = Class (IUnknown)
                        Public
{&StdCall+}
                          Function Advise (Advise : IAdviseSink; var dwConnection : LongInt) : hResult;
                             virtual; abstract;
                          Function Unadvise (dwConnection : LongInt) : hResult;
                             virtual; abstract;
                          Function EnumAdvise (var EnumAdvise : IEnumStatData) : hResult;
                             virtual; abstract;
                          Function SendOnRename (mk : IMoniker) : hResult;
                             virtual; abstract;
                          Function SendOnSave : hResult;
                             virtual; abstract;
                          Function SendOnClose : hResult;
                             virtual; abstract;
{&StdCall-}
                        end;


     (* IOleCache interface
        ===================

        The IOleCache interface provides control of the presentation data that gets cached inside of an object.
        Cached presentation data is available to the container of the object even whenthe  server application is not running or
        is unavailable.

        When to Implement
        -----------------

        The IOleCache interface can be implemented by an object handler and an in-process server. In general, however, the methods
        of IOleCache are implemented as part of the IOleCache2 interface, which inherits the IOleCache definition, and adds
        methods for selectively updating the cache. Rather than implementing, however, it is typical to use or aggregate the OLE
        implementation, a pointer to which is available through a call to CreateDataCache.

        When to Use
        -----------

        A client calls the methods of IOleCache to control what the data cache holds. A typical client would be an OLE Documents
        container that would cache an object's presentation so it is available without the object actually being active.

        IOleCache Methods
        -----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Cache       Adds a presentation to the data or view cache.
        Uncache     Removes a presentation previously added with IOleCache::Cache.
        EnumCache   Returns an object to enumerate the current cache connections.
        InitCache   Fills the cache with all the presentation data from the data object.
        SetData     Fills the cache with specified format of presentation data. *)

     ppIOleCache = ^pIOleCache;
     pIOleCache = ^IOleCache;

     IOleCache = Class (IUnknown)
                 Public
{&StdCall+}
                   Function Cache (var FormatEtc : tFormatEtc; advf : LongInt; var dwConnection : LongInt) : hResult;
                      virtual; abstract;
                   Function Uncache (dwConnection : LongInt) : hResult;
                      virtual; abstract;
                   Function EnumCache (var EnumStatData : IEnumStatData) : hResult;
                      virtual; abstract;
                   Function InitCache (DataObject : IDataObject) : hResult;
                      virtual; abstract;
                   Function SetData (var FormatEtc : tFormatEtc; var Medium : tStgMedium; fRelease : BOOL) : HResult;
                      virtual; abstract;
{&StdCall-}
                 end;


     (* IOleCache2 interface
        ====================

        The IOleCache2 interface allows object clients to selectively update each cache that was created with IOleCache::Cache.

        When to Implement
        -----------------

        The IOleCache2 interface can be implemented by an object handler and an in-process server. Rather than implementing,
        however, it is typical to use or aggregate the OLE implementation in the default handler, a pointer to which is available
        through a call to CreateDataCache.

        When to Use
        -----------

        The OLE-provided implementation includes implementations of the IOleCache interface methods, from which IOleCache2
        inherits its contract definition. The IOleCache2 interface is called by container applications, object handlers, or in
        process servers to update one or more of the caches that were created with the IOleCache::Cache method. This extended
        interface was added so client applications can exercise precise control over updates to the caches being maintained.

        IOleCache2 Methods
        ------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleCache.Cache
        IOleCache.Uncache
        IOleCache.EnumCache
        IOleCache.InitCache
        IOleCache.SetData
        UpdateCache    Updates the specified cache(s).
        DiscardCache   Discards cache(s) found in memory. *)

     ppIOleCache2 = ^pIOleCache2;
     pIOleCache2 = ^IOleCache2;

     IOleCache2 = Class (IOleCache)
                  Public
{&StdCall+}
                    Function UpdateCache (DataObject : IDataObject; grfUpdf : LongInt; pReserved : Pointer) : hResult;
                       virtual; abstract;
                    Function DiscardCache (dwDiscardOptions : LongInt) : hResult;
                       virtual; abstract;
{&StdCall-}
                  end;


     (* IOleCacheControl interface
        ==========================

        The IOleCacheControl interface provides proper maintenance of caches. It maintains the caches by connecting the running
        object's IDataObject implementation to the cache, allowing the cache to receive notifications from the running object.

        When to Implement
        -----------------

        The OLE-provided implementation is used by most handlers and in-process servers. You can get a pointer to the OLE data
        cache object through a call to CreateDataCache.

        When to Use
        -----------

        Object handlers and in-process servers use this interface internally to connect the cache part of the handler to the
        IDataObject implementation on the running object. Container applications have no need for this interface; they use
        IRunnableObject or OleRun instead.

        IOleCacheControl Methods
        ------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        OnRun    Notifies the cache when the data object is running so the cache object can establish advise sinks as needed.
        OnStop   Notifies the cache to terminate any existing advise sinks. *)

     ppIOleCacheControl = ^pIOleCacheControl;
     pIOleCacheControl = ^IOleCacheControl;

     IOleCacheControl = Class (IUnknown)
                        Public
{&StdCall+}
                          Function OnRun (DataObject : IDataObject) : hResult;
                             virtual; abstract;
                          Function OnStop : hResult;
                             virtual; abstract;
{&StdCall-}
                        end;


     (* IParseDisplayName interface
        ===========================

        The IParseDisplayName interface parses a displayable name string to convert it into a moniker. Display name parsing is
        necessary when the end user inputs a string to identify a component, as in the following situations:

         A compound document application that supports linked components typically supports the Edit:Links... dialog box.
        Through this dialog box, the end user can enter a display name to specify a new link source for a specified linked
        component. The compound document needs to have this input string converted into a moniker.
         A script language such as the macro language of a spreadsheet can allow textual references to a component.
        The language's interpreter needs to have such a reference converted into a moniker in order to execute the macro.

        When to Implement
        -----------------

        Compound document applications that support links to embedded components or to pseudo-objects within their documents must
        provide an implementation of the IOleItemContainer interface, which is derived indirectly from IParseDisplayName. In
        effect, such a compound document is providing a namespace for identifying its internal components; and its
        IOleItemContainer implementation (which includes the IParseDisplayName implementation) is the interface through which
        another application can access this namespace. Alternatively, the compound document application can implement
        IParseDisplayName as part of its class object, which is accessible through the CoGetClassObject function.

        When to Use
        -----------

        If you are implementing your own moniker class, you might need to use this interface from your implementation of
        IMoniker::ParseDisplayName. If you call the MkParseDisplayName function, you are indirectly using IParseDisplayName.

        IParseDisplayName Methods
        -------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        ParseDisplayName   Parses the display name. *)

     ppIParseDisplayName = ^pIParseDisplayName;
     pIParseDisplayName = ^IParseDisplayName;

     IParseDisplayName = Class (IUnknown)
                         Public
{&StdCall+}
                           Function ParseDisplayName (bc : IBindCtx; pszDisplayName : pOleStr; var chEaten : LongInt;
                                                      var mkOut : IMoniker) : hResult;
                              virtual; abstract;
{&StdCall-}
                         end;


     (* IOleContainer interface
        =======================

        The IOleContainer interface is used to enumerate objects in a compound document or lock a container in the running state.
        Container and object applications both implement this interface.

        When to Implement
        -----------------

        Applications that support links and links to embedded objects implement this interface to provide object enumeration, name
        parsing, and silent updates of link sources. Simple, nonlinking containers do not need to implement IOleContainer if it is
        useful mainly to support links to embedded objects.

        When to Use
        -----------

        Call IOleContainer to enumerate the objects in a compound document or to lock a container so that silent updates of link
        sources can be carried out safely.
        Many applications inherit the functions of IOleContainer by implementing IOleItemContainer, which is used to bind item
        monikers.

        IOleContainer Methods
        ---------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IParseDisplayName.ParseDisplayName
        EnumObjects     Enumerates objects in a container.
        LockContainer   Keeps container running until explicitly released. *)

     ppIOleContainer = ^pIOleContainer;
     pIOleContainer = ^IOleContainer;

     IOleContainer = Class (IParseDisplayName)
                     Public
{&StdCall+}
                       Function EnumObjects (grfFlags : LongInt; var Enum : IEnumUnknown) : hResult;
                          virtual; abstract;
                       Function LockContainer (fLock : BOOL) : hResult;
                          virtual; abstract;
{&StdCall-}
                     end;


     (* IOleClientSite interface
        ========================

        The IOleClientSite interface is the primary means by which an embedded object obtains information about the location and
        extent of its display site, its moniker, its user interface, and other resources provided by its container. An object
        server calls IOleClientSite to request services from the container. A container must provide one instance of
        IOleClientSite for every compound-document object it contains.

        IOleClientSite Methods
        ----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        SaveObject               Saves embedded object.
        GetMoniker               Requests object's moniker.
        GetContainer             Requests pointer to object's container.
        ShowObject               Asks container to display object.
        OnShowWindow             Notifies container when object becomes visible or invisible
        RequestNewObjectLayout   Asks container to resize display site. *)

     ppIOleClientSite = ^pIOleClientSite;
     pIOleClientSite = ^IOleClientSite;

     IOleClientSite = Class (IUnknown)
                      Public
{&StdCall+}
                        Function SaveObject : hResult;
                           virtual; abstract;
                        Function GetMoniker (dwAssign, dwWhichMoniker : LongInt; var mk : IMoniker) : hResult;
                           virtual; abstract;
                        Function GetContainer (var Container : IOleContainer) : hResult;
                           virtual; abstract;
                        Function ShowObject : hResult;
                           virtual; abstract;
                        Function OnShowWindow (fShow : BOOL) : hResult;
                           virtual; abstract;
                        Function RequestNewObjectLayout : hResult;
                           virtual; abstract;
{&StdCall-}
                      end;


     (* IOleObject interface
        ====================

        The IOleObject interface is the principal means by which an embedded object provides basic functionality to, and
        communicates with, its container.

        When to Implement
        -----------------

        An object application must implement this interface, along with at least IDataObject and IPersistStorage, for each type of
        embedded object that it supports. Although this interface contains 21 methods, only three are nontrivial to implement and
        must be fully implemented: DoVerb, SetHostNames, and Close. Six of the methods provide optional functionality, which, if
        not desired, can be implemented to return E_NOTIMPL: SetExtent, InitFromData, GetClipboardData, SetColorScheme, SetMoniker,
        and GetMoniker. The latter two methods are useful mainly for enabling links to embedded objects.

        When to Use
        -----------

        Call the methods of this interface to enable a container to communicate with an embedded object. A container must call
        DoVerb to activate an embedded object, SetHostNames to communicate the names of the container application and container
        document, and Close to move an object from a running to a loaded state. Calls to all other methods are optional.

        IOleObject Methods
        ------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        SetClientSite      Informs object of its client site in container.
        GetClientSite      Retrieves object's client site.
        SetHostNames       Communicates names of container application and container document.
        Close              Moves object from running to loaded state.
        SetMoniker         Informs object of its moniker.
        GetMoniker         Retrieves object's moniker.
        InitFromData       Initializes embedded object from selected data.
        GetClipboardData   Retrieves a data transfer object from the Clipboard.
        DoVerb             Invokes object to perform one of its enumerated actions ("verbs").
        EnumVerbs          Enumerates actions ("verbs") for an object.
        Update             Updates an object.
        IsUpToDate         Checks if object is up to date.
        GetUserClassID     Returns an object's class identifier.
        GetUserType        Retrieves object's user-type name.
        SetExtent          Sets extent of object's display area.
        GetExtent          Retrieves extent of object's display area.
        Advise             Establishes advisory connection with object.
        Unadvise           Destroys advisory connection with object.
        EnumAdvise         Enumerates object's advisory connections.
        GetMiscStatus      Retrieves status of object.
        SetColorScheme     Recommends color scheme to object application. *)

     ppIOleObject = ^pIOleObject;
     pIOleObject = ^IOleObject;

     IOleObject = Class (IUnknown)
                  Public
{&StdCall+}
                    Function SetClientSite (ClientSite : IOleClientSite) : hResult;
                       virtual; abstract;
                    Function GetClientSite (var ClientSite : IOleClientSite) : hResult;
                       virtual; abstract;
                    Function SetHostNames (szContainerApp, szContainerObj : pOleStr) : hResult;
                       virtual; abstract;
                    Function Close (dwSaveOption : LongInt) : hResult;
                       virtual; abstract;
                    Function SetMoniker (dwWhichMoniker : LongInt; mk : IMoniker) : hResult;
                       virtual; abstract;
                    Function GetMoniker (dwAssign, dwWhichMoniker : LongInt; var mk : IMoniker) : hResult;
                       virtual; abstract;
                    Function InitFromData (DataObject : IDataObject; fCreation : BOOL; dwReserved : LongInt) : hResult;
                       virtual; abstract;
                    Function GetClipboardData (dwReserved : LongInt; var dataObject : IDataObject) : hResult;
                       virtual; abstract;
                    Function DoVerb (iVerb : LongInt; Msg : pMsg; activeSite : IOleClientSite; lIndex : LongInt;
                                     HwndParent : HWnd; const PosRect : tRect) : hResult;
                       virtual; abstract;
                    Function EnumVerbs (var EnumOleVerb : IEnumOleVerb) : hResult;
                       virtual; abstract;
                    Function Update : hResult;
                       virtual; abstract;
                    Function IsUpToDate : hResult;
                       virtual; abstract;
                    Function GetUserClassID (var clsid : TCLSID) : hResult;
                       virtual; abstract;
                    Function GetUserType (dwFormOfType : LongInt; var pszUserType : pOleStr) : hResult;
                       virtual; abstract;
                    Function SetExtent (dwDrawAspect : LongInt; const Size : tPoint) : hResult;
                       virtual; abstract;
                    Function GetExtent (dwDrawAspect : LongInt; var Size : tPoint) : hResult;
                       virtual; abstract;
                    Function Advise (AdvSink : IAdviseSink; var dwConnection : LongInt) : hResult;
                       virtual; abstract;
                    Function Unadvise (dwConnection : LongInt) : hResult;
                       virtual; abstract;
                    Function EnumAdvise (var EnumAdvise : IEnumStatData) : hResult;
                       virtual; abstract;
                    Function GetMiscStatus (dwAspect : LongInt; var dwStatus : LongInt) : hResult;
                       virtual; abstract;
                    Function SetColorScheme (var LogPal : tLogPalette) : hResult;
                       virtual; abstract;
{&StdCall-}
                  end;


     (* IOleWindow interface
        ====================

        The IOleWindow interface provides methods that allow an application to obtain the handle to the various windows that
        participate in in-place activation, and also to enter and exit context-sensitive help mode.

        Several other in-place activation interfaces are derived from the IOleWindow interface. Containers and objects must
        implement and use these interfaces in order to support in-place activation. The following table briefly summarizes each of
        these interfaces:

        IOleWindow                    The base interface. Implemented and used by containers and objects to obtain window handles
                                      and manage context-sensitive help.
        IOleInPlaceObject             Implemented by objects and used by an object's immediate container to activate and deactivate
                                      the object.
        IOleInPlaceActiveObject       Implemented by objects and used by the top-level container to manipulate the object while it
                                      is active. Provides a direct channel of communication between an active object and its frame
                                      and document windows.
        IOleInPlaceUIWindow           Implemented by containers and used by objects to manipulate the container's document window.
        IOleInPlaceFrame              Implemented by containers and used by objects to control the container's frame window.
        IOleInPlaceSite               Implemented by containers and used by objects to interact with the in-place client site.
        IOleInPlaceSiteEx             Implemented by containers and called by objects to optimize activation and deactivation.
        IOleInPlaceSiteWIndowless     Implemented by containers and called by windowless object to obtain services from its
                                      container.
        IOleInPlaceObjectWindowless   Implemented by windowless objects called by containers to support window message processing
                                      and drag and drop operations for windowless objects.

        These interfaces can be arranged in three hierarchical levels with various interfaces implemented at each level. Calls
        that install user-interface menus commands and frame adornments, activate and switch between windows, and dispatch menu
        and keystrokes take place between the top-level container and the active object. Calls that support activating,
        deactivating, scrolling, or clipping span the containment hierarchy, with each level performing the correct actions.

                        +---------------------------------------------------------+
                        |                                                         |
                        |                                                         |
                        |  +---------------+    IOleInPlaceFrame                  |
                        |  |               |    (frame window)                    |
                        +--|   Top level   |----O <--------------------------+    |
                           |   container   |----O <------------------------+ |    |
                           |               |--+ IOleInPlaceUIWindow        | |    |
                           +---------------+  | (document window)          | |    |
                              |               |                            | |    |
              IOleInPlaceSite O               |                            | |    |
                                              v                            | |    |
                              ^                                            | |    |
                              |               O IOleInPlaceObject          | |    |
                              |               |                            | |    |
                              |  +---------------+                         | |    |
                              |  |               |                         | |    |
                              +--|  Intermediate |                         | |    |
                                 |   container   |                         | |    |
                                 |               |--+                      | |    |
                                 +---------------+  |                      | |    |
                                    |               |                      | |    |
                    IOleInPlaceSite O               |                      | |    |
                                                    v                      | |    |
                                    ^                                      | |    |
                                    |               O IOleInPlaceObject    | |    |
                                    |               |                      | |    |
                                    |  +---------------+                   | |    |
                                    |  |               |                   | |    |
                                    +--|    Active     |-------------------+ |    |
                                       |     object    |---------------------+    |
                                       |               |                          |
                                       +---------------+                          |
                                          |                                       |
                                          O IOleInPlaceActiveObject               |
                                                                                  |
                                          ^                                       |
                                          |                                       |
                                          +---------------------------------------+

        When to Implement
        -----------------

        The inherited methods of this interface are implemented by all in-place objects and containers.

        When to Use
        -----------

        Use this interface to obtain the window handle to the windows associated with in-place activation (frame, document, parent,
        and in-place object). It is also used to enter and exit context-sensitive help.

        IOleWindow Methods
        ------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetWindow              Gets a window handle.
        ContextSensitiveHelp   Controls enabling of context-sensitive help. *)

     ppIOleWindow = ^pIOleWindow;
     pIOleWindow = ^IOleWindow;

     IOleWindow = Class (IUnknown)
                  Public
{&StdCall+}
                    Function GetWindow (var Wnd : HWnd) : hResult;
                       virtual; abstract;
                    Function ContextSensitiveHelp (fEnterMode : BOOL) : hResult;
                       virtual; abstract;
{&StdCall-}
                  end;


     (* IOleLink interface
        ==================

        The IOleLink interface is the means by which a linked object provides its container with functions pertaining to linking.
        The most important of these functions is binding to the link source, that is, activating the connection to the document
        that stores the linked object's native data. IOleLink also defines functions for managing information about the linked
        object, such as the location of the link source and the cached presentation data for the linked object.

        A container application can distinguish between embedded objects and linked objects by querying for IOleLink; only linked
        objects implement IOleLink.

        When to Implement
        -----------------

        You do not have to implement this interface yourself; the system supplies an implementation of IOleLink that is suitable
        for all situations. This implementation is used automatically whenever you create or load a linked object.

        When to Use
        -----------

        You must use IOleLink if you are writing a container application that allows its documents to contain linked objects.
        You primarily call IOleLink methods in order to implement the Links dialog box. If you use the OleUIEditLinks function to
        display the Links dialog box, your calls to IOleLink methods take place in your implementation of the IOleUILinkContainer
        interface.
        Some IOleLink methods don't have to be called directly. Instead, you call methods of IOleObject; the default linked object
        provides an implementation of IOleObject that often calls methods of IOleLink. For example, a container application
        typically activates a linked object by calling IOleObject::DoVerb, which in turn calls IOleLink::BindToSource.

        IOleLink Methods
        ----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        SetUpdateOptions       Sets the update options.
        GetUpdateOptions       Returns the update options.
        SetSourceMoniker       Sets the moniker for the link source.
        GetSourceMoniker       Returns the moniker for the link source.
        SetSourceDisplayName   Sets the display name for the link source.
        GetSourceDisplayName   Returns the display name for the link source.
        BindToSource           Binds the moniker to the link source.
        BindIfRunning          Binds the moniker if the source is running.
        GetBoundSource         Returns a pointer to the link source if it's running.
        UnbindSource           Break connection to the link source.
        Update                 Update the cached views of the link source. *)

     ppIOleLink = ^pIOleLink;
     pIOleLink = ^IOleLink;

     IOleLink = Class (IUnknown)
                Public
{&StdCall+}
                  Function SetUpdateOptions (dwUpdateOpt : LongInt): hResult;
                     virtual; abstract;
                  Function GetUpdateOptions (var dwUpdateOpt : LongInt) : hResult;
                     virtual; abstract;
                  Function SetSourceMoniker (mk : IMoniker; const clsid : TCLSID) : hResult;
                     virtual; abstract;
                  Function GetSourceMoniker (var mk : IMoniker) : hResult;
                     virtual; abstract;
                  Function SetSourceDisplayName (pszDisplayName : pOleStr) : hResult;
                     virtual; abstract;
                  Function GetSourceDisplayName (var pszDisplayName : pOleStr) : hResult;
                     virtual; abstract;
                  Function BindToSource (Bindflags : LongInt; bc : IBindCtx) : hResult;
                     virtual; abstract;
                  Function BindIfRunning : hResult;
                     virtual; abstract;
                  Function GetBoundSource (var Unk : IUnknown) : hResult;
                     virtual; abstract;
                  Function UnbindSource : hResult;
                     virtual; abstract;
                  Function Update (bc : IBindCtx) : hResult;
                     virtual; abstract;
{&StdCall-}
                end;


     (* IOleItemContainer interface
        ===========================

        The IOleItemContainer interface is used by item monikers when they are bound to the objects they identify.

        When any container of objects uses item monikers to identify its objects, it must define a naming scheme for those objects.
        The container's IOleItemContainer implementation uses knowledge of that naming scheme to retrieve an object given a
        particular name. Item monikers use the container's IOleItemContainer implementation during binding.

        When to Implement
        -----------------

        You must implement IOleItemContainer if you're a moniker provider handing out item monikers. Being a moniker provider means
        handing out monikers that identify your objects to make them accessible to moniker clients. You must use item monikers if
        the objects you're identifying are contained within another object and can be individually identified using a string.
        The most common example of moniker providers are OLE applications that support linking. If your OLE application supports
        linking to objects smaller than a file-based document, you need to use item monikers. For a server application that allows
        linking to a portion of a document (such as selections within a document), you use the item monikers to identify those
        objects. For a container application that allows linking to embedded objects, you use the item monikers to identify the
        embedded objects.

        You must define a naming scheme for identifying the objects within the container; for example, embedded objects in a
        document could be identified with names of the form "embedobj1," "embedobj2," and so forth, while ranges of cells in a
        spreadsheet could be identified with names of the form "A1:E7," "G5:M9," and so forth. (Ranges of cells in a spreadsheet
        are examples of "pseudo-objects" because they do not have their own persistent storage, but simply represent a portion of
        the container's internal state.) You create an item moniker that represents an object's name using the CreateItemMoniker
        function and hand it out to a moniker client. When an item moniker is bound, your implementation of IOleItemContainer must
        be able to take a name and retrieve the corresponding object.

        When to Use
        -----------

        Applications typically do not call IOleItemContainer methods directly. The item moniker implementation of IMoniker is the
        primary caller of IOleItemContainer methods.

        IOleItemContainer Methods
        -------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IParseDisplayName.ParseDisplayName
        IOleContainer.EnumObjects
        IOleContainer.LockContainer
        GetObject          Returns a pointer to a specified object.
        GetObjectStorage   Returns a pointer to an object's storage.
        IsRunning          Checks whether an object is running. *)

     ppIOleItemContainer = ^pIOleItemContainer;
     pIOleItemContainer = ^IOleItemContainer;

     IOleItemContainer = Class (IOleContainer)
                         Public
{&StdCall+}
                           Function GetObject (pszItem : pOleStr; dwSpeedNeeded : LongInt; bc : IBindCtx; const iid : TIID;
                                               var vObject) : hResult;
                              virtual; abstract;
                           Function GetObjectStorage (pszItem : pOleStr; bc : IBindCtx; const iid : TIID; var vStorage) : hResult;
                              virtual; abstract;
                           Function IsRunning (pszItem : pOleStr) : hResult;
                              virtual; abstract;
{&StdCall-}
                         end;


     (* IOleInPlaceUIWindow interface
        =============================

        The IOleInPlaceUIWindow interface is implemented by container applications and used by object applications to negotiate
        border space on the document or frame window. The container provides a RECT structure in which the object can place
        toolbars and other similar controls, determines if tools can in fact be installed around the object's window frame,
        allocates space for the border, and establishes a communication channel between the object and each frame and document
        window.

        The document window may not exist in all applications. When this is the case, IOleInPlaceSite::GetWindowContext returns
        NULL for IOleInPlaceUIWindow.

        When to Implement
        -----------------

        You must implement this interface if you are writing a container application that will participate in in-place activation.

        When to Use
        -----------

        Used by object applications to negotiate border space on the document or frame window when one of its objects is being
        activated, or to renegotiate border space if the size of the object changes.

        IOleInPlaceUIWindow Methods
        ---------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleWindow.GetWindow
        IOleWindow.ContextSensitiveHelp
        GetBorder             Specifies a RECT structure for toolbars and controls.
        RequestBorderSpace    Determines if tools can be installed around object's window frame.
        SetBorderSpace        Allocates space for the border.
        SetActiveObject       Provides for direct communication between the object and each document and frame window. *)

     ppIOleInPlaceUIWindow = ^pIOleInPlaceUIWindow;
     pIOleInPlaceUIWindow = ^IOleInPlaceUIWindow;

     IOleInPlaceUIWindow = Class (IOleWindow)
                           Public
{&StdCall+}
                             Function GetBorder (var RectBorder : tRect) : hResult;
                                virtual; abstract;
                             Function RequestBorderSpace (const BorderWidths : tRect) : hResult;
                                virtual; abstract;
                             Function SetBorderSpace (pBorderWidths : pRect) : hResult;
                                virtual; abstract;
                             Function SetActiveObject (activeObject : IOleInPlaceActiveObject; pszObjName : pOleStr) : hResult;
                                virtual; abstract;
{&StdCall-}
                           end;


     (* IOleInPlaceActiveObject interface
        =================================

        The IOleInPlaceActiveObject interface provides a direct channel of communication between an in-place object and the
        associated application's outer-most frame window and the document window within the application that contains the
        embedded object. The communication involves the translation of messages, the state of the frame window (activated or
        deactivated), and the state of the document window (activated or deactivated). Also, it informs the object when it needs
        to resize its borders, and manages modeless dialog boxes.

        When to Implement
        -----------------

        This interface is implemented by object applications in order to provide support for their objects while they are active
        in-place.

        When to Use
        -----------

        These methods are used by the in-place object's top-level container to manipulate objects while they are active.

        IOleInPlaceActiveObject Methods
        -------------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleWindow.GetWindow
        IOleWindow.ContextSensitiveHelp
        TranslateAccelerator    Translates messages.
        OnFrameWindowActivate   State of container's top-level frame.
        OnDocWindowActivate     State of container document window.
        ResizeBorder            Alert object of need to resize border space.
        EnableModeless          Enable or disable modeless dialog boxes. *)

     ppIOleInPlaceActiveObject = ^pIOleInPlaceActiveObject;
     pIOleInPlaceActiveObject = ^IOleInPlaceActiveObject;

     IOleInPlaceActiveObject = Class (IOleWindow)
                               Public
{&StdCall+}
                                 Function TranslateAccelerator (var msg : tMsg) : hResult;
                                    virtual; abstract;
                                 Function OnFrameWindowActivate (fActivate : BOOL) : hResult;
                                    virtual; abstract;
                                 Function OnDocWindowActivate (fActivate : BOOL) : hResult;
                                    virtual; abstract;
                                 Function ResizeBorder (const rcBorder : tRect; uiWindow : IOleInPlaceUIWindow;
                                                        fFrameWindow : BOOL) : hResult;
                                    virtual; abstract;
                                 Function EnableModeless (fEnable : BOOL) : hResult;
                                    virtual; abstract;
{&StdCall-}
                               end;


     (* IOleInPlaceFrame interface
        ==========================

        The IOleInPlaceFrame interface controls the container's top-level frame window. This control involves allowing the
        container to insert its menu group into the composite menu, install the composite menu into the appropriate window frame,
        and remove the container's menu elements from the composite menu. It sets and displays status text relevant to the
        in-place object. It also enables or disables the frame's modeless dialog boxes, and translates accelerator keystrokes
        intended for the container's frame.

        When to Implement
        -----------------

        You will need to implement this interface if you are writing a container application that will be participating in
        in-place activation.

        When to Use
        -----------

        This interface is used by object applications to control the display and placement of composite menus, keystroke
        accelerator translation, context-sensitive help mode, and modeless dialog boxes.

        IOleInPlaceFrame Methods
        ------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleWindow.GetWindow
        IOleWindow.ContextSensitiveHelp
        IOleInPlaceUIWindow.GetBorder
        IOleInPlaceUIWindow.RequestBorderSpace
        IOleInPlaceUIWindow.SetBorderSpace
        IOleInPlaceUIWindow.SetActiveObject
        InsertMenus            Allows container to insert menus.
        SetMenu                Adds a composite menu to window frame.
        RemoveMenus            Removes a container's menu elements.
        SetStatusText          Sets and displays status text about.
        EnableModeless         Enables or disables modeless dialog boxes.
        TranslateAccelerator   Translates keystrokes. *)

     pOleInPlaceFrameInfo = ^tOleInPlaceFrameInfo;
     tagOIFI = Record
                 cb : Integer;
                 fMDIApp : BOOL;
                 hwndFrame : HWnd;
                 hAccel : hAccel;
                 cAccelEntries : Integer;
               end;
     tOleInPlaceFrameInfo = tagOIFI;
     OLEINPLACEFRAMEINFO = tagOIFI;

     pOleMenuGroupWidths = ^tOleMenuGroupWidths;
     tagOleMenuGroupWidths = Record
                               Width : Array [0..5] of LongInt;
                             end;
     tOleMenuGroupWidths = tagOleMenuGroupWidths;
     OLEMENUGROUPWIDTHS = tagOleMenuGroupWidths;

     ppIOleInPlaceFrame = ^pIOleInPlaceFrame;
     pIOleInPlaceFrame = ^IOleInPlaceFrame;

     IOleInPlaceFrame = Class (IOleInPlaceUIWindow)
                        Public
{&StdCall+}
                          Function InsertMenus (hMenuShared : hMenu; var MenuWidths : tOleMenuGroupWidths) : hResult;
                             virtual; abstract;
                          Function SetMenu (hMenuShared, hOleMenu : hMenu; HWndActiveObject : HWnd) : hResult;
                             virtual; abstract;
                          Function RemoveMenus (hMenuShared : hMenu) : hResult;
                             virtual; abstract;
                          Function SetStatusText (pszStatusText : pOleStr) : hResult;
                             virtual; abstract;
                          Function EnableModeless (fEnable : BOOL) : hResult;
                             virtual; abstract;
                          Function TranslateAccelerator (var Msg : tMsg; wID : Word) : hResult;
                             virtual; abstract;
{&StdCall-}
                        end;


     (* IOleInPlaceObject interface
        ===========================

        The IOleInPlaceObject interface manages the activation and deactivation of in-place objects, and determines how much of
        the in-place object should be visible.

        You can obtain a pointer to IOleInPlaceObject by calling QueryInterface on IOleObject.

        When to Implement
        -----------------

        You must implement this interface if you are writing an object application that will participate in in-place activation.

        When to Use
        -----------

        Used by an object's immediate container to activate or deactivate the object.

        IOleInPlaceObject Methods
        -------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleWindow.GetWindow
        IOleWindow.ContextSensitiveHelp
        InPlaceDeactivate   Deactivate active in-place object.
        UIDeactivate        Deactivate and remove UI of active object.
        SetObjectRects      Portion of in-place object to be visible.
        ReactivateAndUndo   Reactivate previously deactivated object. *)

     ppIOleInPlaceObject = ^pIOleInPlaceObject;
     pIOleInPlaceObject = ^IOleInPlaceObject;

     IOleInPlaceObject = Class (IOleWindow)
                         Public
{&StdCall+}
                           Function InPlaceDeactivate : hResult;
                              virtual; abstract;
                           Function UIDeactivate : hResult;
                              virtual; abstract;
                           Function SetObjectRects (const rcPosRect, rcClipRect : tRect) : hResult;
                              virtual; abstract;
                           Function ReactivateAndUndo : hResult;
                              virtual; abstract;
{&StdCall-}
                         end;


     (* IOleInPlaceSite interface
        =========================

        The IOleInPlaceSite interface manages interaction between the container and the object's in-place client site.
        Recall that the client site is the display site for embedded objects, and provides position and conceptual information
        about the object.

        This interface provides methods that manage in-place objects. With IOleInPlaceSite, you can determine if an object can be
        activated and manage its activation and deactivation. You can notify the container when one of its objects is being
        activated and inform the container that a composite menu will replace the container's regular menu. It provides methods
        that make it possible for the in-place object to retrieve the window object hierarchy, and the position in the parent
        window where the object should place its in-place activation window. Finally, it determines how the container scrolls the
        object, manages the object undo state, and notifies the object when its borders have changed.

        When to Implement
        -----------------

        You must implement this interface if you are writing a container application that will participate in in-place activation.

        When to Use
        -----------

        Use this interface to allow your object to control in-place activation from within the container.
        The IOleInPlaceSite interface pointer is obtained by calling QueryInterface on the object's IOleClientSite interface.

        IOleInPlaceSite Methods
        -----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleWindow.GetWindow
        IOleWindow.ContextSensitiveHelp
        CanInPlaceActivate    Determines if the container can activate the object in place.
        OnInPlaceActivate     Notifies the container that one of its objects is being activated in place.
        OnUIActivate          Notifies the container that the object is about to be activated in place, and that the main menu
                              will be replaced by a composite menu.
        GetWindowContext      Enables an in-place object to retrieve window interfaces that form at the window object hierarchy,
                              and the position in the parent window to locate the object's in-place activation window.
        Scroll                Specifies the number of pixels by which the container is to scroll the object.
        OnUIDeactivate        Notifies the container to reinstall its user interface and take focus.
        OnInPlaceDeactivate   Notifies the container that the object is no longer active in place.
        DiscardUndoState      Instructs the container to discard its undo state.
        DeactivateAndUndo     Deactivate the object and revert to undo state.
        OnPosRectChange       Object's extents have changed. *)

     ppIOleInPlaceSite = ^pIOleInPlaceSite;
     pIOleInPlaceSite = ^IOleInPlaceSite;

     IOleInPlaceSite = Class (IOleWindow)
                       Public
{&StdCall+}
                         Function CanInPlaceActivate : hResult;
                            virtual; abstract;
                         Function OnInPlaceActivate : hResult;
                            virtual; abstract;
                         Function OnUIActivate : hResult;
                            virtual; abstract;
                         Function GetWindowContext (var Frame : IOleInPlaceFrame; var Doc : IOleInPlaceUIWindow;
                                                    var rcPosRect, rcClipRect : tRect;
                                                    var FrameInfo : tOleInPlaceFrameInfo) : hResult;
                            virtual; abstract;
                         Function Scroll (ScrollExtent : tPoint) : hResult;
                            virtual; abstract;
                         Function OnUIDeactivate (fUndoable : BOOL) : hResult;
                            virtual; abstract;
                         Function OnInPlaceDeactivate : hResult;
                            virtual; abstract;
                         Function DiscardUndoState : hResult;
                            virtual; abstract;
                         Function DeactivateAndUndo : hResult;
                            virtual; abstract;
                         Function OnPosRectChange (const rcPosRect : tRect) : hResult;
                            virtual; abstract;
{&StdCall-}
                       end;


     (* IViewObject interface
        =====================

        The IViewObject interface enables an object to display itself directly without passing a data object to the caller.
        In addition, this interface can create and manage a connection with an advise sink so the caller can be notified of
        changes in the view object.

        The caller can request specific representations and specific target devices. For example, a caller can ask for either an
        object's content or an iconic representation. Also, the caller can ask the object to compose a picture for a target device
        that is independent of the drawing device context. As a result, the picture can be composed for one target device and
        drawn on another device context. For example, to provide a print preview operation, you can compose the drawing for a
        printer target device but actually draw the representation on the display.

        The IViewObject interface is similar to IDataObject; except that IViewObject places a representation of the data onto a
        device context while IDataObject places the representation onto a transfer medium.
        Unlike most other interfaces, IViewObject cannot be marshaled to another process. This is because device contexts are only
        effective in the context of one process.

        When to Implement
        -----------------

        Object handlers and in-process servers that manage their own presentations implement IViewObject for use by compound
        document containers. OLE provides an IViewObject implementation for its default object handler's cache.

        When to Use
        -----------

        You call IViewObject from a container application if you need to draw a contained object on a specific device context.
        For example, if you want to print the object to a printer, you call the Draw method in the IViewObject interface.

        IViewObject Methods
        -------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Draw          Draws a representation of the object onto a device context.
        GetColorSet   Returns the logical palette the object uses for drawing.
        Freeze        Freezes the drawn representation of an object so it will not change until a subsequent Unfreeze.
        Unfreeze      Unfreezes the drawn representation of an object.
        SetAdvise     Sets up a connection between the view object and an advise sink so that the advise sink can receive
                      notifications of changes in the view object.
        GetAdvise     Returns the information on the most recent SetAdvise. *)

     tContinueFunc = Function (dwContinue : LongInt) : BOOL   stdcall;

     ppIViewObject = ^pIViewObject;
     pIViewObject = ^IViewObject;

     IViewObject = Class (IUnknown)
                   Public
{&StdCall+}
                     Function Draw (dwDrawAspect, lIndex : LongInt; pvAspect : Pointer; ptd : pDVTargetDevice;
                                    hicTargetDev, hdcDraw : hDC; prcBounds, prcWBounds : pRect; fnContinue : tContinueFunc;
                                    dwContinue : LongInt) : hResult;
                        virtual; abstract;
                     Function GetColorSet (dwDrawAspect, lIndex : LongInt; pvAspect : Pointer; ptd : PDVTargetDevice;
                                           hicTargetDev : hDC; var colorSet : pLogPalette) : hResult;
                        virtual; abstract;
                     Function Freeze (dwDrawAspect, lIndex : LongInt; pvAspect : Pointer; var dwFreeze : LongInt) : hResult;
                        virtual; abstract;
                     Function Unfreeze (dwFreeze : LongInt) : hResult;
                        virtual; abstract;
                     Function SetAdvise (Aspects, advf : LongInt; advSink : IAdviseSink) : hResult;
                        virtual; abstract;
                     Function GetAdvise (pAspects, pAdvf : pLongInt; var advSink : IAdviseSink) : hResult;
                        virtual; abstract;
{&StdCall-}
                   end;


     (* IViewObject2 interface
        ======================

        The IViewObject2 interface is an extension to the IViewObject interface which returns the size of the drawing for a given
        view of an object. You can prevent the object from being run if it isn't already running by calling this method instead
        of IOleObject::GetExtent.

        Like the IViewObject interface, IViewObject2 cannot be marshaled to another process. This is because device contexts are
        only effective in the context of one process.
        The OLE-provided default implementation provides the size of the object in the cache.

        When to Implement
        -----------------

        Object handlers and in-process servers that manage their own presentations implement IViewObject2 for use by compound
        document containers.

        When to Use
        -----------

        A container application or object handler calls the GetExtent method in the IViewObject2 interface to get the object's
        size from its cache.

        IViewObject2 Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IViewObject.Draw
        IViewObjectGetColorSet
        IViewObject.Freeze
        IViewObject.Unfreeze
        IViewObject.SetAdvise
        IViewObject.GetAdvise
        GetExtent   Returns the size of the view object from the cache. *)

     ppIViewObject2 = ^pIViewObject2;
     pIViewObject2 = ^IViewObject2;

     IViewObject2 = Class (IViewObject)
                    Public
{&StdCall+}
                      Function GetExtent (dwDrawAspect, lIndex : LongInt; ptd : pDVTargetDevice; var Size : tPoint) : hResult;
                         virtual; abstract;
{&StdCall-}
                    end;


     (* IDropSource interface
        =====================

        The IDropSource interface is one of the interfaces you implement to provide drag-and-drop operations in your application.
        It contains methods used in any application used as a data source in a drag-and-drop operation. The data source
        application in a drag-and-drop operation is responsible for:

         Determining the data being dragged based on the user's selection.
         Initiating the drag-and-drop operation based on the user's mouse actions.
         Generating some of the visual feedback during the drag-and-drop operation, such as setting the cursor and highlighting
          the data selected for the drag-and-drop operation.
         Canceling or completing the drag-and-drop operation based on the user's mouse actions.
         Performing any action on the original data caused by the drop operation, such as deleting the data on a drag move.

        IDropSource contains the methods for generating visual feedback to the end user and for canceling or completing the
        drag-and-drop operation. You also need to call the DoDragDrop, RegisterDragDrop, and RevokeDragDrop functions in
        drag-and-drop operations.

        When to Implement
        -----------------

        Implement IDropSource if you are developing a container or server application that can act as a data source for a
        drag-and-drop operation. The IDropSource interface is only required during the drag-and-drop operation.
        If you implement the IDropSource interface, you must also implement the IDataObject interface on the same object to
        represent the data being transferred.
        You can use the same implementation of IDataObject for drag-and-drop data as for the data object offered to the clipboard.
        Once you have implemented clipboard operations in your application, you can add drag-and-drop operations with only a
        little extra work.

        When to Use
        -----------

        You don't usually call IDropSource methods directly. Instead, your data source calls the DoDragDrop function when it
        detects that the user has initiated a drag-and-drop operation. Then, DoDragDrop calls the IDropSource methods during the
        drag-and-drop operation.
        For example, DoDragDrop calls IDropSource::GiveFeedback when you need to change the cursor shape or when you need to
        provide some other visual feedback. DoDragDrop calls IDropSource::QueryContinueDrag when there is a change in the mouse
        button state to determine if the drag-and-drop operation was canceled or completed.

        IDropSource Methods
        -------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        QueryContinueDrag   Determines whether a drag-and-drop operation should continue.
        GiveFeedback        Gives visual feedback to an end user during a drag-and-drop operation. *)

     ppIDropSource = ^pIDropSource;
     pIDropSource = ^IDropSource;

     IDropSource = Class (IUnknown)
                   Public
{&StdCall+}
                     Function QueryContinueDrag (fEscapePressed : BOOL; grfKeyState : LongInt) : hResult;
                        virtual; abstract;
                     Function GiveFeedback (dwEffect : LongInt) : hResult;
                        virtual; stdcall;  abstract;
{&StdCall-}
                   end;


     (* IDropTarget interface
        =====================

        The IDropTarget interface is one of the interfaces you implement to provide drag-and-drop operations in your application.
        It contains methods used in any application that can be a target for data during a drag-and-drop operation.
        A drop-target application is responsible for:

         Determining the effect of the drop on the target application.
         Incorporating any valid dropped data when the drop occurs.
         Communicating target feedback to the source so the source application can provide appropriate visual feedback such as
          setting the cursor.
         Implementing drag scrolling.
         Registering and revoking its application windows as drop targets.

        The IDropTarget interface contains methods that handle all these responsibilities except registering and revoking the
        application window as a drop target, for which you must call the RegisterDragDrop and the RevokeDragDrop functions.

        When to Implement
        -----------------

        Implement the IDropTarget interface if you are developing an application that can act as a target for a drag-and-drop
        operation. The IDropTarget interface is associated with your application windows and is implemented on your window objects.
        Call the RegisterDragDrop function to register your window objects as drop targets.

        When to Use
        -----------

        You do not call the methods of IDropTarget directly. The DoDragDrop function calls the IDropTarget methods during the
        drag-and-drop operation.
        For example, DoDragDrop calls IDropTarget::DragEnter when it detects the mouse has moved over a window that is registered
        as a drag target. Once the mouse has entered a drag-target window, DoDragDrop calls IDropTarget::DragOver as the mouse
        moves through the window and calls IDropTarget::DragLeave if the mouse leaves the target window or if the user cancels or
        completes the drag-and-drop operation. DoDragDrop calls IDropTarget::Drop if the drop finally occurs.

        IDropTarget Methods
        -------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        DragEnter   Determines whether a drop can be accepted and its effect if it is accepted.
        DragOver    Provides target feedback to the user through the DoDragDrop function.
        DragLeave   Causes the drop target to suspend its feedback actions.
        Drop        Drops the data into the target window. *)

     ppIDropTarget = ^pIDropTarget;
     pIDropTarget = ^IDropTarget;

     IDropTarget = Class (IUnknown)
                   Public
{&StdCall+}
                     Function DragEnter (DataObj : IDataObject; grfKeyState : LongInt; pt : tPoint;
                                         var dwEffect : LongInt) : hResult;
                        virtual; abstract;
                     Function DragOver (grfKeyState : LongInt; pt : tPoint; var dwEffect : LongInt) : hResult;
                        virtual; abstract;
                     Function DragLeave : hResult;
                        virtual; abstract;
                     Function Drop (DataObj : IDataObject; grfKeyState : LongInt; pt : tPoint; var dwEffect : LongInt) : hResult;
                        virtual; abstract;
{&StdCall-}
                   end;


     (* IEnumOleVerb interface
        ======================

        The IEnumOleVerb interface enumerates the different verbs available for an object in order of ascending verb number.
        An enumerator that implements the IEnumOLEVERB interface is returned by IOleObject::EnumVerbs. IEnumOleVerb has the same
        methods as all enumerator interfaces: Next, Skip, Reset, and Clone. For general information on these methods, refer to
        IEnumXXXX.

        When to Implement
        -----------------

        You typically do not have to implement this interface. The OLE default handler provides an implementation that supplies
        the entries in the registry. Because calls to IOleObject::EnumVerb are always routed through the default handler, an OLE
        application can let the default handler do the work by implementing IOleObject::EnumVerb as a stub that simply returns
        OLE_S_USEREG. This informs the default handler that it should create the enumerator for you.

        When to Use
        -----------

        Call this interface if you need to list the verbs than an OLE object supports.

        IEnumEleVerb Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Next    Retrieves the next celt items in the enumeration sequence. If there are fewer than the requested number of elements
                left in the sequence, it retrieves the remaining elements. The number of elements actually retrieved is returned through
                pceltFetched (unless the caller passed in NULL for that parameter).
        Skip    Skips over the next specified number of elements in the enumeration sequence.
        Reset   Resets the enumeration sequence to the beginning.
        Clone   Creates another enumerator that contains the same enumeration state as the current one.
                Using this function, a client can record a particular point in the enumeration sequence, and then return to that
                point at a later time. The new enumerator supports the same interface as the original one. *)

     pOleVerb = ^tOleVerb;
     tagOLEVERB = Record
                    lVerb : LongInt;
                    lpszVerbName : pOleStr;
                    fuFlags : LongInt;
                    grfAttribs : LongInt;
                  end;
     tOleVerb = tagOLEVERB;
     OLEVERB = tagOLEVERB;

     ppIEnumOleVerb = ^pIEnumOleVerb;
     pIEnumOleVerb = ^IEnumOleVerb;

     IEnumOleVerb = Class (IUnknown)
                    Public
{&StdCall+}
                      Function Next (celt : LongInt; var elt; pceltFetched : pLongInt) : hResult;
                         virtual; abstract;
                      Function Skip (celt : LongInt) : hResult;
                         virtual; abstract;
                      Function Reset : hResult;
                         virtual; abstract;
                      Function Clone (var enm : IEnumOleVerb) : hResult;
                         virtual; abstract;
{&StdCall-}
                    end;


     (* IOleDocumentView interface
        ==========================

        IOleDocumentView Methods
        ------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        SetInPlaceSite
        GetInPlaceSite
        GetDocument
        SetRect
        GetRect
        SetRectComplex
        Show
        UIActivate
        Open
        CloseView
        SaveViewState
        ApplyViewState
        Clone *)

     ppIOleDocumentView = ^pIOleDocumentView;
     pIOleDocumentView = ^IOleDocumentView;

     IOleDocumentView = Class (IUnknown)
                        Public
{&StdCall+}
                          Function SetInPlaceSite (Site : IOleInPlaceSite) : hResult;
                             virtual; abstract;
                          Function GetInPlaceSite (var Site : IOleInPlaceSite) : hResult;
                             virtual; abstract;
                          Function GetDocument (var Unk : IUnknown) : hResult;
                             virtual; abstract;
                          Function SetRect (const View : tRect) : hResult;
                             virtual; abstract;
                          Function GetRect (var View : tRect) : hResult;
                             virtual; abstract;
                          Function SetRectComplex (const View, HScroll, VScroll, SizeBox) : hResult;
                             virtual; abstract;
                          Function Show (fShow : BOOL) : hResult;
                             virtual; abstract;
                          Function UIActivate (fUIActivate : BOOL) : hResult;
                             virtual; abstract;
                          Function Open : hResult;
                             virtual; abstract;
                          Function CloseView (dwReserved : DWord) : hResult;
                             virtual; abstract;
                          Function SaveViewState (pstm : IStream) : hResult;
                             virtual; abstract;
                          Function ApplyViewState (pstm : IStream) : hResult;
                             virtual; abstract;
                          Function Clone (NewSite : IOleInPlaceSite; var NewView : IOleDocumentView) : hResult;
                             virtual; abstract;
{&StdCall-}
                        end;


     (* IEnumOleDocumentViews interface
        ===============================

        IEnumOleDocumentViews Methods
        -----------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Next    Retrieves the next celt items in the enumeration sequence. If there are fewer than the requested number of elements
                left in the sequence, it retrieves the remaining elements. The number of elements actually retrieved is returned through
                pceltFetched (unless the caller passed in NULL for that parameter).
        Skip    Skips over the next specified number of elements in the enumeration sequence.
        Reset   Resets the enumeration sequence to the beginning.
        Clone   Creates another enumerator that contains the same enumeration state as the current one.
                Using this function, a client can record a particular point in the enumeration sequence, and then return to that
                point at a later time. The new enumerator supports the same interface as the original one. *)

     ppIEnumOleDocumentViews = ^pIEnumOleDocumentViews;
     pIEnumOleDocumentViews = ^IEnumOleDocumentViews;

     IEnumOleDocumentViews = Class (IUnknown)
                             Public
{&StdCall+}
                               Function Next (Count : LongInt; var View : IOleDocumentView; var Fetched : LongInt) : hResult;
                                  virtual; abstract;
                               Function Skip (Count : LongInt) : hResult;
                                  virtual; abstract;
                               Function Reset : hResult;
                                  virtual; abstract;
                               Function Clone (var enm : IEnumOleDocumentViews) : hResult;
                                  virtual; abstract;
{&StdCall-}
                             end;


     (* IOleDocument interface
        ======================

        IOleDocument Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        CreateView
        GetDocMiscStatus
        EnumViews *)

     ppIOleDocument = ^pIOleDocument;
     pIOleDocument = ^IOleDocument;

     IOleDocument = Class (IUnknown)
                    Public
{&StdCall+}
                      Function CreateView (Site : IOleInPlaceSite; Stream : IStream; Reserved : DWord;
                                           var View : IOleDocumentView) : hResult;
                         virtual; abstract;
                      Function GetDocMiscStatus (var Status : DWord) : hResult;
                         virtual; abstract;
                      Function EnumViews (var Enum : IEnumOleDocumentViews; var View : IOleDocumentView) : hResult;
                         virtual; abstract;
{&StdCall-}
                    end;


     (* IOleDocumentSite interface
        ==========================

        IOleDocumentSite Methods
        ------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        ActivateMe *)

     ppIOleDocumentSite = ^pIOleDocumentSite;
     pIOleDocumentSite = ^IOleDocumentSite;

     IOleDocumentSite = Class (IUnknown)
                        Public
{&StdCall+}
                          Function ActivateMe (View : IOleDocumentView) : hResult;
                             virtual; abstract;
{&StdCall-}
                        end;


     (* IContextMenu interface
        ======================

        The IContextMenu interface is used to either create or merge a context menu associated with a certain object.

        Default context menus are available for most objects that are visible within the Explorer's name space, such as files,
        folders, and printer objects. System-provided context menus are adaptable to file objects of any type,
        provided you have made the appropriate registry entries.

        When to Implement
        -----------------

        Implement IContexMenu in the following situations :

         To add dynamic menu items to a context menu associated with an object in the shell's name space.
          Implementation is accomplished by means of a handler located within an COM in-process server DLL.
         To allow menu items to be dynamically added to non-default drag-and-drop menus.
          Implementation is accomplished by means of a handler.
         Applications may either create or merge context menus of items in the shell' name space (or extended name space).
          This is accomplished by an application calling IContextMenu using IShellFolder::GetUIObjectOf.
         A namespace extension should implement IContextMenu so that either the shell or another application can access context
          menus belonging to items in its own name space. This is accomplished by using IShellFolder::GetUIObjectOf.

        Shell extensions based on this interface must be initialized by using the IShellExtInit interface and menu items can be
        inserted by using either the InsertMenu or InsertMenuItem functions.
        Also of note is that shell extensions do not work unless all appropriate registry entries are made.

        When to Use
        -----------

        You don't call this interface directly. It is called by the shell when a user selects a context menu item that has been
        added by a handler registered under the appropriate registry keys, or when an application includes it as the riid
        parameter in a call to IShellFolder::GetUIObjectOf.

        IContextMenu Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        QueryContextMenu        Adds menu items to the specified menu.
                                The menu items should be inserted at a specified position in the menu, and their menu item
                                identifiers must be in a given range.
        InvokeCommand           Carries out a menu command, either in response to user input or otherwise.
                                For an example, see IExtractIcon.
        GetCommandString        Retrieves the language-independent name of a menu command or the help text for a menu command. *)

     pCMInvokeCommandInfo = ^tCMInvokeCommandInfo;
     tCMInvokeCommandInfo = Record
                              cbSize : DWord;          (* Must be SizeOf(CMINVOKECOMMANDINFO) *)
                              fMask : DWord;           (* Any combination of CMIC_MASK_* *)
                              HWnd : HWnd;             (* Might be Nil (indicating no owner window) *)
                              lpVerb : LPCSTR;         (* Either a string of MAKEINTRESOURCE(idOffset) *)
                              lpParameters : LPCSTR;   (* Might be Nil (indicating no parameter) *)
                              lpDirectory : LPCSTR;    (* Might be Nil (indicating no specific directory) *)
                              nShow : Integer;         (* One of SW_ values for ShowWindow() API *)
                              dwHotKey : DWord;
                              hIcon : THandle;
                            end;

     ppIContextMenu = ^pIContextMenu;
     pIContextMenu = ^IContextMenu;

     IContextMenu = Class (IUnknown)
                    Public
{&StdCall+}
                      Function QueryContextMenu (Menu : HMENU; IndexMenu, IdCmdFirst, IdCmdLast, uFlags : UINT) : hResult;
                         virtual; abstract;
                      Function InvokeCommand (var lpICI : tCMInvokeCommandInfo) : hResult;
                         virtual; abstract;
                      Function GetCommandString (IdCmd, uType : UINT; pwReserved : PUINT; pszName : LPSTR; cchMax : UINT): hResult;
                         virtual; abstract;
{&StdCall-}
                    end;


     (* IContextMenu2 interface
        =======================

        The IContextMenu2 interface is used to either create or merge a context menu associated with a certain object
        when a client of IContextMenu is supposed to handle messages associated with owner-drawn menu items.

        When to Implement
        -----------------

        Implement IContexMenu2 if your object is a client of IContextMenu when owner-drawn messages are an issue :
        Do so if it is possible to receive one of the following messages while calling TrackPopupMenu in the window procedure
        of the menu's owner window :
         WM_INITPOPUP
         WM_DRAWITEM
         WM_MEASUREITEM

        These messages are sent only if a QueryInterface call for an IContextMenu2 interface pointer is successful,
        indicating that the object supports this interface.

        When to Use
        -----------

        You do not call this interface directly. IContextMenu2 is used by the operating system only when it has confirmed that
        the application is aware of this interface.

        IContextMenu2 Methods
        ---------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IContextMenu.QueryContextMenu
        IContextMenu.InvokeCommand
        IContextMenu.GetCommandString
        HandleMenuMsg   Allows client objects of IContextMenu to handle messages associated with owner-drawn menu items. *)

     ppIContextMenu2 = ^pIContextMenu2;
     pIContextMenu2 = ^IContextMenu2;

     IContextMenu2 = Class (IContextMenu)
                     Public
{&StdCall+}
                       Function HandleMenuMsg (uMsg : UINT; wParam, lParam : Integer) : hResult;
                          virtual; abstract;
{&StdCall-}
                     end;


     (* IContextMenu3 interface
        =======================

        IContextMenu3 Methods
        ---------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IContextMenu.QueryContextMenu
        IContextMenu.InvokeCommand
        IContextMenu.GetCommandString
        IContextMenu2.HandleMenuMsg
        HandleMenuMsg2 *)

     ppIContextMenu3 = ^pIContextMenu3;
     pIContextMenu3 = ^IContextMenu3;

     IContextMenu3 = Class (IContextMenu2)
                     Public
{&StdCall+}
                       Function HandleMenuMsg2 (uMsg : UINT; wParam, lParam : Integer; var lpResult : Integer) : hResult;
                          virtual; abstract;
{&StdCall-}
                     end;


     (* IShellExtInit interface
        =======================

        The IShellExtInit interface is used to initialize shell extensions for property sheets, context menus, and drag-and-drop
        handlers (extensions that add items to context menus during non-default drag-and-drop operations).

        When to Implement
        -----------------

        Implement IShellExtInit when you are writing a handler based on IContextMenu or IShellPropSheetExt.
        Note that shell extensions based on other interfaces do not use this method of initialization

        When to Use
        -----------

        You don't use this interface directly. It is called by the shell to initialize the handler.

        IShellExtInit Methods
        ---------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Initialize   Initializes the shell extension. *)

     ppIShellExtInit = ^pIShellExtInit;
     pIShellExtInit = ^IShellExtInit;

     IShellExtInit = Class (IUnknown)
                     Public
{&StdCall+}
                       Function Initialize (pIdlFolder : pItemIDList; lpDObj : IDataObject; hKeyProgID : hKey) : hResult;
                          virtual; abstract;
{&StdCall-}
                     end;


     (* IShellPropSheetExt interface
        ============================

        Designates an interface that allows a property sheet handler to add or replace pages in the property sheet for a file
        object.

        IShellPropSheetExt Methods
        --------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        AddPages      Adds one or more pages to a property sheet for a file object.
        ReplacePage   Replaces a page in a property sheet for a control panel object. *)

     ppIShellPropSheetExt = ^pIShellPropSheetExt;
     pIShellPropSheetExt = ^IShellPropSheetExt;

     IShellPropSheetExt = Class (IUnknown)
                          Public
{&StdCall+}
                            Function AddPages (lpfnAddPage : tFNAddPropSheetPage; lParam : lParam) : hResult;
                               virtual; abstract;
                            Function ReplacePage (uPageID : UINT; lpfnReplaceWith : tFNAddPropSheetPage; lParam: lParam) : hResult;
                               virtual; abstract;
{&StdCall-}
                          end;


     (* IPersistFolder interface
        ========================

        The IPersistFolder interface is used to initialize shell folder objects.

        When to Implement
        -----------------

        When implementing a shell namespace extension, specifically IShellFolder, you need to implement this interface so the
        folder object can be initialized this is how the folder is told where it is in the shell namespace.

        When to Use
        -----------

        You don't use this interface directly. It is used by the file system implementation of IShellFolder::BindToObject when it
        is initializing a shell folder object.

        IPersisFolder Methods
        ---------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IPersist.GetClassID
        Initialize   Called when the Explorer initializes a shell folder object. *)

     ppIPersistFolder = ^pIPersistFolder;
     pIPersistFolder = ^IPersistFolder;

     IPersistFolder = Class (IPersist)
                      Public
{&StdCall+}
                        Function Initialize (pIdl : pItemIDList) : hResult;
                           virtual; abstract;
{&StdCall-}
                      end;


     (* IPersistFolder2 interface
        ========================

        IPersisFolder2 Methods
        ---------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IPersist.GetClassID
        IPersisFolder.Initialize
        GetCurFolder. *)

     ppIPersistFolder2 = ^pIPersistFolder2;
     pIPersistFolder2 = ^IPersistFolder2;

     IPersistFolder2 = Class (IPersistFolder)
                       Public
{&StdCall+}
                         Function GetCurFolder (var pIdl : pItemIDList) : HResult;
                            virtual; abstract;
{&StdCall-}
                       end;


     (* IExtractIcon interface
        ----------------------

        The IExtractIcon interface is used by the shell to retrieve icons for objects it displays.

        The operating system provides default icons for file objects but you can specify custom icons by making appropriate
        registry entries and, in some cases, by using IExtractIcon.

        When to Implement
        -----------------

        You implement IExtractIcon to provide either instance-specific icons for objects in a particular class, or icons for
        subfolders that extend the Explorer's name space. These implementations are accomplished by writing handler code in an
        OLE in-process server COM DLL.
        In addition, if you implement IShellFolder, you will need to provide an implementation of IExtractIcon that callers can
        obtain by using IShellFolder::GetUIObjectOf.
        Shell extensions based on IExtractIcon must be initialized by using IPersistFile::Load. You should also note that shell
        extensions do not work unless all appropriate registry entries are made.

        When to Use
        -----------

        In most cases, you don't call this interface directly. It is usually called by the shell when an icon has been made
        available by a properly registered handler. However, you can call IExtractIcon directly if you want to delegate the task
        of icon extracting to another object.

        IExtractIcon Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetIconLocation   Retrieves the icon location for an object.
        Extract           Extracts an icon from the specified location. *)

     IExtractIconA = Class (IUnknown)
                     Public
{&StdCall+}
                       Function GetIconLocation (uFlags : UINT; szIconFile : pAnsiChar; cchMax : UINT; var piIndex : Integer;
                                                 var pwFlags : UINT) : hResult;
                          virtual; abstract;
                       Function Extract (pszFile : pAnsiChar; nIconIndex : UINT; var phIconLarge, phIconSmall : hIcon;
                                         nIconSize : UINT) : hResult;
                          virtual; abstract;
{&StdCall-}
                     end;

     IExtractIconW = Class (IUnknown)
                     Public
{&StdCall+}
                       Function GetIconLocation (uFlags : UINT; szIconFile : pWideChar; cchMax : UINT; var piIndex : Integer;
                                                 var pwFlags : UINT) : hResult;
                          virtual; abstract;
                       Function Extract (pszFile : pWideChar; nIconIndex : UINT; var phIconLarge, phIconSmall : hIcon;
                                         nIconSize : UINT) : hResult;
                          virtual; abstract;
{&StdCall-}
                     end;

     ppIExtractIcon = ^pIExtractIcon;
     pIExtractIcon = ^IExtractIcon;

     IExtractIcon = IExtractIconA;


     (* IShellIcon interface
        ====================

        IShellIcon interface
        ====================

        The IShellIcon interface is used to obtain an icon index for an IShellFolder object. Only one instance of the interface
        for the folder  is required instead of an instance for each object, as is the case for IExtractIcon.

        When to Implement
        -----------------

        Implement IShellIcon as part of an IShellFolder implementation as a quick way to obtain the icon for an object in the
        folder.
        If IShellIcon is not implemented by an IShellFolder object, IShellFolder::GetUIObjectOf(..., IID_IExtractIcon, ...) is
        used to get an icon for all objects.

        When to Use
        -----------

        Use IShellIcon when getting icon indexes for items in a shell folder.

        IShellIcon Methods
        ------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetIconOf   Retrieves an icon for an object in a folder. *)

     ppIShellIcon = ^pIShellIcon;
     pIShellIcon = ^IShellIcon;

     IShellIcon = Class (IUnknown)
                  Public
{&StdCall+}
                    Function GetIconOf (pIdl : pItemIDList; Flags : UINT; var IconIndex : Integer) : hResult;
                       virtual; abstract;
{&StdCall-}
                  end;


     (* IShellIconOverlayIdentifier interface
        =====================================

        IShellIconOverlayIdentifier Methods
        -----------------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IsMemberOf
        GetOverlayInfo
        GetPriority *)

     ppIShellIconOverlayIdentifier = ^pIShellIconOverlayIdentifier;
     pIShellIconOverlayIdentifier = ^IShellIconOverlayIdentifier;

     IShellIconOverlayIdentifier = Class (IUnknown)
                                   Public
{&StdCall+}
                                     Function IsMemberOf (pwszPath : pWideChar; dwAttrib : DWord) : hResult;
                                        virtual; abstract;
                                     Function GetOverlayInfo (pwszIconFile : pWideChar; cchMax : Integer; var pIndex : Integer;
                                                              var pdwFlags : DWord) : hResult;
                                        virtual; abstract;
                                     Function GetPriority (var pIPriority : Integer) : hResult;
                                        virtual; abstract;
{&StdCall-}
                                   end;


     (* IShellIconOverlay interface
        ===========================

        IShellIconOverlay Methods
        -------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetOverlayIndex
        GetOverlayIconIndex *)

     ppIShellIconOverlay = ^pIShellIconOverlay;
     pIShellIconOverlay = ^IShellIconOverlay;

     IShellIconOverlay = Class (IUnknown)
                         Public
{&StdCall+}
                           Function GetOverlayIndex (pIdl : pItemIDList; var pIndex : Integer) : hResult;
                              virtual; abstract;
                           Function GetOverlayIconIndex (pIdl : pItemIDList; var pIconIndex : Integer) : hResult;
                              virtual; abstract;
{&StdCall-}
                         end;


     (* IShellLink Interface
        ====================

        Designates an interface that allows an application to create and resolve shell links.

        IShellLink Methods
        ------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetArguments          Retrieves the command-line arguments associated with a shell link object.
        GetDescription        Retrieves the description string for a shell link object.
        GetHotkey             Retrieves the hot key for a shell link object.
        GetIconLocation       Retrieves the location (path and index) of the icon for a shell link object.
        GetIDList             Retrieves the list of item identifiers for a shell link object.
        GetPath               Retrieves the path and filename of a shell link object.
        GetShowCmd            Retrieves the show (SW_) command for a shell link object.
        GetWorkingDirectory   Retrieves the name of the working directory for a shell link object.
        Resolve               Resolves a shell link by searching for the shell link object and updating the shell
                              link path and its list of identifiers (if necessary).
        SetArguments          Sets the command-line arguments associated with a shell link object.
        SetDescription        Sets the description string for a shell link object.
        SetHotkey             Sets the hot key for a shell link object.
        SetIconLocation       Sets the location (path and index) of the icon for a shell link object.
        SetIDList             Sets the list of item identifiers for a shell link object.
        SetPath               Sets the path and filename of a shell link object.
        SetRelativePath       Sets the relative path for a shell link object.
        SetShowCmd            Sets the show (SW_) command for a shell link object.
        SetWorkingDirectory   Sets the name of the working directory for a shell link object. *)


     IShellLinkA = Class (IUnknown)
                   Public
{&StdCall+}
                     Function GetArguments (pszArgs : pAnsiChar; cchMaxPath : Integer) : hResult;
                        virtual; abstract;
                     Function GetDescription (pszName : pAnsiChar; cchMaxName : Integer) : hResult;
                        virtual; abstract;
                     Function GetHotkey (var pwHotkey : Word) : hResult;
                        virtual; abstract;
                     Function GetIconLocation (pszIconPath : pAnsiChar; cchIconPath : Integer; var piIcon : Integer) : hResult;
                        virtual; abstract;
                     Function GetIDList (var ppidl : pItemIDList) : hResult;
                        virtual; abstract;
                     Function GetPath (pszFile : pAnsiChar; cchMaxPath : Integer; var pfd : tWin32FindData; fFlags : DWord) : hResult;
                        virtual; abstract;
                     Function GetShowCmd (var piShowCmd : Integer) : hResult;
                         virtual; abstract;
                     Function GetWorkingDirectory (pszDir : pAnsiChar; cchMaxPath : Integer) : hResult;
                        virtual; abstract;
                     Function Resolve (Wnd : HWnd; fFlags : DWord) : hResult;
                        virtual; abstract;
                     Function SetArguments (pszArgs : pAnsiChar) : hResult;
                        virtual; abstract;
                     Function SetDescription (pszName : pAnsiChar) : hResult;
                        virtual; abstract;
                     Function SetHotkey (wHotkey : Word) : hResult;
                        virtual; abstract;
                     Function SetIconLocation (pszIconPath : pAnsiChar; iIcon : Integer) : hResult;
                        virtual; abstract;
                     Function SetIDList (pidl : pItemIDList) : hResult;
                        virtual; abstract;
                     Function SetPath (pszFile : pAnsiChar) : hResult;
                        virtual; abstract;
                     Function SetRelativePath (pszPathRel : pAnsiChar; dwReserved : DWord) : hResult;
                        virtual; abstract;
                     Function SetShowCmd (iShowCmd : Integer) : hResult;
                        virtual; abstract;
                     Function SetWorkingDirectory (pszDir : pAnsiChar) : hResult;
                        virtual; abstract;
{&StdCall-}
                   end;

     IShellLinkW = Class (IUnknown)
                   Public
{&StdCall+}
                     Function GetArguments (pszArgs : pWideChar; cchMaxPath : Integer) : hResult;
                        virtual; abstract;
                     Function GetDescription (pszName : pWideChar; cchMaxName : Integer) : hResult;
                        virtual; abstract;
                     Function GetHotkey (var pwHotkey : Word) : hResult;
                        virtual; abstract;
                     Function GetIconLocation (pszIconPath : pWideChar; cchIconPath : Integer; var piIcon : Integer) : hResult;
                        virtual; abstract;
                     Function GetIDList (var ppidl : pItemIDList) : hResult;
                        virtual; abstract;
                     Function GetPath (pszFile : pWideChar; cchMaxPath : Integer; var pfd : tWin32FindData; fFlags : DWord) : hResult;
                        virtual; abstract;
                     Function GetShowCmd (var piShowCmd : Integer) : hResult;
                         virtual; abstract;
                     Function GetWorkingDirectory (pszDir : pWideChar; cchMaxPath : Integer) : hResult;
                        virtual; abstract;
                     Function Resolve (Wnd : HWnd; fFlags : DWord) : hResult;
                        virtual; abstract;
                     Function SetArguments (pszArgs : pWideChar) : hResult;
                        virtual; abstract;
                     Function SetDescription (pszName : pWideChar) : hResult;
                        virtual; abstract;
                     Function SetHotkey (wHotkey : Word) : hResult;
                        virtual; abstract;
                     Function SetIconLocation (pszIconPath : pWideChar; iIcon : Integer) : hResult;
                        virtual; abstract;
                     Function SetIDList (pidl : pItemIDList) : hResult;
                        virtual; abstract;
                     Function SetPath (pszFile : pWideChar) : hResult;
                        virtual; abstract;
                     Function SetRelativePath (pszPathRel : pWideChar; dwReserved : DWord) : hResult;
                        virtual; abstract;
                     Function SetShowCmd (iShowCmd : Integer) : hResult;
                        virtual; abstract;
                     Function SetWorkingDirectory (pszDir : pWideChar) : hResult;
                        virtual; abstract;
{&StdCall-}
                   end;

     ppIShellLink = ^pIShellLink;
     pIShellLink = ^IShellLink;

     IShellLink = IShellLinkA;


     (* IShellExecuteHook interface
        ===========================

        Extends the behavior of ShellExecute or ShellExecuteEx. Typically implemented by subsystems that expose the names of
        objects that users might type into the Start.Run... dialog.

        When to Implement
        -----------------

        You should implement IShellExecuteHook when you have named objects that users would expect to be able to run in the
        Start.Run... dialog.

        When to Use
        -----------

        You do not use this interface directly. It is generally used by the ShellExecuteEx code.

        IShellExecuteHook Methods
        -------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Execute   Fill in this field. *)

     IShellExecuteHookA = Class (IUnknown)
                          Public
{&StdCall+}
                            Function Execute (var ShellExecuteInfo : tShellExecuteInfo) : hResult;
                               virtual; abstract;
{&StdCall-}
                          end;

     IShellExecuteHookW = Class (IUnknown)
                          Public
{&StdCall+}
                            Function Execute (var ShellExecuteInfo : tShellExecuteInfo) : hResult;
                               virtual; abstract;
{&StdCall-}
                          end;

     ppIShellExecuteHook = ^pIShellExecuteHook;
     pIShellExecuteHook = ^IShellExecuteHook;

     IShellExecuteHook = IShellExecuteHookA;


     (* IURLSearchHook Interface
        ========================

        IURLSearchHook Methods
        ----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Translate *)

     ppIURLSearchHook = ^pIURLSearchHook;
     pIURLSearchHook = ^IURLSearchHook;

     IURLSearchHook = Class (IUnknown)
                      Public
{&StdCall+}
                        Function Translate (lpwszSearchURL : pWideChar; cchBufferSize : DWord) : hResult;
                           virtual; abstract;
{&StdCall-}
                      end;


     (* INewShortcutHook interface
        ==========================

        INewShortcutHook Methods
        ------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        SetReferent
        GetReferent
        SetFolder
        GetFolder
        GetName
        GetExtension *)

     INewShortcutHookA = Class (IUnknown)
                         Public
{&StdCall+}
                           Function SetReferent (pcszReferent : pAnsiChar; Wnd : HWnd) : hResult;
                              virtual; abstract;
                           Function GetReferent (pcszReferent : pAnsiChar; cchReferent : Integer) : hResult;
                              virtual; abstract;
                           Function SetFolder (pcszFolder : pAnsiChar; Wnd : HWnd) : hResult;
                              virtual; abstract;
                           Function GetFolder (pcszFolder : pAnsiChar; cchFolder : Integer) : hResult;
                              virtual; abstract;
                           Function GetName (pcszName : pAnsiChar; cchName : Integer) : hResult;
                              virtual; abstract;
                           Function GetExtension (pcszExtension : pAnsiChar; cchExtension : Integer) : hResult;
                              virtual; abstract;
{&StdCall-}
                         end;

     INewShortcutHookW = Class (IUnknown)
                         Public
{&StdCall+}
                           Function SetReferent (pcszReferent : pWideChar; Wnd : HWnd) : hResult;
                              virtual; abstract;
                           Function GetReferent (pcszReferent : pWideChar; cchReferent : Integer) : hResult;
                              virtual; abstract;
                           Function SetFolder (pcszFolder : pWideChar; Wnd : HWnd) : hResult;
                              virtual; abstract;
                           Function GetFolder (pcszFolder : pWideChar; cchFolder : Integer) : hResult;
                              virtual; abstract;
                           Function GetName (pcszName : pWideChar; cchName : Integer) : hResult;
                              virtual; abstract;
                           Function GetExtension (pcszExtension : pWideChar; cchExtension : Integer) : hResult;
                              virtual; abstract;
{&StdCall-}
                         end;

     ppINewShortcutHook = ^pINewShortcutHook;
     pINewShortcutHook = ^INewShortcutHook;

     INewShortcutHook = INewShortcutHookA;


     (* ICopyHook interface
        ===================

        The ICopyHook interface is a COM-based interface used to create a copy hook handler, a shell extension, that determines
        whether it is all right to move, copy, rename, or delete a shell folder or printer object. The shell calls
        ICopyHook::CopyCallback prior to performing one of these operations.

        The copy hook handler, which is an OLE in-process server (a DLL), does not perform the task itself, but does approve or
        disapprove the action. If the shell receives approval from the copy hook handler, it performs the file system operation.
        Copy hook handlers are not informed about the success of an operation, so cannot monitor actions taken on folder objects,
        except via FindFirstChangeNotify.
        A folder object can have multiple copy hook handlers. For example, even if the shell already has a copy hook handler
        registered for a particular folder object, you can still register one of your own. If two or more copy hook handlers are
        registered for an object, the shell simply calls each of them before performing one the specified file system operations.

        The shell initializes ICopyHook directly, without using the IShellExtInit or IPersistFile interfaces first.
        CopyCallback returns an integer value that indicates whether or not the shell should perform the operation. The shell will
        call each copy hook handler registered for a folder object until either all the handlers have been called or one of them
        has returned a value other than IDYES. The handler can also return IDYES to specify that the operation should be performed,
        or IDNO or IDCANCEL to specify that the operation should be discontinued.

        When to Implement
        -----------------

        Implement a copy hook handler, for example for shared folders, when you want to be able to control when, or if. these file
        system operations are performed on a given object.

        When to Use
        -----------

        You don't call this shell extension directly. ICopyHook::CopyCallback is called by the shell prior to moving, copying,
        renaming, or deleting a shell folder object.

        ICopyHook Methods
        -----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        CopyCallback   Determines whether a move, copy, delete, or rename operation on a folder object should be allowed or
                       disallowed. *)

     ICopyHookA = Class (IUnknown)
                  Public
{&StdCall+}
                    Function CopyCallback (Wnd : HWnd; wFunc, wFlags : UINT; pszSrcFile : pAnsiChar; dwSrcAttribs: DWord;
                                           pszDestFile : pAnsiChar; dwDestAttribs : DWord) : UINT;
                       virtual; abstract;
{&StdCall-}
                  end;

     ICopyHookW = Class (IUnknown)
                  Public
{&StdCall+}
                    Function CopyCallback (Wnd : HWnd; wFunc, wFlags : UINT; pszSrcFile : pWideChar; dwSrcAttribs: DWord;
                                           pszDestFile : pWideChar; dwDestAttribs : DWord) : UINT;
                       virtual; abstract;
{&StdCall-}
                  end;

     ppICopyHook = ^pICopyHook;
     pICopyHook = ^ICopyHook;

     ICopyHook = ICopyHookA;


     (* IFileViewerSite Interface
        =========================

        Designates an interface that allows a file viewer to retrieve the handle of the current pinned window or to set a new
        pinned window. The pinned window is the window in which the current file viewer is displaying a file. When the user
        selects a new file to view, the shell directs the file viewer to display the new file in the pinned window rather than to
        create a new window.

        The IFileViewerSite interface has the following member functions.

        IFileViewerSite Methods
        -----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetPinnedWindow   Retrieves the handle of the current pinned window.
        SetPinnedWindow   Sets a new pinned window. *)

     ppIFileViewerSite = ^pIFileViewerSite;
     pIFileViewerSite = ^IFileViewerSite;

     IFileViewerSite = Class (IUnknown)
                       Public
{&StdCall+}
                         Function SetPinnedWindow(Wnd : HWnd) : hResult;
                            virtual; abstract;
                         Function GetPinnedWindow (var Wnd : HWnd) : hResult;
                            virtual; abstract;
{&StdCall-}
                       end;


     (* IFileViewer interface
        =====================

        Designates an interface that allows a registered file viewer to be notified when it must show or print a file.
        The shell calls this interface when the user selects the Quick View command from a file's context menu and the file is a
        type that the file viewer recognizes. The IFileViewer interface has the following member functions:

        IFileViewer Methods
        -------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Show             Displays a file.
        ShowInitialize   Prepares to display a file.
        PrintTo          Prints a file. *)

     IFileViewerA = Class (IUnknown)
                    Public
{&StdCall+}
                      Function ShowInitialize (fsi : IFileViewerSite) : hResult;
                         virtual; abstract;
                      Function Show (var pvsi : tFVShowInfo) : hResult;
                         virtual; abstract;
                      Function PrintTo (pszDriver : pAnsiChar; fSuppressUI : BOOL) : hResult;
                         virtual; abstract;
{&StdCall-}
                    end;

     IFileViewerW = Class (IUnknown)
                    Public
{&StdCall+}
                      Function ShowInitialize (fsi : IFileViewerSite) : hResult;
                         virtual; abstract;
                      Function Show (var pvsi : tFVShowInfo) : hResult;
                         virtual; abstract;
                      Function PrintTo (pszDriver : pWideChar; fSuppressUI : BOOL) : hResult;
                         virtual; abstract;
{&StdCall-}
                    end;

     ppIFileViewer = ^pIFileViewer;
     pIFileViewer = ^IFileViewer;

     IFileViewer = IFileViewerA;


     (* IShellBrowser interface
        =======================

        The IShellBrowser interface provides services for namespace extensions and is the companion to the IShellView interface
        implemented by namespace extensions.. It is similar to the "site" interfaces that are often found in OLE hosting
        scenarios, such as IOleControl and IOleControlSite. This allows the extension to communicate with the host of the
        namespace, providing UI elements like menus, status text, and tool bars. This interface also provides the extension with a
        way to access storage to save its persistent view state.

        IShellBrowser derives from IOleWindow and it represents the container's top-level window, allowing the contained views to
        insert their menus into the composite menu, install the composite menu into the appropriate window frame and remove the
        container's menu elements from the composite menu. It sets and displays status text relevant to the in-place object. It
        also enables or disables the frame's modeless dialog boxes, and translates accelerator keystrokes intended for the
        container's frame.

        When to Implement
        -----------------

        You do not implement this interface directly. IShellBrowser is implemented by the Windows Explorer and by the Windows File
        Open Dialog.

        When to Use
        -----------

        When implementing a namespace extension, notably IShellView, you will use the IShellBrowser implementation that is passed
        to use IShellBrowser::CreateViewWindow to communicate with the  Explorer.

        IShellBrowser Methods
        ---------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleWindow.GetWindow
        IOleWindow.ContextSensitiveHelp
        InsertMenusSB            Inserts the Explorer's menu items to an empty menu created by the view.
        SetMenuSB                Installs the composite menu in the Explorer.
        RemoveMenusSB            Gives the container a chance to remove its items from a composite menu. It  perform tasks that
                                 are the opposite of InsertMenuSB.
        SetStatusTextSB          Sets and displays status text in the Explorer window.
        EnableModelessSB         Enables or disables modeless windows of the Explorer, such as a floating toolbar.
        TranslateAcceleratorSB   Reserved for future use.
        BrowseObject             Tells the Explorer to browse in another folder.
        GetViewStateStream       Returns a view-specific stream that can be used to read and write the persistent data for a view.
        GetControlWindow         Gets the window handle of an Explorer control.
        SendControlMsg           Sends messages to Explorer controls.
        QueryActiveShellView     Returns the currently activated (displayed) shellview object.
        OnViewWindowActive       Informs the Explorer that the view was activated.
        SetToolbarItems          Adds toolbar items to the Explorer's toolbar.


        +--------------------------+  <-- Explorer window
        | [] Explorer              |
        |--------------------------+       IShellBrowser
        | File Edit View ..        |
        |--------------------------|
        |        |                 |
        |        |              <-------- Content pane
        |        |                 |
        |        |                 |       IShellView
        |        |                 |
        |        |                 |
        +--------------------------+ *)

     ppIShellBrowser = ^pIShellBrowser;
     pIShellBrowser = ^IShellBrowser;

     IShellBrowser = Class (IOleWindow)
                     Public
{&StdCall+}
                       Function InsertMenusSB (hMenuShared : hMenu; var MenuWidths : tOleMenuGroupWidths) : hResult;
                          virtual; abstract;
                       Function SetMenuSB (hMenuShared : hMenu; hOleMenuReserved : hOleMenu; HWndActiveObject : HWnd) : hResult;
                          virtual; abstract;
                       Function RemoveMenusSB (hMenuShared : hMenu) : hResult;
                          virtual; abstract;
                       Function SetStatusTextSB (StatusText : pOleStr) : hResult;
                          virtual; abstract;
                       Function EnableModelessSB (Enable : BOOL) : hResult;
                          virtual; abstract;
                       Function TranslateAcceleratorSB (Msg : pMsg; ID : Word) : hResult;
                          virtual; abstract;
                       Function BrowseObject (pIdl : pItemIDList; Flags : UINT) : hResult;
                          virtual; abstract;
                       Function GetViewStateStream (Mode : DWord; var Stream : IStream) : hResult;
                          virtual; abstract;
                       Function GetControlWindow (ID : UINT; var Wnd : HWnd) : hResult;
                          virtual; abstract;
                       Function SendControlMsg (ID, Msg : UINT; wParm : wParam; lParm : lParam; var Rslt : lResult) : hResult;
                          virtual; abstract;
                       Function QueryActiveShellView (var ShellView : IShellView) : hResult;
                          virtual; abstract;
                       Function OnViewWindowActive (var ShellView : IShellView) : hResult;
                          virtual; abstract;
                       Function SetToolbarItems (TBButton : pTBButton; nButtons, uFlags : UINT) : hResult;
                          virtual; abstract;
{&StdCall-}
                     end;


     (* ICommDlgBrowser interface
        =========================

        The ICommDlgBrowser interface is used by the common file dialog boxes to extend the behavior of the shell browser.
        This interface is received by calling QueryInterface on the IShellBrowser object.

        When to Implement
        -----------------

        This interface is implemented only by the common file-dialog boxes.

        When to Use
        -----------

        Use ICommDlgBrowser when you want to provide special behavior when hosted inside the common dialog boxes.

        ICommDlgBrowser Methods
        -----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        OnDefaultCommand   Called when a user double-clicks in the view or presses the ENTER key.
        OnStateChange      Called after a state of change has occurred in a common dialog box.
        IncludeObject      Allows common dialog filter objects that the view presents. *)

     ppICommDlgBrowser = ^pICommDlgBrowser;
     pICommDlgBrowser = ^ICommDlgBrowser;

     ICommDlgBrowser = Class (IUnknown)
                       Public
{&StdCall+}
                         Function OnDefaultCommand (const ppshv : IShellView) : hResult;
                            virtual; abstract;
                         Function OnStateChange (const ppshv : IShellView; Change : ULONG) : hResult;
                            virtual; abstract;
                         Function IncludeObject (const ppshv : IShellView; pIdl : pItemIDList) : hResult;
                            virtual; abstract;
{&StdCall-}
                       end;


     (* IShellView interface
        ====================

        The IShellView interface is implemented to present a view in the Windows Explorer or folder windows. The object that
        exposes IShellView is created by a call to IShellFolder::CreateViewObject. This provides the channel of communication
        between a view object and the Explorer's outermost frame window. The communication involves the translation of messages,
        the state of the frame window (activated or deactivated), and the state of the document window (Activated or deactivated),
        the merging of menus, and toolbar items.

        When to Implement
        -----------------

        This interface is implemented by namespace extensions that want to represent themselves in the Explorer's namespace.
        This object is created by the IShellFolder object that hosts the view.

        When to Use
        -----------

        These methods are used by the shell view's Explorer window to manipulate objects while they are active.

        IShellView Methods
        ------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleWindow.GetWindow
        IOleWindow.ContextSensitiveHelp
        TranslateAccelerator    Translates accelerator key strokes when a namespace extension's view has the focus.
        EnableModeless          Enables or disables modeless dialog boxes. Not in use by the Explorer at this time.
        EnableModelessSV        Not in use at this time.
        UIActivate              Passes a value when the state of the view window is changed by events not caused by the shell
                                view itself.
        Refresh                 Responds to user input to refresh the display.
        CreateViewWindow        Creates the view window.
        DestroyViewWindow       Destroys the view window.
        GetCurrentInfo          Returns the folder settings.
        AddPropertySheetPages   Allows the view to add pages to the options property sheet.
        SaveViewState           Saves the current view state into a stream obtained by the view by calling
                                IShellBrowser::GetViewStateStream.
        SelectItem              Changes the state of items within the shell view window.
        GetItemObject           Allows callers to get an object that represents something in the view. *)

     ppIShellView = ^pIShellView;
     pIShellView = ^IShellView;

     IShellView = Class (IOleWindow)
                  Public
{&StdCall+}
                    Function TranslateAccelerator (var Msg : tMsg) : hResult;
                       virtual; abstract;
                    Function EnableModeless (Enable : Boolean) : hResult;
                       virtual; abstract;
                    Function UIActivate (State : UINT) : hResult;
                       virtual; abstract;
                    Function Refresh : hResult;
                       virtual; abstract;
                    Function CreateViewWindow (PrevView : IShellView; var FolderSettings : tFolderSettings;
                                               ShellBrowser : IShellBrowser; var Rect : tRect; var Wnd : HWnd) : hResult;
                       virtual; abstract;
                    Function DestroyViewWindow : hResult;
                       virtual; abstract;
                    Function GetCurrentInfo (var FolderSettings : tFolderSettings) : hResult;
                       virtual; abstract;
                    Function AddPropertySheetPages (Reseved : DWord; var lpfnAddPage : tFNAddPropSheetPage;
                                                    lParam : lParam) : hResult;
                       virtual; abstract;
                    Function SaveViewState : hResult;
                       virtual; abstract;
                    Function SelectItem (pIdl : pItemIDList; Flags : UINT) : hResult;
                       virtual; abstract;
                    Function GetItemObject (Item : UINT; const iid : TIID; var IPtr : Pointer) : hResult;
                       virtual; abstract;
{&StdCall-}
                  end;


     (* IShellView2 interface
        =====================

        IShellView2 methods
        -------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleWindow.GetWindow
        IOleWindow.ContextSensitiveHelp
        IShellView.TranslateAccelerator
        IShellView.EnableModeless
        IShellView.EnableModelessSV
        IShellView.UIActivate
        IShellView.Refresh
        IShellView.CreateViewWindow
        IShellView.DestroyViewWindow
        IShellView.GetCurrentInfo
        IShellView.AddPropertySheetPages
        IShellView.SaveViewState
        IShellView.SelectItem
        IShellView.GetItemObject
        GetView
        CreateViewWindow2
        HandleRename
        SelectAndPositionItem *)

     ppIShellView2 = ^pIShellView2;
     pIShellView2 = ^IShellView2;

     IShellView2 = Class (IShellView)
                   Public
{&StdCall+}
                     Function GetView (pvid : pShellViewID; uView : ULONG) : hResult;
                        virtual; abstract;
                     Function CreateViewWindow2 (SV2CreateParams : pSV2CreateParams) : hResult;
                        virtual; abstract;
                     Function HandleRename (pIdlNew : pItemIDList) : hResult;
                        virtual; abstract;
                     Function SelectAndPositionItem (pIdlItem : pItemIDList; uFlags : UINT; var Point : tPoint) : hResult;
                        virtual; abstract;
{&StdCall-}
                   end;


     (* IShellDetails interface
        =======================

        Supported on Win9x and NT4; for >= NT5 use IShellFolder2 }

        IShellDetails Methods
        ---------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetDetailsOf
        ColumnClick *)

     ppIShellDetails = ^pIShellDetails;
     pIShellDetails = ^IShellDetails;

     IShellDetails = Class (IUnknown)
                     Public
{&StdCall+}
                       Function GetDetailsOf (pIdl : pItemIDList; iColumn : UINT; var pDetails : tShellDetails) : hResult;
                          virtual; abstract;
                       Function ColumnClick (iColumn : UINT) : hResult;
                          virtual; abstract;
{&StdCall-}
                     end;


     (* IEnumIDList interface
        =====================

        The IEnumIDList interface enumerates item identifiers associated with shell folder objects. First, use
        IShellFolder::EnumObjects to create an item enumeration object and then use IEnumIDList to iterate through the item IDs
        in the enumeration object.

        IEnumIDList has the same methods as all enumerator interfaces: Next, Skip, Reset, and Clone. Next iterates through the
        item IDs one or more at a time, Skip passes over the next item ID in the list, Reset returns to the beginning of the item
        ID list, and Clone returns a duplicate item enumeration object.

        When to Implement
        -----------------

        You can implement this interface when you want a caller to be able to enumerate the item IDs contained in a folder object.
        You get a pointer to IEnumIDList through IShellFolder::EnumObjects.

        When to Use
        -----------

        You don't use this interface directly. IShellFolder::EnumObjects creates an enumeration object of this kind. In this case,
        the enumeration is a set of item identifiers. The shell calls then IEnumIDList  methods to enumerate the items contained
        in a enumeration object.

        IEnumIDList Methods
        -------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Next    Retrieves the next celt items in the enumeration sequence. If there are fewer than the requested number of elements
                left in the sequence, it retrieves the remaining elements. The number of elements actually retrieved is returned through
                pceltFetched (unless the caller passed in NULL for that parameter).
        Skip    Skips over the next specified number of elements in the enumeration sequence.
        Reset   Resets the enumeration sequence to the beginning.
        Clone   Creates another enumerator that contains the same enumeration state as the current one.
                Using this function, a client can record a particular point in the enumeration sequence, and then return to that
                point at a later time. The new enumerator supports the same interface as the original one. *)

     ppIEnumIDList = ^pIEnumIDList;
     pIEnumIDList = ^IEnumIDList;

     IEnumIDList = Class (IUnknown)
                   Public
{&StdCall+}
                     Function Next (celt : ULONG; var rgelt : pItemIDList; var pceltFetched : ULONG) : hResult;
                        virtual; abstract;
                     Function Skip (celt : ULONG) : hResult;
                        virtual; abstract;
                     Function Reset : hResult;
                        virtual; abstract;
                     Function Clone (var ppEnum : IEnumIDList) : hResult;
                        virtual; abstract;
{&StdCall-}
                   end;


     (* IShellFolder interface
        ======================

        The IShellFolder interface is used to manage folders.

        When to Implement
        -----------------

        Implement IShellFolder for objects that extend the shell's namespace. For example, if you create a separate name space
        that requires a rooted Explorer; or if you install a new name space directly within the hierarchy of the system name space.
        Only you know anything about the contents of your name space so you are responsible for implementing everything needed to
        access your data.

        When to Use
        -----------

        Use IShellFolder when you need to display or operate on the contents of the shell's namespace. Objects that support
        IShellFolder are usually created by other shell folder objects, with the root object (the Desktop shell folder) being
        returned from the SHGetDesktopFolder function.

        IShellFolder Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        ParseDisplayName   Translates a display name into an item identifier list.
        EnumObjects        Enumerates the objects in a folder.
        BindToObject       Retrieves the IShellFolder interface for the specified subfolder.
        BindToStorage      Returns the storage instance of a subfolder.
        CompareIDs         Compares two item identifier lists and returns the result.
        CreateViewObject   Creates a view object of the folder itself.
        GetAttributesOf    Retrieves the attributes of the specified file object or subfolder.
        GetUIObjectOf      Creates an OLE interface that can be used to carry out operations on a file object or subfolder.
        GetDisplayNameOf   Retreives the display name of a file object or subfolder.
        SetNameOf          Sets the display name of the specified file object or subfolder and changes its identifier
                           accordingly. *)

       ppIShellFolder = ^pIShellFolder;
       pIShellFolder = ^IShellFolder;

       IShellFolder = Class (IUnknown)
                      Public
{&StdCall+}
                        Function ParseDisplayName (HWndOwner : HWnd; pbcReserved : Pointer; lpszDisplayName : pOleStr;
                                                   var pchEaten : ULONG; var ppIdl : pItemIDList;
                                                   var dwAttributes : ULONG) : hResult;
                           virtual; abstract;
                        Function EnumObjects (HWndOwner : HWnd; grfFlags : DWord; var EnumIDList : IEnumIDList) : hResult;
                           virtual; abstract;
                        Function BindToObject (pIdl : pItemIDList; pbcReserved : Pointer; const riid : TIID; var ppvOut) : hResult;
                           virtual; abstract;
                        Function BindToStorage (pIdl : pItemIDList; pbcReserved : Pointer; const riid : TIID; var ppvObj) : hResult;
                           virtual; abstract;
                        Function CompareIDs (lParam : lParam; pIdl1, pIdl2 : pItemIDList) : hResult;
                           virtual; abstract;
                        Function CreateViewObject (HWndOwner : HWnd; const riid : TIID; var ppvOut) : hResult;
                           virtual; abstract;
                        Function GetAttributesOf (cidl : UINT; var apidl : pItemIDList; var rgfInOut : UINT) : hResult;
                           virtual; abstract;
                        Function GetUIObjectOf (HWndOwner : HWnd; cidl : UINT; var apidl : pItemIDList; const riid : TIID;
                                                vprgfInOut : Pointer; var ppvOut) : hResult;
                           virtual; abstract;
                        Function GetDisplayNameOf (pIdl : pItemIDList; uFlags : DWord; var lpName : tStrRet) : hResult;
                           virtual; abstract;
                        Function SetNameOf (HWndOwner : HWnd; pIdl : pItemIDList; lpszName : pOleStr; uFlags : DWord;
                                            var ppidlOut : pItemIDList) : hResult;
                           virtual; abstract;
{&StdCall-}
                      end;


     (* IEnumExtraSearch interface
        ==========================

        IEnumExtraSearch Methods
        ------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Next    Retrieves the next celt items in the enumeration sequence. If there are fewer than the requested number of elements
                left in the sequence, it retrieves the remaining elements. The number of elements actually retrieved is returned through
                pceltFetched (unless the caller passed in NULL for that parameter).
        Skip    Skips over the next specified number of elements in the enumeration sequence.
        Reset   Resets the enumeration sequence to the beginning.
        Clone   Creates another enumerator that contains the same enumeration state as the current one.
                Using this function, a client can record a particular point in the enumeration sequence, and then return to that
                point at a later time. The new enumerator supports the same interface as the original one. *)

     ppIEnumExtraSearch = ^pIEnumExtraSearch;
     pIEnumExtraSearch = ^IEnumExtraSearch;

     IEnumExtraSearch = Class (IUnknown)
                        Public
{&StdCall+}
                          Function Next (celt : ULONG; var rgelt : pExtraSearch; var pceltFetched : ULONG) : hResult;
                             virtual; abstract;
                          Function Skip (celt : ULONG) : hResult;
                             virtual; abstract;
                          Function Reset : hResult;
                             virtual; abstract;
                          Function Clone (var ppEnum : IEnumExtraSearch) : hResult;
                             virtual; abstract;
{&StdCall-}
                        end;


     (* IShellFolder2 interface
        =======================

        IShellFolder2 Methods
        ---------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IShellFolder.ParseDisplayName
        IShellFolder.EnumObjects
        IShellFolder.BindToObject
        IShellFolder.BindToStorage
        IShellFolder.CompareIDs
        IShellFolder.CreateViewObject
        IShellFolder.GetAttributesOf
        IShellFolder.GetUIObjectOf
        IShellFolder.GetDisplayNameOf
        IShellFolder.SetNameOf
        GetDefaultSearchGUID
        EnumSearches
        GetDefaultColumn
        GetDefaultColumnState
        GetDetailsEx
        GetDetailsOf
        MapNameToSCID *)

     ppIShellFolder2 = ^pIShellFolder2;
     pIShellFolder2 = ^IShellFolder2;

     IShellFolder2 = Class (IShellFolder)
                     Public
{&StdCall+}
                       Function GetDefaultSearchGUID (var pguid : TGUID) : hResult;
                          virtual; abstract;
                       Function EnumSearches (var ppEnum : IEnumExtraSearch) : hResult;
                          virtual; abstract;
                       Function GetDefaultColumn (dwRes : DWord; var pSort, pDisplay : ULONG) : hResult;
                          virtual; abstract;
                       Function GetDefaultColumnState (iColumn : UINT; var pcsFlags : DWord) : hResult;
                          virtual; abstract;
                       Function GetDetailsEx (pIdl : pItemIDList; const pscid : SHCOLUMNID; pv : pOleVariant) : hResult;
                          virtual; abstract;
                       Function GetDetailsOf (pIdl : pItemIDList; iColumn : UINT; var psd : tShellDetails) : hResult;
                          virtual; abstract;
                       Function MapNameToSCID (pwszName : LPCWSTR; var pscid : tShColumnID) : hResult;
                          virtual; abstract;
{&StdCall-}
                     end;


     (* IInputObjectSite interface
        ==========================

        An object implements this interface so the site can communicate activation and accelerator events to it.

        IInputObjectSite Methods
        ------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        OnFocusChangeIS   Object (pUnkObj) is getting or losing the focus. *)

     ppIInputObjectSite = ^pIInputObjectSite;
     pIInputObjectSite = ^IInputObjectSite;

     IInputObjectSite = Class (IUnknown)
                        Public
{&StdCall+}
                          Function OnFocusChangeIS (pUnkObj : IUnknown; fSetFocus : BOOL) : hResult;
                             virtual; abstract;
{&StdCall-}
                        end;


     (* IInputObject interface
        ======================

        An object implements this interface so the site can communicate activation and accelerator events to it.

        IInputObject Methods
        --------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        UIActivateIO             Activates or deactivates the object.
        HasFocusIO               Determines if the object has the focus.
        TranslateAcceleratorIO   Allow the object to process a message. *)

     ppIInputObject = ^pIInputObject;
     pIInputObject = ^IInputObject;

     IInputObject = Class (IUnknown)
                    Public
{&StdCall+}
                      Function UIActivateIO (fActivate : BOOL; var lpMsg : tMsg) : hResult;
                         virtual; abstract;
                      Function HasFocusIO : hResult;
                         virtual; abstract;
                      Function TranslateAcceleratorIO (var lpMsg : tMsg) : hResult;
                         virtual; abstract;
{&StdCall-}
                    end;


     (* IDockingWindowSite interfaces
        =============================

        A site implements this interface so the object can negotiate for and inquire about real estate on the site.

        IDockingWindowSite Methods
        --------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleWindow.GetWindow
        IOleWindow.ContextSensitiveHelp
        GetBorderDW            Site returns the bounding rectangle of the given source object.
        RequestBorderSpaceDW   Object requests that the site makes room for it.
        SetBorderSpaceDW       Object requests that the site set the border spacing to the specified size. *)

     ppIDockingWindowSite = ^pIDockingWindowSite;
     pIDockingWindowSite = ^IDockingWindowSite;

     IDockingWindowSite = Class (IOleWindow)
                          Public
{&StdCall+}
                            Function GetBorderDW (pUnkObj : IUnknown; var prcBorder : tRect) : hResult;
                               virtual; abstract;
                            Function RequestBorderSpaceDW (pUnkObj : IUnknown; var pbw : tBorderWidths) : hResult;
                               virtual; abstract;
                            Function SetBorderSpaceDW (pUnkObj : IUnknown; var pbw : tBorderWidths) : hResult;
                               virtual; abstract;
{&StdCall-}
                          end;


     (* IDockingWindowFrame interface
        =============================

        IDockingWindowFrame Methods
        ---------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleWindow.GetWindow
        IOleWindow.ContextSensitiveHelp
        AddToolbar
        RemoveToolbar
        FindToolbar *)

     ppIDockingWindowFrame = ^pIDockingWindowFrame;
     pIDockingWindowFrame = ^IDockingWindowFrame;

     IDockingWindowFrame = Class (IOleWindow)
                           Public
{&StdCall+}
                             Function AddToolbar (pUnkSrc : IUnknown; pwszItem : pWideChar; dwAddFlags : DWord) : hResult;
                                virtual; abstract;
                             Function RemoveToolbar (pUnkSrc : IUnknown; dwRemoveFlags : DWord) : hResult;
                                virtual; abstract;
                             Function FindToolbar (pwszItem : pWideChar; const riid : TIID; var ppvObj : Pointer) : hResult;
                                virtual; abstract;
{&StdCall-}
                           end;


     (* IDockingWindow interface
        ========================

        An object (docking window) implements this interface so the site can communicate with it.
        An example of a docking window is a toolbar.

        IDockingWindow Methods
        ----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleWindow.GetWindow
        IOleWindow.ContextSensitiveHelp
        ShowDW           Shows or hides the docking window.
        CloseDW          Closes the docking window.
        ResizeBorderDW   Resizes the docking window's border.
        SetSite          IDockingWindow usually paired with IObjectWithSite.
                         Provides the IUnknown pointer of the site to the docking window. *)

     ppIDockingWindow = ^pIDockingWindow;
     pIDockingWindow = ^IDockingWindow;

     IDockingWindow = Class (IOleWindow)
                      Public
{&StdCall+}
                        Function ShowDW (fShow : BOOL) : hResult;
                           virtual; abstract;
                        Function CloseDW (dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function ResizeBorderDW (var prcBorder : tRect; pUnkToolbarSite : IUnknown; fReserved : BOOL) : hResult;
                           virtual; abstract;
{&StdCall-}
                      end;


     (* IDeskBand interface
        ===================

        IDeskBand Methods
        -----------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IOleWindow.GetWindow
        IOleWindow.ContextSensitiveHelp
        IDockingWindow.ShowDW
        IDockingWindow.CloseDW
        IDockingWindow.ResizeBorderDW
        IDockingWindow.SetSite
        GetBandInfo   Returns info on the given band. *)

     _POINTL = Packed record
                 x : LongInt;
                 y : LongInt;
               end;
     pPointL = ^tPointL;
     tPointL = _POINTL;

     DESKBANDINFO = Packed record
                      dwMask : DWord;
                      ptMinSize : tPointL;
                      ptMaxSize : tPointL;
                      ptIntegral : tPointL;
                      ptActual : tPointL;
                      wszTitle : Array [0..255] of WideChar;
                      dwModeFlags : DWord;
                      crBkgnd : COLORREF;
                    end;
     pDeskBandInfo = ^tDeskBandInfo;
     tDeskBandInfo = DESKBANDINFO;

     ppIDeskBand = ^pIDeskBand;
     pIDeskBand = ^IDeskBand;

     IDeskBand = Class (IDockingWindow)
                 Public
{&StdCall+}
                   Function GetBandInfo (dwBandID, dwViewMode : DWord; var pdbi : tDeskBandInfo) : hResult;
                      virtual; abstract;
{&StdCall-}
                 end;


     (* IActiveDesktop interface
        ========================

        Interface for manipulating the Active Desktop.

        IActiveDesktop Methods
        ----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        ApplyChanges
        GetWallpaper
        SetWallpaper
        GetWallpaperOptions
        SetWallpaperOptions
        GetPattern
        SetPattern
        GetDesktopItemOptions
        SetDesktopItemOptions
        AddDesktopItem
        AddDesktopItemWithUI
        ModifyDesktopItem
        RemoveDesktopItem
        GetDesktopItemCount
        GetDesktopItem
        GetDesktopItemByID
        GenerateDesktopItemHtml
        AddUrl
        GetDesktopItemBySource *)

     _tagWALLPAPEROPT = Packed record
                          dwSize : DWord;
                          dwStyle : DWord;
                        end;
     pWallPaperOpt = ^tWallPaperOpt;
     tWallPaperOpt = _tagWALLPAPEROPT;

     _tagCOMPONENTSOPT = Packed record
                           dwSize : DWord;
                           fEnableComponents : BOOL;
                           fActiveDesktop : BOOL;
                         end;
     pComponentsOpt = ^tComponentsOpt;
     tComponentsOpt = _tagCOMPONENTSOPT;

     _tagCOMPPOS = Packed record
                     dwSize : DWord;
                     iLeft : Integer;
                     iTop : Integer;
                     dwWidth : DWord;
                     dwHeight : DWord;
                     izIndex : Integer;
                     fCanResize : BOOL;
                     fCanResizeX : BOOL;
                     fCanResizeY : BOOL;
                     iPreferredLeftPercent : Integer;
                     iPreferredTopPercent : Integer;
                   end;
     pCompPos = ^tCompPos;
     tCompPos = _tagCOMPPOS;

     _tagCOMPONENT = Packed record
                       dwSize : DWord;
                       dwID : DWord;
                       iComponentType : Integer;
                       fChecked : BOOL;
                       fDirty : BOOL;
                       fNoScroll : BOOL;
                       cpPos : tCompPos;
                       wszFriendlyName : Array [0..MAX_PATH - 1] of WideChar;
                       wszSource : Array [0..INTERNET_MAX_URL_LENGTH - 1] of WideChar;
                       wszSubscribedURL : Array [0..INTERNET_MAX_URL_LENGTH - 1] of WideChar;
                     end;
     pShComponent = ^tShComponent;
     tShComponent = _tagCOMPONENT;

     tagDTI_ADTIWUI =  (DTI_ADDUI_DEFAULT, DTI_ADDUI_DISPSUBWIZARD);

     ppIActiveDesktop = ^pIActiveDesktop;
     pIActiveDesktop = ^IActiveDesktop;

     IActiveDesktop = Class (IUnknown)
                      Public
{&StdCall+}
                        Function ApplyChanges (dwFlags : DWord) : hResult;
                           virtual; abstract;
                        Function GetWallpaper (pwszWallpaper : pWideChar; cchWallpaper : UINT; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function SetWallpaper (pwszWallpaper : pWideChar; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function GetWallpaperOptions (var pwpo : tWallPaperOpt; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function SetWallpaperOptions (var pwpo : tWallPaperOpt; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function GetPattern (pwszPattern : pWideChar; cchPattern : UINT; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function SetPattern (pwszPattern : pWideChar; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function GetDesktopItemOptions (var pco : tComponentsOpt; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function SetDesktopItemOptions (var pco : tComponentsOpt; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function AddDesktopItem (var pComp : tShComponent; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function AddDesktopItemWithUI (Hwnd : HWnd; var pComp : tShComponent; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function ModifyDesktopItem (var pComp : tShComponent; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function RemoveDesktopItem (var pComp : tShComponent; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function GetDesktopItemCount (var lpiCount : Integer; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function GetDesktopItem (nComponent : Integer; var pComp : tShComponent; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function GetDesktopItemByID (dwID : DWord; var pComp : tShComponent; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function GenerateDesktopItemHtml (pwszFileName : pWideChar; var pComp : tShComponent; dwReserved : DWord) : hResult;
                           virtual; abstract;
                        Function AddUrl (Hwnd : HWnd; pszSource : pWideChar; var pComp : tShComponent; dwFlags : DWord) : hResult;
                           virtual; abstract;
                        Function GetDesktopItemBySource (pwszSource : pWideChar; var pComp : tShComponent; dwReserved : DWord) : hResult;
                           virtual; abstract;
{&StdCall-}
                      end;


     (* IShellChangeNotify interface
        ============================

        IShellChangeNotify Methods
        --------------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        OnChange *)

     ppIShellChangeNotify = ^pIShellChangeNotify;
     pIShellChangeNotify = ^IShellChangeNotify;

     IShellChangeNotify = Class (IUnknown)
                          Public
{&StdCall+}
                            Function OnChange (lEvent : LongInt; var pIdl1, pIdl2 : tItemIDList) : hResult;
                               virtual; abstract;
{&StdCall-}
                          end;


     (* IQueryInfo interface
        ====================

        IQueryInfo Methods
        ------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        GetInfoTip
        GetInfoFlags *)

     ppIQueryInfo = ^pIQueryInfo;
     pIQueryInfo = ^IQueryInfo;

     IQueryInfo = Class (IUnknown)
                  Public
{&StdCall+}
                    Function GetInfoTip (dwFlags : DWord; var ppwszTip : pWideChar) : hResult;
                       virtual; abstract;
                    Function GetInfoFlags (var pdwFlags : DWord) : hResult;
                       virtual; abstract;
{&StdCall-}
                  end;


     (* IAutoComplete interface
        =======================

        IAutoComplete Methods
        ---------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        Init
        Enable *)

     ppIAutoComplete = ^pIAutoComplete;
     pIAutoComplete = ^IAutoComplete;

     IAutoComplete = Class (IUnknown)
                     Public
{&StdCall+}
                       Function Init (hWndEdit : HWnd; pUnkACL : IUnknown; pwszRegKeyPath :
                                      LPCWSTR; pwszQuickComplete : LPCWSTR) : hResult;
                          virtual; abstract;
                       Function Enable (fEnable : BOOL) : hResult;
                          virtual; abstract;
{&StdCall-}
                     end;


     (* IAutoComplete2 interface
        ========================

        IAutoComplete2 Methods
        ----------------------

        IUnknown.QueryInterface
        IUnknown.AddRef
        IUnknown.Release
        IAutoComplete.Init
        IAutoComplete.Enable
        SetOptions
        GetOptions *)

     ppIAutoComplete2 = ^pIAutoComplete2;
     pIAutoComplete2 = ^IAutoComplete2;

     IAutoComplete2 = Class (IAutoComplete)
                      Public
{&StdCall+}
                        Function SetOptions (dwFlag : DWord) : hResult;
                           virtual; abstract;
                        Function GetOptions (var dwFlag : DWord) : hResult;
                           virtual; abstract;
{&StdCall-}
                      end;


Const (* Standard GUIDs *)

      GUID_NULL : tGUID                   = (Data1 : $00000000; Data2 : $0000; Data3 : $0000; Data4 : ($00,$00,$00,$00,$00,$00,$00,$00));
      IID_IUnknown : tGUID                = (Data1 : $00000000; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IClassFactory : tGUID           = (Data1 : $00000001; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IMarshal : tGUID                = (Data1 : $00000003; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IMalloc : tGUID                 = (Data1 : $00000002; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IStdMarshalInfo : tGUID         = (Data1 : $00000018; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IExternalConnection : tGUID     = (Data1 : $00000019; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumUnknown : tGUID            = (Data1 : $00000100; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IBindCtx : tGUID                = (Data1 : $0000000E; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumMoniker : tGUID            = (Data1 : $00000102; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IRunnableObject : tGUID         = (Data1 : $00000126; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IRunningObjectTable : tGUID     = (Data1 : $00000010; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IPersist : tGUID                = (Data1 : $0000010C; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IPersistStream : tGUID          = (Data1 : $00000109; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IMoniker : tGUID                = (Data1 : $0000000F; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumString : tGUID             = (Data1 : $00000101; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IStream : tGUID                 = (Data1 : $0000000C; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumStatStg : tGUID            = (Data1 : $0000000D; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IStorage : tGUID                = (Data1 : $0000000B; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IPersistFile : tGUID            = (Data1 : $0000010B; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IPersistStorage : tGUID         = (Data1 : $0000010A; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_ILockBytes : tGUID              = (Data1 : $0000000A; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumFormatEtc : tGUID          = (Data1 : $00000103; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumStatData : tGUID           = (Data1 : $00000105; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IRootStorage : tGUID            = (Data1 : $00000012; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IAdviseSink : tGUID             = (Data1 : $0000010F; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IAdviseSink2 : tGUID            = (Data1 : $00000125; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IDataObject : tGUID             = (Data1 : $0000010E; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IDataAdviseHolder : tGUID       = (Data1 : $00000110; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IMessageFilter : tGUID          = (Data1 : $00000016; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IRpcChannelBuffer : tGUID       = (Data1 : $D5F56B60; Data2 : $593B; Data3 : $101A; Data4 : ($B5,$69,$08,$00,$2B,$2D,$BF,$7A));
      IID_IRpcProxyBuffer : tGUID         = (Data1 : $D5F56A34; Data2 : $593B; Data3 : $101A; Data4 : ($B5,$69,$08,$00,$2B,$2D,$BF,$7A));
      IID_IRpcStubBuffer : tGUID          = (Data1 : $D5F56AFC; Data2 : $593B; Data3 : $101A; Data4 : ($B5,$69,$08,$00,$2B,$2D,$BF,$7A));
      IID_IPSFactoryBuffer : tGUID        = (Data1 : $D5F569D0; Data2 : $593B; Data3 : $101A; Data4 : ($B5,$69,$08,$00,$2B,$2D,$BF,$7A));
      IID_ICreateTypeInfo : tGUID         = (Data1 : $00020405; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_ICreateTypeLib : tGUID          = (Data1 : $00020406; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IDispatch : tGUID               = (Data1 : $00020400; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumVariant : tGUID            = (Data1 : $00020404; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_ITypeComp : tGUID               = (Data1 : $00020403; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_ITypeInfo : tGUID               = (Data1 : $00020401; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_ITypeLib : tGUID                = (Data1 : $00020402; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IErrorInfo : tGUID              = (Data1 : $1CF2B120; Data2 : $547D; Data3 : $101B; Data4 : ($8E,$65,$08,$00,$2B,$2B,$D1,$19));
      IID_ICreateErrorInfo : tGUID        = (Data1 : $22F03340; Data2 : $547D; Data3 : $101B; Data4 : ($8E,$65,$08,$00,$2B,$2B,$D1,$19));
      IID_ISupportErrorInfo : tGUID       = (Data1 : $DF0B3D60; Data2 : $548F; Data3 : $101B; Data4 : ($8E,$65,$08,$00,$2B,$2B,$D1,$19));
      IID_IOleAdviseHolder : tGUID        = (Data1 : $00000111; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleCache : tGUID               = (Data1 : $0000011E; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleCache2 : tGUID              = (Data1 : $00000128; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleCacheControl : tGUID        = (Data1 : $00000129; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IParseDisplayName : tGUID       = (Data1 : $0000011A; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleContainer : tGUID           = (Data1 : $0000011B; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleClientSite : tGUID          = (Data1 : $00000118; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleObject : tGUID              = (Data1 : $00000112; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleWindow : tGUID              = (Data1 : $00000114; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleLink : tGUID                = (Data1 : $0000011D; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleItemContainer : tGUID       = (Data1 : $0000011C; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleInPlaceUIWindow : tGUID     = (Data1 : $00000115; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleInPlaceActiveObject : tGUID = (Data1 : $00000117; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleInPlaceFrame : tGUID        = (Data1 : $00000116; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleInPlaceObject : tGUID       = (Data1 : $00000113; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleInPlaceSite : tGUID         = (Data1 : $00000119; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IViewObject : tGUID             = (Data1 : $0000010D; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IViewObject2 : tGUID            = (Data1 : $00000127; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IDropSource : tGUID             = (Data1 : $00000121; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IDropTarget : tGUID             = (Data1 : $00000122; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumOleVerb : tGUID            = (Data1 : $00000104; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));

      (* Additional GUIDs *)

      IID_IRpcChannel : tGUID             = (Data1 : $00000004; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IRpcStub : tGUID                = (Data1 : $00000005; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IStubManager : tGUID            = (Data1 : $00000006; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IRpcProxy : tGUID               = (Data1 : $00000007; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IProxyManager : tGUID           = (Data1 : $00000008; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IPSFactory : tGUID              = (Data1 : $00000009; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IInternalMoniker : tGUID        = (Data1 : $00000011; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumGeneric : tGUID            = (Data1 : $00000106; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumHolder : tGUID             = (Data1 : $00000107; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumCallback : tGUID           = (Data1 : $00000108; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleManager : tGUID             = (Data1 : $0000011F; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOlePresObj : tGUID             = (Data1 : $00000120; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IDebug : tGUID                  = (Data1 : $00000123; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IDebugStream : tGUID            = (Data1 : $00000124; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IOleDocument : tGUID            = (Data1 : $B722BCC5; Data2 : $4E68; Data3 : $101B; Data4 : ($A2,$BC,$00,$AA,$00,$40,$47,$70));
      IID_IOleDocumentSite : tGUID        = (Data1 : $B722BCC7; Data2 : $4E68; Data3 : $101B; Data4 : ($A2,$BC,$00,$AA,$00,$40,$47,$70));

      (* Class ID's *)

      CLSID_ShellDesktop : tGUID     = (Data1 : $00021400; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      CLSID_ShellLink : tGUID        = (Data1 : $00021401; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      CLSID_StdMarshal : tGUID       = (Data1 : $00000017; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      CLSID_ActiveDesktop            = '{75048700-EF1F-11D0-9888-006097DEACF9}';
      CLSID_AutoComplete             = '{00BB2763-6A77-11D0-A535-00C04FD7D062}';

      (* Format ID's *)

      FMTID_Intshcut : tGUID         = (Data1 : $000214A0; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      FMTID_InternetSite : tGUID     = (Data1 : $000214A1; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));

      (* Command group ID's *)

      CGID_Explorer : tGUID          = (Data1 : $000214D0; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      CGID_ShellDocView : tGUID      = (Data1 : $000214D1; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));

      (* Interface ID's *)

      IID_INewShortcutHookA : tGUID  = (Data1 : $000214E1; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellBrowser : tGUID      = (Data1 : $000214E2; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellView : tGUID         = (Data1 : $000214E3; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IContextMenu : tGUID       = (Data1 : $000214E4; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellIcon : tGUID         = (Data1 : $000214E5; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellFolder : tGUID       = (Data1 : $000214E6; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellExtInit : tGUID      = (Data1 : $000214E8; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellPropSheetExt : tGUID = (Data1 : $000214E9; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IPersistFolder : tGUID     = (Data1 : $000214EA; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IExtractIconA : tGUID      = (Data1 : $000214EB; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IExtractIcon : tGUID       = (Data1 : $000214EB; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellLinkA : tGUID        = (Data1 : $000214EE; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellLink : tGUID         = (Data1 : $000214EE; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellCopyHookA : tGUID    = (Data1 : $000214EF; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellCopyHook : tGUID     = (Data1 : $000214EF; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IFileViewerA : tGUID       = (Data1 : $000214F0; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IFileViewer : tGUID        = (Data1 : $000214F0; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_ICommDlgBrowser : tGUID    = (Data1 : $000214F1; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumIDList : tGUID        = (Data1 : $000214F2; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IFileViewerSite : tGUID    = (Data1 : $000214F3; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IContextMenu2 : tGUID      = (Data1 : $000214F4; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellExecuteHook : tGUID  = (Data1 : $000214F5; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IPropSheetPage : tGUID     = (Data1 : $000214F6; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_INewShortcutHookW : tGUID  = (Data1 : $000214F7; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IFileViewerW : tGUID       = (Data1 : $000214F8; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellLinkW : tGUID        = (Data1 : $000214F9; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IExtractIconW : tGUID      = (Data1 : $000214FA; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellExecuteHookW : tGUID = (Data1 : $000214FB; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellCopyHookW : tGUID    = (Data1 : $000214FC; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellView2 : tGUID        = (Data1 : $88E39E80; Data2 : $3578; Data3 : $11CF; Data4 : ($AE,$69,$08,$00,$2B,$2E,$12,$62));
      IID_IShellFolder2 : tGUID      = (Data1 : $93F2F68C; Data2 : $1D1B; Data3 : $11D3; Data4 : ($A3,$0E,$00,$C0,$4F,$79,$AB,$D1));
      IID_IShellDetails : tGUID      = (Data1 : $000214EC; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IEnumExtraSearch : tGUID   = (Data1 : $0E700BE1; Data2 : $9DB6; Data3 : $11D1; Data4 : ($A1,$CE,$00,$C0,$4F,$D7,$5D,$13));


{&StdCall+}

(* hResult manipulation routines *)

Function Succeeded (Res : hResult) : Boolean;
Function Failed (Res : hResult) : Boolean;
Function ResultCode (Res : hResult) : Integer;
Function ResultFacility (Res : hResult) : Integer;
Function ResultSeverity (Res : hResult) : Integer;
Function MakeResult (Severity, Facility, Code : Integer) : hResult;

(* GUID Functions *)

Function IsEqualGUID (const guid1, guiData2 : tGUID) : Boolean;
Function IsEqualIID (const iid1, iiData2 : TIID) : Boolean;
Function IsEqualCLSID (const clsid1, clsiData2 : TCLSID) : Boolean;

(* Standard object API Functions *)

Function CoBuildVersion : LongInt;

(* Init/Uninit *)

Function CoInitialize (pvReserved : Pointer) : hResult;
Procedure CoUninitialize;
Function CoGetMalloc (dwMemContext : LongInt; var malloc : IMalloc) : hResult;
Function CoGetCurrentProcess : LongInt;
Function CoRegisterMallocSpy (MallocSpy : IMallocSpy) : hResult;
Function CoRevokeMallocSpy : hResult;
Function CoCreateStandardMalloc (MemCtx : LongInt; var Malloc : IMalloc) : hResult;

(* Register, revoke, and get class objects *)

Function CoGetClassObject (const clsid : TCLSID; dwClsContext : LongInt; pvReserved : Pointer; const iid : TIID; var pv) : hResult;
Function CoRegisterClassObject (const clsid : TCLSID; unk : IUnknown; dwClsContext : LongInt; flags : LongInt; var dwRegister : LongInt) : hResult;
Function CoRevokeClassObject (dwRegister : LongInt) : hResult;

(* Marshaling interface pointers *)

Function CoGetMarshalSizeMax (var ulSize : LongInt; const iid : TIID; unk : IUnknown; dwDestContext : LongInt; pvDestContext : Pointer; mshlflags : LongInt) : hResult;
Function CoMarshalInterface (stm : IStream; const iid : TIID; unk : IUnknown; dwDestContext : LongInt; pvDestContext : Pointer; mshlflags : LongInt) : hResult;
Function CoUnmarshalInterface (stm : IStream; const iid : TIID; var pv) : hResult;
Function CoMarshalhResult (stm : IStream; Result : hResult) : hResult;
Function CoUnmarshalhResult (stm : IStream; var Result : hResult) : hResult;
Function CoReleaseMarshalData (stm : IStream) : hResult;
Function CoDisconnectObject (unk : IUnknown; dwReserved : LongInt) : hResult;
Function CoLockObjectExternal (unk : IUnknown; fLock : BOOL; fLastUnlockReleases : BOOL) : hResult;
Function CoGetStandardMarshal (const iid : TIID; unk : IUnknown; dwDestContext : LongInt; pvDestContext : Pointer; mshlFlags : LongInt; var Marshal : IMarshal) : hResult;

Function CoIsHandlerConnected (unk : IUnknown) : BOOL;
Function CoHasStrongExternalConnections (unk : IUnknown) : BOOL;

(* Apartment model inter-thread interface passing helpers *)

Function CoMarshalInterThreadInterfaceInStream (const iid : TIID; unk : IUnknown; var stm : IStream) : hResult;
Function CoGetInterfaceAndReleaseStream (stm : IStream; const iid : TIID; var pv) : hResult;
Function CoCreateFreeThreadedMarshaler (unkOuter : IUnknown; var unkMarshal : IUnknown) : hResult;

(* DLL loading helpers; keeps track of ref counts and unloads all on exit *)

Function CoLoadLibrary (pszLibName : pOleStr; bAutoFree : BOOL) : THandle;
Procedure CoFreeLibrary (hInst : THandle);
Procedure CoFreeAllLibraries;
Procedure CoFreeUnusedLibraries;

(* Helper for creating instances *)

Function CoCreateInstance (const clsid : TCLSID; unkOuter : IUnknown; dwClsContext : LongInt; const iid : TIID; var pv) : hResult;

(* Other helpers *)

Function StringFromCLSID (const clsid : TCLSID; var psz : pOleStr) : hResult;
Function CLSIDFromString (psz : pOleStr; var clsid : TCLSID) : hResult;
Function StringFromIID (const iid : TIID; var psz : pOleStr) : hResult;
Function IIDFromString (psz : pOleStr; var iid : TIID) : hResult;
Function CoIsOle1Class (const clsid : TCLSID) : BOOL;
Function ProgIDFromCLSID (const clsid : TCLSID; var pszProgID : pOleStr) : hResult;
Function CLSIDFromProgID (pszProgID : pOleStr; var clsid : TCLSID) : hResult;
Function StringFromGUID2 (const guid : tGUID; psz : pOleStr; cbMax : Integer) : Integer;

Function CoCreateGuid(var guid : tGUID) : hResult;

Function CoFileTimeToDosDateTime (var FileTime : tFileTime; var DosDate : Word; var DosTime : Word) : BOOL;
Function CoDosDateTimeToFileTime (nDosDate : Word; nDosTime : Word; var filetime : tFileTime) : BOOL;
Function CoFileTimeNow (var FileTime : tFileTime) : hResult;
Function CoRegisterMessageFilter (MessageFilter : IMessageFilter; var pMessageFilter : IMessageFilter) : hResult;

(* TreatAs APIs *)

Function CoGetTreatAsClass (const clsidOld : TCLSID; var clsidNew : TCLSID) : hResult;
Function CoTreatAsClass (const clsidOld : TCLSID; const clsidNew : TCLSID) : hResult;

(* Default memory allocation *)

Function CoTaskMemAlloc (cb : LongInt) : Pointer;
Function CoTaskMemRealloc (pv : Pointer; cb : LongInt) : Pointer;
Procedure CoTaskMemFree (pv : Pointer);

(* DV APIs *)

Function CreateDataAdviseHolder (var DAHolder : IDataAdviseHolder) : hResult;
Function CreateDataCache (unkOuter : IUnknown; const clsid : TCLSID; const iid : TIID; var pv) : hResult;

(* Storage API prototypes *)

Function StgCreateDocfile (pwcsName : pOleStr; grfMode : LongInt; Reserved : LongInt; var stgOpen : IStorage) : hResult;
Function StgCreateDocfileOnILockBytes (lkbyt : ILockBytes; grfMode : LongInt; Reserved : LongInt; var stgOpen : IStorage) : hResult;
Function StgOpenStorage (pwcsName : pOleStr; stgPriority : IStorage; grfMode : LongInt; snbExclude : TSNB; Reserved : LongInt; var stgOpen : IStorage) : hResult;
Function StgOpenStorageOnILockBytes (lkbyt : ILockBytes; stgPriority : IStorage; grfMode : LongInt; snbExclude : TSNB; Reserved : LongInt; var stgOpen : IStorage) : hResult;
Function StgIsStorageFile (pwcsName : pOleStr) : hResult;
Function StgIsStorageILockBytes (lkbyt : ILockBytes) : hResult;
Function StgSetTimes (pszName : pOleStr; const cTime : tFileTime; const aTime : tFileTime; const mTime : tFileTime) : hResult;

(* Moniker APIs *)

Function BindMoniker (mk : IMoniker; grfOpt : LongInt; const iidResult : TIID; var pvResult) : hResult;
Function MkParseDisplayName (bc : IBindCtx; szUserName : pOleStr; var chEaten : LongInt; var mk : IMoniker) : hResult;
Function MonikerRelativePathTo (mkSrc : IMoniker; mkDest : IMoniker; var mkRelPath : IMoniker; dwReserved : BOOL) : hResult;
Function MonikerCommonPrefixWith (mkThis : IMoniker; mkOther : IMoniker; var mkCommon : IMoniker) : hResult;
Function CreateBindCtx (Reserved : LongInt; var bc : IBindCtx) : hResult;
Function CreateGenericComposite (mkFirst : IMoniker; mkRest : IMoniker; var mkComposite : IMoniker) : hResult;
Function GetClassFile (szFilename : pOleStr; var clsid : TCLSID) : hResult;
Function CreateFileMoniker (pszPathName : pOleStr; var mk : IMoniker) : hResult;
Function CreateItemMoniker (pszDelim : pOleStr; pszItem : pOleStr; var mk : IMoniker) : hResult;
Function CreateAntiMoniker (var mk : IMoniker) : hResult;
Function CreatePointerMoniker (unk : IUnknown; var mk : IMoniker) : hResult;
Function GetRunningObjectTable (Reserved : LongInt; var rot : IRunningObjectTable) : hResult;

(* tBStr API *)

Function SysAllocString (psz : pOleStr) : tBStr;
Function SysReAllocString (var bstr : tBStr; psz : pOleStr) : Integer;
Function SysAllocStringLen (psz : pOleStr; len : Integer) : tBStr;
Function SysReAllocStringLen (var bstr : tBStr; psz : pOleStr; len : Integer) : Integer;
Procedure SysFreeString (bstr : tBStr);
Function SysStringLen (bstr : tBStr) : Integer;
Function SysStringByteLen (bstr : tBStr) : Integer;
Function SysAllocStringByteLen (psz : PChar; len : Integer) : tBStr;

(* Time API *)

Function DosDateTimeToVariantTime (wDosDate, wDosTime : Word; var vtime : tOleDate) : Integer;
Function VariantTimeToDosDateTime (vtime : tOleDate; var wDosDate, wDosTime : Word) : Integer;

(* SafeArray API *)

Function SafeArrayAllocDescriptor (cDims : Integer; var psaOut : pSafeArray) : hResult;
Function SafeArrayAllocData (psa : pSafeArray) : hResult;
Function SafeArrayCreate (vt : tVarType; cDims : Integer; const rgsabound) : pSafeArray;
Function SafeArrayDestroyDescriptor (psa : pSafeArray) : hResult;
Function SafeArrayDestroyData (psa : pSafeArray) : hResult;
Function SafeArrayDestroy (psa : pSafeArray) : hResult;
Function SafeArrayRedim (psa : pSafeArray; var saboundNew : tSafeArrayBound) : hResult;
Function SafeArrayGetDim (psa : pSafeArray) : Integer;
Function SafeArrayGetElemsize (psa : pSafeArray) : Integer;
Function SafeArrayGetUBound (psa : pSafeArray; nDim : Integer; var lUbound : LongInt) : hResult;
Function SafeArrayGetLBound (psa : pSafeArray; nDim : Integer; var lLbound : LongInt) : hResult;
Function SafeArrayLock (psa : pSafeArray) : hResult;
Function SafeArrayUnlock (psa : pSafeArray) : hResult;
Function SafeArrayAccessData (psa : pSafeArray; var pvData : Pointer) : hResult;
Function SafeArrayUnaccessData (psa : pSafeArray) : hResult;
Function SafeArrayGetElement (psa : pSafeArray; const rgIndices; var pv) : hResult;
Function SafeArrayPutElement (psa : pSafeArray; const rgIndices; const pv) : hResult;
Function SafeArrayCopy (psa : pSafeArray; var psaOut : pSafeArray) : hResult;
Function SafeArrayPtrOfIndex (psa : pSafeArray; var rgIndices; var pvData : Pointer) : hResult;

(* Variant API *)

Procedure VariantInit (var varg{ : Variant});
Function VariantClear (var varg{ : Variant}) : hResult;
Function VariantCopy (var vargDest{ : Variant}; const vargSrc{ : Variant}) : hResult;
Function VariantCopyInd (var varDest{ : Variant}; const vargSrc{ : Variant}) : hResult;
Function VariantChangeType (var vargDest{ : Variant}; const vargSrc{ : Variant}; wFlags : Word; vt : tVarType) : hResult;
Function VariantChangeTypeEx (var vargDest{ : Variant}; const vargSrc{ : Variant}; lcid : tLCID; wFlags : Word; vt : tVarType) : hResult;

(* VarType conversion API.

   Note : The routines that convert from a string are defined to take a pOleStr rather than a tBStr because no allocation is
   required, and this makes the routines a bit more generic.
   They may of course still be passed a tBStr as the strIn param.
   Any of the conversion functions that converts either from or to a string takes an additional lcid and dwFlags arguments.
   The lcid argument allows locale specific parsing to occur. The dwFlags allow additional function specific condition to occur.
   All function that accept the dwFlags argument can include either 0 or LOCALE_NOUSEROVERRIDE flag.
   In addition, the VarDateFromStr functions also accepts the VAR_TIMEVALUEONLY and VAR_DATEVALUEONLY flags. *)

Function VarUI1FromI2 (sIn : SmallInt; var bOut : Byte) : hResult;
Function VarUI1FromI4 (lIn : LongInt; var bOut : Byte) : hResult;
Function VarUI1FromR4 (fltIn : Single; var bOut : Byte) : hResult;
Function VarUI1FromR8 (dblIn : Double; var bOut : Byte) : hResult;
Function VarUI1FromCy (cyIn : tCurrency; var bOut : Byte) : hResult;
Function VarUI1FromDate (DateIn : tOleDate; var bOut : Byte) : hResult;
Function VarUI1FromStr (StrIn : tBStr; lcid : tLCID; dwFlags : LongInt; var bOut : Byte) : hResult;
Function VarUI1FromDisp (dispIn : IDispatch; lcid : tLCID; var bOut : Byte) : hResult;
Function VarUI1FromBool (boolIn : tOleBool; var bOut : Byte) : hResult;

Function VarI2FromUI1 (bIn : Byte; var sOut : SmallInt) : hResult;
Function VarI2FromI4 (lIn : LongInt; var sOut : SmallInt) : hResult;
Function VarI2FromR4 (fltIn : Single; var sOut : SmallInt) : hResult;
Function VarI2FromR8 (dblIn : Double; var sOut : SmallInt) : hResult;
Function VarI2FromCy (cyIn : tCurrency; var sOut : SmallInt) : hResult;
Function VarI2FromDate (dateIn : tOleDate; var sOut : SmallInt) : hResult;
Function VarI2FromStr (strIn : tBStr; lcid : tLCID; dwFlags : LongInt; var sOut : SmallInt) : hResult;
Function VarI2FromDisp (dispIn : IDispatch; lcid : tLCID; var sOut : SmallInt) : hResult;
Function VarI2FromBool (boolIn : tOleBool; var sOut : SmallInt) : hResult;

Function VarI4FromUI1 (bIn : Byte; var lOut : LongInt) : hResult;
Function VarI4FromI2 (sIn : SmallInt; var lOut : LongInt) : hResult;
Function VarI4FromR4 (fltIn : Single; var lOut : LongInt) : hResult;
Function VarI4FromR8 (dblIn : Double; var lOut : LongInt) : hResult;
Function VarI4FromCy (cyIn : tCurrency; var lOut : LongInt) : hResult;
Function VarI4FromDate (dateIn : tOleDate; var lOut : LongInt) : hResult;
Function VarI4FromStr (strIn : tBStr; lcid : tLCID; dwFlags : LongInt; var lOut : LongInt) : hResult;
Function VarI4FromDisp (dispIn : IDispatch; lcid : tLCID; var lOut : LongInt) : hResult;
Function VarI4FromBool (boolIn : tOleBool; var lOut : LongInt) : hResult;

Function VarR4FromUI1 (bIn : Byte; var fltOut : Single) : hResult;
Function VarR4FromI2 (sIn : SmallInt; var fltOut : Single) : hResult;
Function VarR4FromI4 (lIn : LongInt; var fltOut : Single) : hResult;
Function VarR4FromR8 (dblIn : Double; var fltOut : Single) : hResult;
Function VarR4FromCy (cyIn : tCurrency; var fltOut : Single) : hResult;
Function VarR4FromDate (dateIn : tOleDate; var fltOut : Single) : hResult;
Function VarR4FromStr (strIn : tBStr; lcid : tLCID; dwFlags : LongInt; var fltOut : Single) : hResult;
Function VarR4FromDisp (dispIn : IDispatch; lcid : tLCID; var fltOut : Single) : hResult;
Function VarR4FromBool (boolIn : tOleBool; var fltOut : Single) : hResult;

Function VarR8FromUI1 (bIn : Byte; var dblOut : Double) : hResult;
Function VarR8FromI2 (sIn : SmallInt; var dblOut : Double) : hResult;
Function VarR8FromI4 (lIn : LongInt; var dblOut : Double) : hResult;
Function VarR8FromR4 (fltIn : Single; var dblOut : Double) : hResult;
Function VarR8FromCy (cyIn : tCurrency; var dblOut : Double) : hResult;
Function VarR8FromDate (dateIn : tOleDate; var dblOut : Double) : hResult;
Function VarR8FromStr (strIn : tBStr; lcid : tLCID; dwFlags : LongInt; var dblOut : Double) : hResult;
Function VarR8FromDisp (dispIn : IDispatch; lcid : tLCID; var dblOut : Double) : hResult;
Function VarR8FromBool (boolIn : tOleBool; var dblOut : Double) : hResult;

Function VarDateFromUI1 (bIn : Byte; var dateOut : tOleDate) : hResult;
Function VarDateFromI2 (sIn : SmallInt; var dateOut : tOleDate) : hResult;
Function VarDateFromI4 (lIn : LongInt; var dateOut : tOleDate) : hResult;
Function VarDateFromR4 (fltIn : Single; var dateOut : tOleDate) : hResult;
Function VarDateFromR8 (dblIn : Double; var dateOut : tOleDate) : hResult;
Function VarDateFromCy (cyIn : tCurrency; var dateOut : tOleDate) : hResult;
Function VarDateFromStr (strIn : tBStr; lcid : tLCID; dwFlags : LongInt; var dateOut : tOleDate) : hResult;
Function VarDateFromDisp (dispIn : IDispatch; lcid : tLCID; var dateOut : tOleDate) : hResult;
Function VarDateFromBool (boolIn : tOleBool; var dateOut : tOleDate) : hResult;

Function VarCyFromUI1 (bIn : Byte; var cyOut : tCurrency) : hResult;
Function VarCyFromI2 (sIn : SmallInt; var cyOut : tCurrency) : hResult;
Function VarCyFromI4 (lIn : LongInt; var cyOut : tCurrency) : hResult;
Function VarCyFromR4 (fltIn : Single; var cyOut : tCurrency) : hResult;
Function VarCyFromR8 (dblIn : Double; var cyOut : tCurrency) : hResult;
Function VarCyFromDate (dateIn : tOleDate; var cyOut : tCurrency) : hResult;
Function VarCyFromStr (strIn : tBStr; lcid : tLCID; dwFlags : LongInt; var cyOut : tCurrency) : hResult;
Function VarCyFromDisp (dispIn : IDispatch; lcid : tLCID; var cyOut : tCurrency) : hResult;
Function VarCyFromBool (boolIn : tOleBool; var cyOut : tCurrency) : hResult;

Function VarBStrFromUI1 (bVal : Byte; lcid : tLCID; dwFlags : LongInt; var bstrOut : tBStr) : hResult;
Function VarBStrFromI2 (iVal : SmallInt; lcid : tLCID; dwFlags : LongInt; var bstrOut : tBStr) : hResult;
Function VarBStrFromI4 (lIn : LongInt; lcid : tLCID; dwFlags : LongInt; var bstrOut : tBStr) : hResult;
Function VarBStrFromR4 (fltIn : Single; lcid : tLCID; dwFlags : LongInt; var bstrOut : tBStr) : hResult;
Function VarBStrFromR8 (dblIn : Double; lcid : tLCID; dwFlags : LongInt; var bstrOut : tBStr) : hResult;
Function VarBStrFromCy (cyIn : tCurrency; lcid : tLCID; dwFlags : LongInt; var bstrOut : tBStr) : hResult;
Function VarBStrFromDate (dateIn : tOleDate; lcid : tLCID; dwFlags : LongInt; var bstrOut : tBStr) : hResult;
Function VarBStrFromDisp (dispIn : IDispatch; lcid : tLCID; dwFlags : LongInt; var bstrOut : tBStr) : hResult;
Function VarBStrFromBool (boolIn : tOleBool; lcid : tLCID; dwFlags : LongInt; var bstrOut : tBStr) : hResult;

Function VarBoolFromUI1 (bIn : Byte; var boolOut : tOleBool) : hResult;
Function VarBoolFromI2 (sIn : SmallInt; var boolOut : tOleBool) : hResult;
Function VarBoolFromI4 (lIn : LongInt; var boolOut : tOleBool) : hResult;
Function VarBoolFromR4 (fltIn : Single; var boolOut : tOleBool) : hResult;
Function VarBoolFromR8 (dblIn : Double; var boolOut : tOleBool) : hResult;
Function VarBoolFromDate (dateIn : tOleDate; var boolOut : tOleBool) : hResult;
Function VarBoolFromCy (cyIn : tCurrency; var boolOut : tOleBool) : hResult;
Function VarBoolFromStr (strIn : tBStr; lcid : tLCID; dwFlags : LongInt; var boolOut : tOleBool) : hResult;
Function VarBoolFromDisp (dispIn : IDispatch; lcid : tLCID; var boolOut : tOleBool) : hResult;

(* TypeInfo API *)

Function LHashValOfNameSys (syskind : tSysKind; lcid : tLCID; szName : pOleStr) : LongInt;
Function LHashValOfNameSysA (syskind : tSysKind; lcid : tLCID; szName : PChar) : LongInt;

Function LHashValOfName (lcid : tLCID; szName : pOleStr) : LongInt;
Function WHashValOfLHashVal (lhashval : LongInt) : Word;
Function IsHashValCompatible (lhashval1, lhashval2 : LongInt) : Boolean;

Function LoadTypeLib (szFile : pOleStr; var tlib : ITypeLib) : hResult;
Function LoadRegTypeLib (const guid : tGUID; wVerMajor, wVerMinor : Word; lcid : tLCID; var tlib : ITypeLib) : hResult;
Function QueryPathOfRegTypeLib (const guid : tGUID; wMaj, wMin : Word; lcid : tLCID; var bstrPathName : tBStr) : hResult;
Function RegisterTypeLib (tlib : ITypeLib; szFullPath, szHelpDir : pOleStr) : hResult;
Function CreateTypeLib (syskind : tSysKind; szFile : pOleStr; var ctlib : ICreateTypeLib) : hResult;

(* IDispatch implementation support *)

Function DispGetParam (var dispparams : tDispParams; position : Integer; vtTarg : tVarType; var varResult{ : Variant}; var puArgErr : Integer) : hResult;
Function DispGetIDsOfNames (tinfo : ITypeInfo; var rgszNames; cNames : Integer; var rgdispid) : hResult;
Function DispInvoke (This : Pointer; tinfo : ITypeInfo; dispidMember : tDispID; wFlags : Word; var params : tDispParams; var varResult{ : Variant}; var excepinfo : tExcepInfo; var puArgErr : Integer) : hResult;
Function CreateDispTypeInfo (var idata : tInterfaceData; lcid : tLCID; var tinfo : ITypeInfo) : hResult;
Function CreateStdDispatch (unkOuter : IUnknown; pvThis : Pointer; tinfo : ITypeInfo; var unkStdDisp : IUnknown) : hResult;

(* Active object registration API *)

Function RegisterActiveObject (unk : IUnknown; const clsid : TCLSID; dwFlags : LongInt; var dwRegister : LongInt) : hResult;
Function RevokeActiveObject (dwRegister : LongInt; pvReserved : Pointer) : hResult;
Function GetActiveObject (const clsid : TCLSID; pvReserved : Pointer; var unk : IUnknown) : hResult;

(* ErrorInfo API *)

Function SetErrorInfo (dwReserved : LongInt; errinfo : IErrorInfo) : hResult;
Function GetErrorInfo (dwReserved : LongInt; var errinfo : IErrorInfo) : hResult;
Function CreateErrorInfo (var errinfo : ICreateErrorInfo) : hResult;

(* Misc API *)

Function OaBuildVersion :  LongInt;

(* OLE API prototypes *)

Function OleBuildVersion :  hResult;

(* Helper functions *)

Function ReadClassStg (stg : IStorage; var clsid : TCLSID) : hResult;
Function WriteClassStg (stg : IStorage; const clsid : TIID) : hResult;
Function ReadClassStm (stm : IStream; var clsid : TCLSID) : hResult;
Function WriteClassStm (stm : IStream; const clsid : TIID) : hResult;
Function WriteFmtUserTypeStg (stg : IStorage; cf : tClipFormat; pszUserType : pOleStr) : hResult;
Function ReadFmtUserTypeStg (stg : IStorage; var cf : tClipFormat; var pszUserType : pOleStr) : hResult;

(* OLE initialization and termination *)

Function OleInitialize (pwReserved : Pointer) : hResult;
Procedure OleUninitialize ;

(* APIs to query whether (Embedded/Linked) object can be created from the data object *)

Function OleQueryLinkFromData (srcDataObject : IDataObject) : hResult;
Function OleQueryCreateFromData (srcDataObject : IDataObject) : hResult;

(* Object creation APIs *)

Function OleCreate (const clsid : TCLSID; const iid : TIID; renderopt : LongInt; FormatEtc : pFormatEtc; clientSite : IOleClientSite; stg : IStorage; var vObj) : hResult;
Function OleCreateFromData (srcDataObj : IDataObject; const iid : TIID; renderopt : LongInt; FormatEtc : pFormatEtc; clientSite : IOleClientSite; stg : IStorage; var vObj) : hResult;
Function OleCreateLinkFromData (srcDataObj : IDataObject; const iid : TIID; renderopt : LongInt; FormatEtc : pFormatEtc; clientSite : IOleClientSite; stg : IStorage; var vObj) : hResult;
Function OleCreateStaticFromData (srcDataObj : IDataObject; const iid : TIID; renderopt : LongInt; FormatEtc : pFormatEtc; clientSite : IOleClientSite; stg : IStorage; var vObj) : hResult;
Function OleCreateLink (mkLinkSrc : IMoniker; const iid : TIID; renderopt : LongInt; FormatEtc : pFormatEtc; clientSite : IOleClientSite; stg : IStorage; var vObj) : hResult;
Function OleCreateLinkToFile (pszFileName : pOleStr; const iid : TIID; renderopt : LongInt; FormatEtc : pFormatEtc; clientSite : IOleClientSite; stg : IStorage; var vObj) : hResult;
Function OleCreateFromFile (const clsid : TCLSID; pszFileName : pOleStr; const iid : TIID; renderopt : LongInt; FormatEtc : pFormatEtc; clientSite : IOleClientSite; stg : IStorage; var vObj) : hResult;
Function OleLoad (stg : IStorage; const iid : TIID; clientSite : IOleClientSite; var vObj) : hResult;
Function OleSave (ps : IPersistStorage; stg : IStorage; fSameAsLoad : BOOL) : hResult;
Function OleLoadFromStream (stm : IStream; const iidInterface : TIID; var vObj) : hResult;
Function OleSaveToStream (pstm : IPersistStream; stm : IStream) : hResult;
Function OleSetContainedObject (unknown : IUnknown; fContained : BOOL) : hResult;
Function OleNoteObjectVisible (unknown : IUnknown; fVisible : BOOL) : hResult;

(* DragDrop APIs *)

Function RegisterDragDrop (wnd : HWnd; dropTarget : IDropTarget) : hResult;
Function RevokeDragDrop (wnd : HWnd) : hResult;
Function DoDragDrop (dataObj : IDataObject; dropSource : IDropSource; dwOKEffects : LongInt; var dwEffect : LongInt) : hResult;

(* Clipboard APIs *)

Function OleSetClipboard (dataObj : IDataObject) : hResult;
Function OleGetClipboard (var dataObj : IDataObject) : hResult;
Function OleFlushClipboard :  hResult;
Function OleIsCurrentClipboard (dataObj : IDataObject) : hResult;

(* In-place editing APIs *)

Function OleCreateMenuDescriptor (hmenuCombined : HMenu; var menuWidths : tOleMenuGroupWidths) : HMenu;
Function OleSetMenuDescriptor (holemenu : HMenu; hwndFrame : HWnd; hwndActiveObject : HWnd; frame : IOleInPlaceFrame; activeObj : IOleInPlaceActiveObject) : hResult;
Function OleDestroyMenuDescriptor (holemenu : HMenu) : hResult;
Function OleTranslateAccelerator (frame : IOleInPlaceFrame; var frameInfo : tOleInPlaceFrameInfo; msg : PMsg) : hResult;

(* OLE helper APIs *)

Function OleDuplicateData (hSrc : THandle; cfFormat : tClipFormat; uiFlags : Integer) : THandle;
Function OleDraw (unknown : IUnknown; dwAspect : LongInt; hdcDraw : HDC; const rcBounds : tRect) : hResult;
Function OleRun (unknown : IUnknown) : hResult;
Function OleIsRunning (obj : IOleObject) : BOOL;
Function OleLockRunning (unknown : IUnknown; fLock : BOOL; fLastUnlockCloses : BOOL) : hResult;
Procedure ReleaseStgMedium (var medium : tStgMedium);
Function CreateOleAdviseHolder (var OAHolder : IOleAdviseHolder) : hResult;
Function OleCreateDefaultHandler (const clsid : TCLSID; unkOuter : IUnknown; const iid : TIID; var vObj) : hResult;
Function OleCreateEmbeddingHelper (const clsid : TCLSID; unkOuter : IUnknown; flags : LongInt; cf : IClassFactory; const iid : TIID; var vObj) : hResult;
Function IsAccelerator (accel : HAccel; cAccelEntries : Integer; msg : PMsg; var pwCmd : Word) : BOOL;

(* Icon extraction helper APIs *)

Function OleGetIconOfFile (pszPath : pOleStr; fUseFileAsLabel : BOOL) : HGlobal;
Function OleGetIconOfClass (const clsid : TCLSID; pszLabel : pOleStr; fUseTypeAsLabel : BOOL) : HGlobal;
Function OleMetafilePictFromIconAndLabel (icon : HIcon; pszLabel : pOleStr; pszSourceFile : pOleStr; iIconIndex : Integer) : HGlobal;

(* Registration database helper APIs *)

Function OleRegGetUserType (const clsid : TCLSID; dwFormOfType : LongInt; var pszUserType : pOleStr) : hResult;
Function OleRegGetMiscStatus (const clsid : TCLSID; dwAspect : LongInt; var dwStatus : LongInt) : hResult;
Function OleRegEnumFormatEtc (const clsid : TCLSID; dwDirection : LongInt; var Enum : IEnumFormatEtc) : hResult;
Function OleRegEnumVerbs (const clsid : TCLSID; var Enum : IEnumOleVerb) : hResult;

(* OLE 1.0 conversion APIs *)

Function OleConvertIStorageToOLESTREAM (stg : IStorage; polestm : Pointer) : hResult;
Function OleConvertOLESTREAMToIStorage (polestm : Pointer; stg : IStorage; td : pDVTargetDevice) : hResult;
Function OleConvertIStorageToOLESTREAMEx (stg : IStorage; cfFormat : tClipFormat; lWidth : LongInt; lHeight : LongInt; dwSize : LongInt; var medium : tStgMedium; polestm : Pointer) : hResult;
Function OleConvertOLESTREAMToIStorageEx (polestm : Pointer; stg : IStorage; var cfFormat : tClipFormat; var lWidth : LongInt; var lHeight : LongInt; var dwSize : LongInt; var Medium : tStgMedium) : hResult;

(* Storage utility APIs *)

Function GetHGlobalFromILockBytes (lkbyt : ILockBytes; var hglob : HGlobal) : hResult;
Function CreateILockBytesOnHGlobal (hglob : HGlobal; fDeleteOnRelease : BOOL; var lkbyt : ILockBytes) : hResult;
Function GetHGlobalFromStream (stm : IStream; var hglob : HGlobal) : hResult;
Function CreateStreamOnHGlobal (hglob : HGlobal; fDeleteOnRelease : BOOL; var stm : IStream) : hResult;

(* ConvertTo APIs *)

Function OleDoAutoConvert (stg : IStorage; var clsidNew : TCLSID) : hResult;
Function OleGetAutoConvert (const clsidOld : TCLSID; var clsidNew : TCLSID) : hResult;
Function OleSetAutoConvert (const clsidOld : TCLSID; const clsidNew : TCLSID) : hResult;
Function GetConvertStg (stg : IStorage) : hResult;
Function SetConvertStg (stg : IStorage; fConvert : BOOL) : hResult;

(* Shell32 functions *)

Function SHGetMalloc (ppMalloc : ppIMalloc) : hResult;
Function SHGetPathFromIDList (pidl : pItemIDList; pszPath : pChar) : BOOL;
Function SHGetPathFromIDListA (pidl : pItemIDList; pszPath : pAnsiChar) : BOOL;
Function SHGetPathFromIDListW (pidl : pItemIDList; pszPath : pWideChar) : BOOL;
Function SHGetSpecialFolderLocation (hwndOwner : HWnd; nFolder : Integer; var ppidl : pItemIDList) : hResult;
Function SHGetSpecialFolderPath (hwndOwner : HWnd; lpszPath : pChar; nFolder : Integer; fCreate : BOOL) : BOOL;
Function SHGetSpecialFolderPathA (hwndOwner : HWnd; lpszPath : pAnsiChar; nFolder : Integer; fCreate : BOOL) : BOOL;
Function SHGetSpecialFolderPathW (hwndOwner : HWnd; lpszPath : pWideChar; nFolder : Integer; fCreate : BOOL) : BOOL;
Function SHBrowseForFolder (lpbi : pBrowseInfo) : pItemIDList;
Function SHBrowseForFolderA (lpbi : pBrowseInfoA) : pItemIDList;
Function SHBrowseForFolderW (lpbi : pBrowseInfoW) : pItemIDList;
Function SHLoadInProc (rclsid : TCLSID) : hResult;
Function SHGetDesktopFolder (ppshf : pIShellFolder) : hResult;
Procedure SHChangeNotify (wEventId : LongInt; uFlags : UINT; dwItem1, dwItem2 : Pointer);
Procedure SHAddToRecentDocs (uFlags : UINT; pv : Pointer);
Function SHGetInstanceExplorer (var ppUnk : IUnknown) : hResult;
Function SHGetDataFromIDList (psf : IShellFolder; pidl : pItemIDList; nFormat : Integer; ptr : Pointer; cb : Integer) : hResult;   // Tested
Function SHGetDataFromIDListA (psf : IShellFolder; pidl : pItemIDList; nFormat : Integer; ptr : Pointer; cb : Integer) : hResult;
Function SHGetDataFromIDListW (psf : IShellFolder; pidl : pItemIDList; nFormat : Integer; ptr : Pointer; cb : Integer) : hResult;
Procedure SHGetSettings (var lpss : tShellFlagState; dwMask : DWord);
Function SoftwareUpdateMessageBox (HWnd : HWnd; szDistUnit : pWideChar; dwFlags : DWord; var psdi : tSoftDistInfo) : DWord;

{&StdCall-}


(* ========================================================================================================================= *)
                                                          Implementation
(* ========================================================================================================================= *)

Function IsEqualGUID;                           external 'ole32'       name 'IsEqualGUID';
Function IsEqualIID;                            external 'ole32'       name 'IsEqualGUID';
Function IsEqualCLSID;                          external 'ole32'       name 'IsEqualGUID';
Function CoBuildVersion;                        external 'ole32'       name 'CoBuildVersion';
Function CoInitialize;                          external 'ole32'       name 'CoInitialize';
Procedure CoUninitialize;                       external 'ole32'       name 'CoUninitialize';
Function CoGetMalloc;                           external 'ole32'       name 'CoGetMalloc';
Function CoGetCurrentProcess;                   external 'ole32'       name 'CoGetCurrentProcess';
Function CoRegisterMallocSpy;                   external 'ole32'       name 'CoRegisterMallocSpy';
Function CoRevokeMallocSpy;                     external 'ole32'       name 'CoRevokeMallocSpy';
Function CoCreateStandardMalloc;                external 'ole32'       name 'CoCreateStandardMalloc';
Function CoGetClassObject;                      external 'ole32'       name 'CoGetClassObject';
Function CoRegisterClassObject;                 external 'ole32'       name 'CoRegisterClassObject';
Function CoRevokeClassObject;                   external 'ole32'       name 'CoRevokeClassObject';
Function CoGetMarshalSizeMax;                   external 'ole32'       name 'CoGetMarshalSizeMax';
Function CoMarshalInterface;                    external 'ole32'       name 'CoMarshalInterface';
Function CoUnmarshalInterface;                  external 'ole32'       name 'CoUnmarshalInterface';
Function CoMarshalhResult;                      external 'ole32'       name 'CoMarshalhResult';
Function CoUnmarshalhResult;                    external 'ole32'       name 'CoUnmarshalhResult';
Function CoReleaseMarshalData;                  external 'ole32'       name 'CoReleaseMarshalData';
Function CoDisconnectObject;                    external 'ole32'       name 'CoDisconnectObject';
Function CoLockObjectExternal;                  external 'ole32'       name 'CoLockObjectExternal';
Function CoGetStandardMarshal;                  external 'ole32'       name 'CoGetStandardMarshal';
Function CoIsHandlerConnected;                  external 'ole32'       name 'CoIsHandlerConnected';
Function CoHasStrongExternalConnections;        external 'ole32'       name 'CoHasStrongExternalConnections';
Function CoMarshalInterThreadInterfaceInStream; external 'ole32'       name 'CoMarshalInterThreadInterfaceInStream';
Function CoGetInterfaceAndReleaseStream;        external 'ole32'       name 'CoGetInterfaceAndReleaseStream';
Function CoCreateFreeThreadedMarshaler;         external 'ole32'       name 'CoCreateFreeThreadedMarshaler';
Function CoLoadLibrary;                         external 'ole32'       name 'CoLoadLibrary';
Procedure CoFreeLibrary;                        external 'ole32'       name 'CoFreeLibrary';
Procedure CoFreeAllLibraries;                   external 'ole32'       name 'CoFreeAllLibraries';
Procedure CoFreeUnusedLibraries;                external 'ole32'       name 'CoFreeUnusedLibraries';
Function CoCreateInstance;                      external 'ole32'       name 'CoCreateInstance';
Function StringFromCLSID;                       external 'ole32'       name 'StringFromCLSID';
Function CLSIDFromString;                       external 'ole32'       name 'CLSIDFromString';
Function StringFromIID;                         external 'ole32'       name 'StringFromIID';
Function IIDFromString;                         external 'ole32'       name 'IIDFromString';
Function CoIsOle1Class;                         external 'ole32'       name 'CoIsOle1Class';
Function ProgIDFromCLSID;                       external 'ole32'       name 'ProgIDFromCLSID';
Function CLSIDFromProgID;                       external 'ole32'       name 'CLSIDFromProgID';
Function StringFromGUID2;                       external 'ole32'       name 'StringFromGUID2';
Function CoCreateGuid;                          external 'ole32'       name 'CoCreateGuid';
Function CoFileTimeToDosDateTime;               external 'ole32'       name 'CoFileTimeToDosDateTime';
Function CoDosDateTimeToFileTime;               external 'ole32'       name 'CoDosDateTimeToFileTime';
Function CoFileTimeNow;                         external 'ole32'       name 'CoFileTimeNow';
Function CoRegisterMessageFilter;               external 'ole32'       name 'CoRegisterMessageFilter';
Function CoGetTreatAsClass;                     external 'ole32'       name 'CoGetTreatAsClass';
Function CoTreatAsClass;                        external 'ole32'       name 'CoTreatAsClass';
Function CoTaskMemAlloc;                        external 'ole32'       name 'CoTaskMemAlloc';
Function CoTaskMemRealloc;                      external 'ole32'       name 'CoTaskMemRealloc';
Procedure CoTaskMemFree;                        external 'ole32'       name 'CoTaskMemFree';
Function CreateDataAdviseHolder;                external 'ole32'       name 'CreateDataAdviseHolder';
Function CreateDataCache;                       external 'ole32'       name 'CreateDataCache';
Function StgCreateDocfile;                      external 'ole32'       name 'StgCreateDocfile';
Function StgCreateDocfileOnILockBytes;          external 'ole32'       name 'StgCreateDocfileOnILockBytes';
Function StgOpenStorage;                        external 'ole32'       name 'StgOpenStorage';
Function StgOpenStorageOnILockBytes;            external 'ole32'       name 'StgOpenStorageOnILockBytes';
Function StgIsStorageFile;                      external 'ole32'       name 'StgIsStorageFile';
Function StgIsStorageILockBytes;                external 'ole32'       name 'StgIsStorageILockBytes';
Function StgSetTimes;                           external 'ole32'       name 'StgSetTimes';
Function BindMoniker;                           external 'ole32'       name 'BindMoniker';
Function MkParseDisplayName;                    external 'ole32'       name 'MkParseDisplayName';
Function MonikerRelativePathTo;                 external 'ole32'       name 'MonikerRelativePathTo';
Function MonikerCommonPrefixWith;               external 'ole32'       name 'MonikerCommonPrefixWith';
Function CreateBindCtx;                         external 'ole32'       name 'CreateBindCtx';
Function CreateGenericComposite;                external 'ole32'       name 'CreateGenericComposite';
Function GetClassFile;                          external 'ole32'       name 'GetClassFile';
Function CreateFileMoniker;                     external 'ole32'       name 'CreateFileMoniker';
Function CreateItemMoniker;                     external 'ole32'       name 'CreateItemMoniker';
Function CreateAntiMoniker;                     external 'ole32'       name 'CreateAntiMoniker';
Function CreatePointerMoniker;                  external 'ole32'       name 'CreatePointerMoniker';
Function GetRunningObjectTable;                 external 'ole32'       name 'GetRunningObjectTable';
Function OleBuildVersion;                       external 'ole32'       name 'OleBuildVersion';
Function ReadClassStg;                          external 'ole32'       name 'ReadClassStg';
Function WriteClassStg;                         external 'ole32'       name 'WriteClassStg';
Function ReadClassStm;                          external 'ole32'       name 'ReadClassStm';
Function WriteClassStm;                         external 'ole32'       name 'WriteClassStm';
Function WriteFmtUserTypeStg;                   external 'ole32'       name 'WriteFmtUserTypeStg';
Function ReadFmtUserTypeStg;                    external 'ole32'       name 'ReadFmtUserTypeStg';
Function OleInitialize;                         external 'ole32'       name 'OleInitialize';
Procedure OleUninitialize;                      external 'ole32'       name 'OleUninitialize';
Function OleQueryLinkFromData;                  external 'ole32'       name 'OleQueryLinkFromData';
Function OleQueryCreateFromData;                external 'ole32'       name 'OleQueryCreateFromData';
Function OleCreate;                             external 'ole32'       name 'OleCreate';
Function OleCreateFromData;                     external 'ole32'       name 'OleCreateFromData';
Function OleCreateLinkFromData;                 external 'ole32'       name 'OleCreateLinkFromData';
Function OleCreateStaticFromData;               external 'ole32'       name 'OleCreateStaticFromData';
Function OleCreateLink;                         external 'ole32'       name 'OleCreateLink';
Function OleCreateLinkToFile;                   external 'ole32'       name 'OleCreateLinkToFile';
Function OleCreateFromFile;                     external 'ole32'       name 'OleCreateFromFile';
Function OleLoad;                               external 'ole32'       name 'OleLoad';
Function OleSave;                               external 'ole32'       name 'OleSave';
Function OleLoadFromStream;                     external 'ole32'       name 'OleLoadFromStream';
Function OleSaveToStream;                       external 'ole32'       name 'OleSaveToStream';
Function OleSetContainedObject;                 external 'ole32'       name 'OleSetContainedObject';
Function OleNoteObjectVisible;                  external 'ole32'       name 'OleNoteObjectVisible';
Function RegisterDragDrop;                      external 'ole32'       name 'RegisterDragDrop';
Function RevokeDragDrop;                        external 'ole32'       name 'RevokeDragDrop';
Function DoDragDrop;                            external 'ole32'       name 'DoDragDrop';
Function OleSetClipboard;                       external 'ole32'       name 'OleSetClipboard';
Function OleGetClipboard;                       external 'ole32'       name 'OleGetClipboard';
Function OleFlushClipboard;                     external 'ole32'       name 'OleFlushClipboard';
Function OleIsCurrentClipboard;                 external 'ole32'       name 'OleIsCurrentClipboard';
Function OleCreateMenuDescriptor;               external 'ole32'       name 'OleCreateMenuDescriptor';
Function OleSetMenuDescriptor;                  external 'ole32'       name 'OleSetMenuDescriptor';
Function OleDestroyMenuDescriptor;              external 'ole32'       name 'OleDestroyMenuDescriptor';
Function OleTranslateAccelerator;               external 'ole32'       name 'OleTranslateAccelerator';
Function OleDuplicateData;                      external 'ole32'       name 'OleDuplicateData';
Function OleDraw;                               external 'ole32'       name 'OleDraw';
Function OleRun;                                external 'ole32'       name 'OleRun';
Function OleIsRunning;                          external 'ole32'       name 'OleIsRunning';
Function OleLockRunning;                        external 'ole32'       name 'OleLockRunning';
Procedure ReleaseStgMedium;                     external 'ole32'       name 'ReleaseStgMedium';
Function CreateOleAdviseHolder;                 external 'ole32'       name 'CreateOleAdviseHolder';
Function OleCreateDefaultHandler;               external 'ole32'       name 'OleCreateDefaultHandler';
Function OleCreateEmbeddingHelper;              external 'ole32'       name 'OleCreateEmbeddingHelper';
Function IsAccelerator;                         external 'ole32'       name 'IsAccelerator';
Function OleGetIconOfFile;                      external 'ole32'       name 'OleGetIconOfFile';
Function OleGetIconOfClass;                     external 'ole32'       name 'OleGetIconOfClass';
Function OleMetafilePictFromIconAndLabel;       external 'ole32'       name 'OleMetafilePictFromIconAndLabel';
Function OleRegGetUserType;                     external 'ole32'       name 'OleRegGetUserType';
Function OleRegGetMiscStatus;                   external 'ole32'       name 'OleRegGetMiscStatus';
Function OleRegEnumFormatEtc;                   external 'ole32'       name 'OleRegEnumFormatEtc';
Function OleRegEnumVerbs;                       external 'ole32'       name 'OleRegEnumVerbs';
Function OleConvertIStorageToOLESTREAM;         external 'ole32'       name 'OleConvertIStorageToOLESTREAM';
Function OleConvertOLESTREAMToIStorage;         external 'ole32'       name 'OleConvertOLESTREAMToIStorage';
Function OleConvertIStorageToOLESTREAMEx;       external 'ole32'       name 'OleConvertIStorageToOLESTREAMEx';
Function OleConvertOLESTREAMToIStorageEx;       external 'ole32'       name 'OleConvertOLESTREAMToIStorageEx';
Function GetHGlobalFromILockBytes;              external 'ole32'       name 'GetHGlobalFromILockBytes';
Function CreateILockBytesOnHGlobal;             external 'ole32'       name 'CreateILockBytesOnHGlobal';
Function GetHGlobalFromStream;                  external 'ole32'       name 'GetHGlobalFromStream';
Function CreateStreamOnHGlobal;                 external 'ole32'       name 'CreateStreamOnHGlobal';
Function OleDoAutoConvert;                      external 'ole32'       name 'OleDoAutoConvert';
Function OleGetAutoConvert;                     external 'ole32'       name 'OleGetAutoConvert';
Function OleSetAutoConvert;                     external 'ole32'       name 'OleSetAutoConvert';
Function GetConvertStg;                         external 'ole32'       name 'GetConvertStg';
Function SetConvertStg;                         external 'ole32'       name 'SetConvertStg';

Function SysAllocString;                        external 'oleaut32'    name 'SysAllocString';
Function SysReAllocString;                      external 'oleaut32'    name 'SysReAllocString';
Function SysAllocStringLen;                     external 'oleaut32'    name 'SysAllocStringLen';
Function SysReAllocStringLen;                   external 'oleaut32'    name 'SysReAllocStringLen';
Procedure SysFreeString;                        external 'oleaut32'    name 'SysFreeString';
Function SysStringLen;                          external 'oleaut32'    name 'SysStringLen';
Function SysStringByteLen;                      external 'oleaut32'    name 'SysStringByteLen';
Function SysAllocStringByteLen;                 external 'oleaut32'    name 'SysAllocStringByteLen';
Function DosDateTimeToVariantTime;              external 'oleaut32'    name 'DosDateTimeToVariantTime';
Function VariantTimeToDosDateTime;              external 'oleaut32'    name 'VariantTimeToDosDateTime';
Function SafeArrayAllocDescriptor;              external 'oleaut32'    name 'SafeArrayAllocDescriptor';
Function SafeArrayAllocData;                    external 'oleaut32'    name 'SafeArrayAllocData';
Function SafeArrayCreate;                       external 'oleaut32'    name 'SafeArrayCreate';
Function SafeArrayDestroyDescriptor;            external 'oleaut32'    name 'SafeArrayDestroyDescriptor';
Function SafeArrayDestroyData;                  external 'oleaut32'    name 'SafeArrayDestroyData';
Function SafeArrayDestroy;                      external 'oleaut32'    name 'SafeArrayDestroy';
Function SafeArrayRedim;                        external 'oleaut32'    name 'SafeArrayRedim';
Function SafeArrayGetDim;                       external 'oleaut32'    name 'SafeArrayGetDim';
Function SafeArrayGetElemsize;                  external 'oleaut32'    name 'SafeArrayGetElemsize';
Function SafeArrayGetUBound;                    external 'oleaut32'    name 'SafeArrayGetUBound';
Function SafeArrayGetLBound;                    external 'oleaut32'    name 'SafeArrayGetLBound';
Function SafeArrayLock;                         external 'oleaut32'    name 'SafeArrayLock';
Function SafeArrayUnlock;                       external 'oleaut32'    name 'SafeArrayUnlock';
Function SafeArrayAccessData;                   external 'oleaut32'    name 'SafeArrayAccessData';
Function SafeArrayUnaccessData;                 external 'oleaut32'    name 'SafeArrayUnaccessData';
Function SafeArrayGetElement;                   external 'oleaut32'    name 'SafeArrayGetElement';
Function SafeArrayPutElement;                   external 'oleaut32'    name 'SafeArrayPutElement';
Function SafeArrayCopy;                         external 'oleaut32'    name 'SafeArrayCopy';
Function SafeArrayPtrOfIndex;                   external 'oleaut32'    name 'SafeArrayPtrOfIndex';
Procedure VariantInit;                          external 'oleaut32'    name 'VariantInit';
Function VariantClear;                          external 'oleaut32'    name 'VariantClear';
Function VariantCopy;                           external 'oleaut32'    name 'VariantCopy';
Function VariantCopyInd;                        external 'oleaut32'    name 'VariantCopyInd';
Function VariantChangeType;                     external 'oleaut32'    name 'VariantChangeType';
Function VariantChangeTypeEx;                   external 'oleaut32'    name 'VariantChangeTypeEx';
Function VarUI1FromI2;                          external 'oleaut32'    name 'VarUI1FromI2';
Function VarUI1FromI4;                          external 'oleaut32'    name 'VarUI1FromI4';
Function VarUI1FromR4;                          external 'oleaut32'    name 'VarUI1FromR4';
Function VarUI1FromR8;                          external 'oleaut32'    name 'VarUI1FromR8';
Function VarUI1FromCy;                          external 'oleaut32'    name 'VarUI1FromCy';
Function VarUI1FromDate;                        external 'oleaut32'    name 'VarUI1FromDate';
Function VarUI1FromStr;                         external 'oleaut32'    name 'VarUI1FromStr';
Function VarUI1FromDisp;                        external 'oleaut32'    name 'VarUI1FromDisp';
Function VarUI1FromBool;                        external 'oleaut32'    name 'VarUI1FromBool';
Function VarI2FromUI1;                          external 'oleaut32'    name 'VarI2FromUI1';
Function VarI2FromI4;                           external 'oleaut32'    name 'VarI2FromI4';
Function VarI2FromR4;                           external 'oleaut32'    name 'VarI2FromR4';
Function VarI2FromR8;                           external 'oleaut32'    name 'VarI2FromR8';
Function VarI2FromCy;                           external 'oleaut32'    name 'VarI2FromCy';
Function VarI2FromDate;                         external 'oleaut32'    name 'VarI2FromDate';
Function VarI2FromStr;                          external 'oleaut32'    name 'VarI2FromStr';
Function VarI2FromDisp;                         external 'oleaut32'    name 'VarI2FromDisp';
Function VarI2FromBool;                         external 'oleaut32'    name 'VarI2FromBool';
Function VarI4FromUI1;                          external 'oleaut32'    name 'VarI4FromUI1';
Function VarI4FromI2;                           external 'oleaut32'    name 'VarI4FromI2';
Function VarI4FromR4;                           external 'oleaut32'    name 'VarI4FromR4';
Function VarI4FromR8;                           external 'oleaut32'    name 'VarI4FromR8';
Function VarI4FromCy;                           external 'oleaut32'    name 'VarI4FromCy';
Function VarI4FromDate;                         external 'oleaut32'    name 'VarI4FromDate';
Function VarI4FromStr;                          external 'oleaut32'    name 'VarI4FromStr';
Function VarI4FromDisp;                         external 'oleaut32'    name 'VarI4FromDisp';
Function VarI4FromBool;                         external 'oleaut32'    name 'VarI4FromBool';
Function VarR4FromUI1;                          external 'oleaut32'    name 'VarR4FromUI1';
Function VarR4FromI2;                           external 'oleaut32'    name 'VarR4FromI2';
Function VarR4FromI4;                           external 'oleaut32'    name 'VarR4FromI4';
Function VarR4FromR8;                           external 'oleaut32'    name 'VarR4FromR8';
Function VarR4FromCy;                           external 'oleaut32'    name 'VarR4FromCy';
Function VarR4FromDate;                         external 'oleaut32'    name 'VarR4FromDate';
Function VarR4FromStr;                          external 'oleaut32'    name 'VarR4FromStr';
Function VarR4FromDisp;                         external 'oleaut32'    name 'VarR4FromDisp';
Function VarR4FromBool;                         external 'oleaut32'    name 'VarR4FromBool';
Function VarR8FromUI1;                          external 'oleaut32'    name 'VarR8FromUI1';
Function VarR8FromI2;                           external 'oleaut32'    name 'VarR8FromI2';
Function VarR8FromI4;                           external 'oleaut32'    name 'VarR8FromI4';
Function VarR8FromR4;                           external 'oleaut32'    name 'VarR8FromR4';
Function VarR8FromCy;                           external 'oleaut32'    name 'VarR8FromCy';
Function VarR8FromDate;                         external 'oleaut32'    name 'VarR8FromDate';
Function VarR8FromStr;                          external 'oleaut32'    name 'VarR8FromStr';
Function VarR8FromDisp;                         external 'oleaut32'    name 'VarR8FromDisp';
Function VarR8FromBool;                         external 'oleaut32'    name 'VarR8FromBool';
Function VarDateFromUI1;                        external 'oleaut32'    name 'VarDateFromUI1';
Function VarDateFromI2;                         external 'oleaut32'    name 'VarDateFromI2';
Function VarDateFromI4;                         external 'oleaut32'    name 'VarDateFromI4';
Function VarDateFromR4;                         external 'oleaut32'    name 'VarDateFromR4';
Function VarDateFromR8;                         external 'oleaut32'    name 'VarDateFromR8';
Function VarDateFromCy;                         external 'oleaut32'    name 'VarDateFromCy';
Function VarDateFromStr;                        external 'oleaut32'    name 'VarDateFromStr';
Function VarDateFromDisp;                       external 'oleaut32'    name 'VarDateFromDisp';
Function VarDateFromBool;                       external 'oleaut32'    name 'VarDateFromBool';
Function VarCyFromUI1;                          external 'oleaut32'    name 'VarCyFromUI1';
Function VarCyFromI2;                           external 'oleaut32'    name 'VarCyFromI2';
Function VarCyFromI4;                           external 'oleaut32'    name 'VarCyFromI4';
Function VarCyFromR4;                           external 'oleaut32'    name 'VarCyFromR4';
Function VarCyFromR8;                           external 'oleaut32'    name 'VarCyFromR8';
Function VarCyFromDate;                         external 'oleaut32'    name 'VarCyFromDate';
Function VarCyFromStr;                          external 'oleaut32'    name 'VarCyFromStr';
Function VarCyFromDisp;                         external 'oleaut32'    name 'VarCyFromDisp';
Function VarCyFromBool;                         external 'oleaut32'    name 'VarCyFromBool';
Function VarBStrFromUI1;                        external 'oleaut32'    name 'VarBStrFromUI1';
Function VarBStrFromI2;                         external 'oleaut32'    name 'VarBStrFromI2';
Function VarBStrFromI4;                         external 'oleaut32'    name 'VarBStrFromI4';
Function VarBStrFromR4;                         external 'oleaut32'    name 'VarBStrFromR4';
Function VarBStrFromR8;                         external 'oleaut32'    name 'VarBStrFromR8';
Function VarBStrFromCy;                         external 'oleaut32'    name 'VarBStrFromCy';
Function VarBStrFromDate;                       external 'oleaut32'    name 'VarBStrFromDate';
Function VarBStrFromDisp;                       external 'oleaut32'    name 'VarBStrFromDisp';
Function VarBStrFromBool;                       external 'oleaut32'    name 'VarBStrFromBool';
Function VarBoolFromUI1;                        external 'oleaut32'    name 'VarBoolFromUI1';
Function VarBoolFromI2;                         external 'oleaut32'    name 'VarBoolFromI2';
Function VarBoolFromI4;                         external 'oleaut32'    name 'VarBoolFromI4';
Function VarBoolFromR4;                         external 'oleaut32'    name 'VarBoolFromR4';
Function VarBoolFromR8;                         external 'oleaut32'    name 'VarBoolFromR8';
Function VarBoolFromDate;                       external 'oleaut32'    name 'VarBoolFromDate';
Function VarBoolFromCy;                         external 'oleaut32'    name 'VarBoolFromCy';
Function VarBoolFromStr;                        external 'oleaut32'    name 'VarBoolFromStr';
Function VarBoolFromDisp;                       external 'oleaut32'    name 'VarBoolFromDisp';
Function LHashValOfNameSys;                     external 'oleaut32'    name 'LHashValOfNameSys';
Function LHashValOfNameSysA;                    external 'oleaut32'    name 'LHashValOfNameSysA';
Function LoadTypeLib;                           external 'oleaut32'    name 'LoadTypeLib';
Function LoadRegTypeLib;                        external 'oleaut32'    name 'LoadRegTypeLib';
Function QueryPathOfRegTypeLib;                 external 'oleaut32'    name 'QueryPathOfRegTypeLib';
Function RegisterTypeLib;                       external 'oleaut32'    name 'RegisterTypeLib';
Function CreateTypeLib;                         external 'oleaut32'    name 'CreateTypeLib';
Function DispGetParam;                          external 'oleaut32'    name 'DispGetParam';
Function DispGetIDsOfNames;                     external 'oleaut32'    name 'DispGetIDsOfNames';
Function DispInvoke;                            external 'oleaut32'    name 'DispInvoke';
Function CreateDispTypeInfo;                    external 'oleaut32'    name 'CreateDispTypeInfo';
Function CreateStdDispatch;                     external 'oleaut32'    name 'CreateStdDispatch';
Function RegisterActiveObject;                  external 'oleaut32'    name 'RegisterActiveObject';
Function RevokeActiveObject;                    external 'oleaut32'    name 'RevokeActiveObject';
Function GetActiveObject;                       external 'oleaut32'    name 'GetActiveObject';
Function SetErrorInfo;                          external 'oleaut32'    name 'SetErrorInfo';
Function GetErrorInfo;                          external 'oleaut32'    name 'GetErrorInfo';
Function CreateErrorInfo;                       external 'oleaut32'    name 'CreateErrorInfo';
Function OaBuildVersion;                        external 'oleaut32'    name 'OaBuildVersion';

Procedure SHAddToRecentDocs;                    external 'shell32.dll' name 'SHAddToRecentDocs';
Function SHBrowseForFolder;                     external 'shell32.dll' name 'SHBrowseForFolderA';
Function SHBrowseForFolderA;                    external 'shell32.dll' name 'SHBrowseForFolderA';
Function SHBrowseForFolderW;                    external 'shell32.dll' name 'SHBrowseForFolderW';
Procedure SHChangeNotify;                       external 'shell32.dll' name 'SHChangeNotify';
Function SHGetDataFromIDList;                   external 'shell32.dll' name 'SHGetDataFromIDListA';
Function SHGetDataFromIDListA;                  external 'shell32.dll' name 'SHGetDataFromIDListA';
Function SHGetDataFromIDListW;                  external 'shell32.dll' name 'SHGetDataFromIDListW';
Function SHGetDesktopFolder;                    external 'shell32.dll' name 'SHGetDesktopFolder';
Function SHGetInstanceExplorer;                 external 'shell32.dll' name 'SHGetInstanceExplorer';
Function SHGetMalloc;                           external 'shell32.dll' name 'SHGetMalloc';
Function SHGetPathFromIDList;                   external 'shell32.dll' name 'SHGetPathFromIDListA';
Function SHGetPathFromIDListA;                  external 'shell32.dll' name 'SHGetPathFromIDListA';
Function SHGetPathFromIDListW;                  external 'shell32.dll' name 'SHGetPathFromIDListW';
Function SHGetSpecialFolderLocation;            external 'shell32.dll' name 'SHGetSpecialFolderLocation';
Function SHLoadInProc;                          external 'shell32.dll' name 'SHLoadInProc';
Function SHGetSpecialFolderPath;                external 'shell32.dll' name 'SHGetSpecialFolderPathA';
Function SHGetSpecialFolderPathA;               external 'shell32.dll' name 'SHGetSpecialFolderPathA';
Function SHGetSpecialFolderPathW;               external 'shell32.dll' name 'SHGetSpecialFolderPathW';
Procedure SHGetSettings;                        external 'shell32.dll' name 'SHGetSettings';
Function SoftwareUpdateMessageBox;              external 'shell32.dll' name 'SoftwareUpdateMessageBox';

(* Macros *)

Function Succeeded (Res : hResult) : Boolean;
Begin
  Result := Res and $80000000 = 0;
End;

Function Failed (Res : hResult) : Boolean;
Begin
  Result := Res and $80000000 <> 0;
End;

Function ResultCode (Res : hResult) : Integer;
Begin
  Result := Res and $0000FFFF;
End;

Function ResultFacility (Res : hResult) : Integer;
Begin
  Result := (Res shr 16) and $00001FFF;
End;

Function ResultSeverity (Res : hResult) : Integer;
Begin
  Result := Res shr 31;
End;

Function MakeResult (Severity, Facility, Code : Integer) : hResult;
Begin
  Result := (Severity shl 31) or (Facility shl 16) or Code;
End;

Function LHashValOfName (lcid : tLCID; szName : pOleStr) : LongInt;
Begin
  Result := LHashValOfNameSys(SYS_WIN32, lcid, szName);
End;

Function WHashValOfLHashVal (lhashval : LongInt) : Word;
Begin
  Result := lhashval and $0000FFFF;
End;

Function IsHashValCompatible (lhashval1, lhashval2 : LongInt) : Boolean;
Begin
  Result := lhashval1 and $00FF0000 = lhashval2 and $00FF0000;
End;



(* ========================================================================================================================= *)
(*                                                        Initializations                                                    *)
(* ========================================================================================================================= *)

Begin
End.

